using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.user
{
  /// <author>SudhaS</author>
  public interface IUserModelRO : IObjEditorModelRO
  {
    
    /// <returns></returns>
    bool GetCheckBox();
    
    /// <returns></returns>
    String GetLoginName();
    
    /// <returns></returns>
    String GetPassword();
    
    /// <returns></returns>
    String GetConfirmPassword();
    
    /// <returns></returns>
    bool EditingInDefaultProfilesFolder();
    
    /// <summary>
    /// Returns true if the User Type of the user is guest.
    /// </summary>
    /// <returns></returns>
    bool EditingGuestUser();
    
    /// <summary>
    /// Return true if the user is locked.
    /// </summary>
    /// <returns></returns>
    bool EditingLockedAccount();
    String GetUserMobileName();
    String GetUserMobilePsswrd();
    bool IsPlumtreeAuthSource();
    bool IsCurrentUserAdministrator();
    
    /// <summary>
    /// Returns whether the guest account type is editable.
    /// </summary>
    /// <returns></returns>
    bool UserTypeEditable();
    
    /// <summary>
    /// Returns <c>true</c> if the user is tied
    /// to a remote authentication source.  Otherwise,
    /// <c>false</c> is returned.
    /// </summary>
    /// <returns>boolean indicating remote status</returns>
    bool IsRemoteUser();
    
    /// <summary>
    /// Returns the user's auth user name - the name
    /// sent to a remote provider in order to authenticate
    /// the user.
    /// </summary>
    /// <returns>String representing the authentication user name</returns>
    String GetAuthUsername();
    
    /// <summary>
    /// Returns the user's auth unique name - the unique key
    /// sent by a remote provider to identify the user.
    /// </summary>
    /// <returns>String representing the remote unique name</returns>
    String GetUniqueUsername();
  }
}