using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>
  /// adolfoc To change this generated comment edit the template variable
  /// "typecomment": Window>Preferences>Java>Templates. To enable and
  /// disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class AdvSettingsDP : WSPluginDP
  {
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AdvSettingsDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdvSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_ActSecurityPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_XUIURLPluginView);
      return xpWSViews;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1183, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      // Specify the additional settings for this Web Service.
      /* was 1669 --?? */
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1672, "ptmsgs_portaladminmsgs"),
       m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nWSMode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      switch (nWSMode){
      case WebServiceModel.WSMODE_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdvSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_ActSecurityPluginView);
      break;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicHelpSpacePluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicProfilePluginView);
      break;
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_PWS:
      case WebServiceModel.WSMODE_MWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_XUIURLPluginView);
      break;
      case WebServiceModel.WSMODE_CWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdvSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_ActSecurityPluginView);
      break;
      case WebServiceModel.WSMODE_SWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdvSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
      break;
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return xpWSViews;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PORTLET:
      return "PT_WebService_Portlet_Remote_AdvancedSettings";
      goto case WebServiceModel.WSMODE_AWS;
      case WebServiceModel.WSMODE_AWS:
      return "PT_WebService_Authentication_AdvancedSettings";
      goto case WebServiceModel.WSMODE_PWS;
      case WebServiceModel.WSMODE_PWS:
      return "PT_WebService_Profile_AdvancedSettings";
      goto case WebServiceModel.WSMODE_CWS;
      case WebServiceModel.WSMODE_CWS:
      return "PT_WebService_Crawler_AdvancedSettings";
      goto case WebServiceModel.WSMODE_SWS;
      case WebServiceModel.WSMODE_SWS:
      return "PT_WebService_Search_AdvancedSettings";
      goto case WebServiceModel.WSMODE_MWS;
      case WebServiceModel.WSMODE_MWS:
      return "PT_WebService_Migration_AdvancedSettings";
      goto case WebServiceModel.WSMODE_INTRINSIC_PORTLET;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return null;
    }
  }
}