using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>AkashJ</author>
  public class AuthenticationDP : WSPluginDP
  {
    public const String STR_MVC_CLASS_NAME = "AuthenticationDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_BasicAuthPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CredentialVaultPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_FormLoginPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_FormLoginFieldsPluginView);
      return xpWSViews;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nWSMode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      switch (nWSMode){
      case WebServiceModel.WSMODE_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_CredentialVaultPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_BasicAuthPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_FormLoginPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_FormLoginFieldsPluginView);
      break;
      case WebServiceModel.WSMODE_CWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_BasicAuthPluginView);
      // aj TODO - should we show this here??
      //			xpWSViews.Add(
      //					WebServiceEditorAS.strStorage_CredentialVaultPluginView);
      //				xpWSViews.Add(
      //						WebServiceEditorAS.strStorage_FormLoginPluginView);
      //				xpWSViews.Add(
      //						WebServiceEditorAS.strStorage_FormLoginFieldsPluginView);
      break;
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_PWS:
      case WebServiceModel.WSMODE_MWS:
      case WebServiceModel.WSMODE_SWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_BasicAuthPluginView);
      break;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return xpWSViews;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()"></seealso>
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PORTLET:
      return "PT_WebService_RemotePortlet_AuthSettings";
      goto case WebServiceModel.WSMODE_AWS;
      case WebServiceModel.WSMODE_AWS:
      return "PT_WebService_Authentication_AuthSettings";
      goto case WebServiceModel.WSMODE_PWS;
      case WebServiceModel.WSMODE_PWS:
      return "PT_WebService_Profile_AuthSettings";
      goto case WebServiceModel.WSMODE_CWS;
      case WebServiceModel.WSMODE_CWS:
      return "PT_WebService_Crawler_AuthSettings";
      goto case WebServiceModel.WSMODE_SWS;
      case WebServiceModel.WSMODE_SWS:
      return "PT_WebService_Search_AuthSettings";
      goto case WebServiceModel.WSMODE_MWS;
      case WebServiceModel.WSMODE_MWS:
      return "PT_WebService_Migration_AuthSettings";
      goto case WebServiceModel.WSMODE_INTRINSIC_PORTLET;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return null;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu, linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(2921, ResourceConstants.PORTALADMINMSGS));
      }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2924, ResourceConstants.PORTALADMINMSGS),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}