using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>adolfoc</author>
  public class PrefsDP : WSPluginDP
  {
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "WebServicePrefsDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdminPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_UserPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_UserPrefsListPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CommunityPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CommunityPrefsListPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicAdminPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicUserPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicCommunityPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SessionPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SessionPrefsListPluginView);
      return xpWSViews;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1190, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nWSMode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      switch (nWSMode){
      case WebServiceModel.WSMODE_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_AdminPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_UserPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_UserPrefsListPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CommunityPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CommunityPrefsListPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SessionPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SessionPrefsListPluginView);
      break;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicAdminPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicUserPrefsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicCommunityPrefsPluginView);
      break;
      case WebServiceModel.WSMODE_CWS:
      case WebServiceModel.WSMODE_SWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_UserPrefsListPluginView);
      break;
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_PWS:
      case WebServiceModel.WSMODE_MWS:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return xpWSViews;
    }
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      // Specify the additional settings for this Web Service.
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1672, "ptmsgs_portaladminmsgs"),
       m_asOwner);
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PORTLET:
      return "PT_WebService_Portlet_Remote_Preferences";
      goto case WebServiceModel.WSMODE_INTRINSIC_PORTLET;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      return "PT_WebService_Portlet_Intrinsic_Preferences";
      goto case WebServiceModel.WSMODE_CWS;
      case WebServiceModel.WSMODE_CWS:
      return "PT_WebService_Crawler_Preferences";
      goto case WebServiceModel.WSMODE_SWS;
      case WebServiceModel.WSMODE_SWS:
      return "PT_WebService_Search_Preferences";
      goto case WebServiceModel.WSMODE_AWS;
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_PWS:
      case WebServiceModel.WSMODE_MWS:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return null;
    }
  }
}