using System;
// Framework imports
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class WSDependenciesView : ObjDependenciesView
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "WSDependencies";
    // <0 use default, 0 none, >0 use specified 
    public const int OFFSET = -1;
    // <0 use default, 0 none, >0 use specified
    public const int BREAK = -1;
    private CreatedHelper m_chHelper = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new WSDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (WebServiceModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      m_chHelper.displayEmptyRow(result);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(1942, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1941,
       "ptmsgs_portaladminmsgs"), ((ObjEditorModel) m_model).GetObjectName());
      m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1943,
       "ptmsgs_portaladminmsgs"), ((ObjEditorModel) m_model).GetParentFolderPath(),
       BREAK);
      int nFolderID = ((ObjEditorModel) m_model).GetFolderID();
      String strArg = "&" + XUIHelperMethods.QS_XUI_WEBSERVICE_ID + "=" + ((WebServiceModel) m_model).GetObjectID();
      strArg+="&" + PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_CLASSID + "=" + PT_CLASSIDS.PT_WEBSERVICE_ID;
      strArg+="&" + PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_ID + "=" + ((WebServiceModel) m_model).GetObjectID();
      switch (((WebServiceModel) m_model).GetWSMode()){
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      m_chHelper.displayEmptyRow(result);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.beginList(result);
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PORTLETS))
      {
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_GADGET_ID,
         WSModelHelper.WSTYPE_IGP, nFolderID, m_asOwner.GetString(1947, "ptmsgs_portaladminmsgs"),
         m_asOwner, strArg, true));
      }
      m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_GADGETTEMPLATE_ID,
       WSModelHelper.WSTYPE_IGP, nFolderID, m_asOwner.GetString(1949, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      break;
      case WebServiceModel.WSMODE_AWS:
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_AUTHSOURCES))
      {
        m_chHelper.displayEmptyRow(result);
        m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_AUTHSOURCE_ID,
         WSModelHelper.WSTYPE_AWS, nFolderID, m_asOwner.GetString(1945, "ptmsgs_portaladminmsgs"),
         m_asOwner, strArg, true));
      }
      break;
      case WebServiceModel.WSMODE_CWS:
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_CRAWLERS))
      {
        m_chHelper.displayEmptyRow(result);
        m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_DATASOURCE_ID,
         WSModelHelper.WSTYPE_CWS, nFolderID, m_asOwner.GetString(1950, "ptmsgs_portaladminmsgs"),
         m_asOwner, strArg, true));
      }
      break;
      case WebServiceModel.WSMODE_PORTLET:
      m_chHelper.displayEmptyRow(result);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.beginList(result);
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PORTLETS))
      {
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_GADGET_ID,
         WSModelHelper.WSTYPE_HTTPGP, nFolderID, m_asOwner.GetString(1946,
         "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
      }
      m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_GADGETTEMPLATE_ID,
       WSModelHelper.WSTYPE_HTTPGP, nFolderID, m_asOwner.GetString(1948, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      break;
      case WebServiceModel.WSMODE_SWS:
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_NETWORKSEARCHES))
      {
        m_chHelper.displayEmptyRow(result);
        m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_FEDERATEDPORTAL_ID,
         WSModelHelper.WSTYPE_SWS, nFolderID, m_asOwner.GetString(1951, "ptmsgs_portaladminmsgs"),
         m_asOwner, strArg, true));
      }
      break;
      case WebServiceModel.WSMODE_PWS:
      if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PROFILESOURCES))
      {
        m_chHelper.displayEmptyRow(result);
        m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
        // AGC- Yes, AWS -  not PWS
        PT_CLASSIDS.PT_PROFILESOURCE_ID, WSModelHelper.WSTYPE_AWS, nFolderID,
         m_asOwner.GetString(1952, "ptmsgs_portaladminmsgs"), m_asOwner, strArg,
         true));
      }
      break;
      }
      m_chHelper.displayEmptyRow(result);
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, (WebServiceModel) m_model,
       m_asOwner.GetString(2287, "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}