using System;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>dustina</author>
  public class NewLinkPopUpDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "NewLinkPopUpDP";
    
    /// <summary>
    /// Displays some HTML after the body tag and before the form tag.
    /// For example this is used by pages using a DHTML calendar to display the div tag.
    /// The function is optional.  If it exists, it will be called by the framework, and
    /// the resulting HTMLElement will be added in the right place.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      HTMLElementCollection myHTMLBeforeForm = new HTMLElementCollection();
      IInvCodeListModelRO ptROModel = (IInvCodeListModelRO) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME);
      myHTMLBeforeForm = ptROModel.GetDatePickerControlManager().GetPagePreFormContent();
      return (myHTMLBeforeForm);
    }
    
    /// <summary>
    /// Returns the HTML that is placed in the HEAD section of this HTML page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElementCollection DisplayHTMLinHEAD()
    {
      HTMLElementCollection retVal = new HTMLElementCollection();
      String strLangID = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingNames.LANGUAGE,
       GetOwner());
      IInvCodeListModelRO ptROModel = (IInvCodeListModelRO) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME);
      JSDatePickerMgr ptDatePickerMgr = ptROModel.GetDatePickerControlManager();
      retVal.AddInnerHTMLElement(ptDatePickerMgr.GetJSIncludes());
      //Get access to the PTDate.js file for formatting date strings
      retVal.AddInnerHTMLElement(ConfigHelper.GetJSIncluderJSComponentInclude(ConfigHelper.JSCOMPONENT_JSDATEPICKER,
       GetOwner()));
      return retVal;
    }
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and want to
    /// have the Done and Cancel buttons displayed in the header for them need to
    /// implement.  The method should return the title add whatever HTML the child
    /// class wants to display to the body argument.  The parent class will then add
    /// that HTML to the HTMLPage after filling in the banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1298, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(NewLinkPopUpView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(NewLinkPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}