using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public class AccountLockingView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.general.AccountLockingView");
    // ***COMMENT_1*** All the Views in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "AccountLockingView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AccountLockingView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1316,
         "ptmsgs_portaladminmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetWidth("50%");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1317, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE, SetServerSettingsRepostControl.PARAM_ENABLE_ACCOUNT_LOCKING,
         SetServerSettingsRepostControl.PARAM_ENABLE_ACCOUNT_LOCKING);
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        myInput.SetValue(XPConvert.ToString(true));
        if (((ISetServerSettingsModelRO) this.m_model).GetEnableAccountLocking())
        {
          myInput.SetChecked(true);
        }
        // 1st Row end
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1318, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_MINUTES_TO_TRACK_FAILED_LOGINS,
         SetServerSettingsRepostControl.PARAM_MINUTES_TO_TRACK_FAILED_LOGINS);
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        myInput.SetValue(XPConvert.ToString(((ISetServerSettingsModelRO) this.m_model).GetMinutesToTrackFailedLogins()));
        // 1st Row end
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1319, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_NUMBER_FAILURES_ALLOWED,
         SetServerSettingsRepostControl.PARAM_NUMBER_FAILURES_ALLOWED);
        myInput.SetValue(XPConvert.ToString(((ISetServerSettingsModelRO) this.m_model).GetNumberOfFailedLoginsAllowed()));
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        // 1st Row end
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1320, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_MINUTES_TO_LOCK_ACCOUNTS,
         SetServerSettingsRepostControl.PARAM_MINUTES_TO_LOCK_ACCOUNTS);
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        myInput.SetValue(XPConvert.ToString(((ISetServerSettingsModelRO) this.m_model).GetMinutesToLockAccounts()));
        // 1st Row end
        result.AddInnerHTMLString("\n");
        HTMLComment myComment = new HTMLComment("End: Display PropMainView");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLString("\n");
      }
      catch (Exception e)
      {
        log.Error(e, "AccountLockingView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1321, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns Java Script for that Section.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript;
      try
      {
        XPStringBuilder sb = new XPStringBuilder(300);
        myScript = new HTMLScript("text/javaScript");
        // The JavaScript below checks if the Property Name is empty.
        sb.Append("function CheckNumericInputs()\n");
        sb.Append("{\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "PropMainView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw new XPException(m_asOwner.GetString(1322, "ptmsgs_portaladminmsgs"),
         e);
      }
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}