using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author></author>
  public class SetServerSettingsModel : EditorModel,ISetServerSettingsModelRO
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.general.SetServerSettingsModel");
    // ***COMMENT_1*** All the Models in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "SetServerSettingsModel";
    private AActivitySpace m_asasParent = null;
    private String sDefaultLocale = null;
    private String sDefaultTimeZone = null;
    private String sDocumentDisplayURL = null;
    //	private String sIncomingSearchURL		    = null;
    private int iMinutesToLockAccounts = -1;
    private int iMinutesToTrackFailedLogins = -1;
    private int iNumberOfFailedLoginsAllowed = -1;
    private String sPrimaryWebServerURL = null;
    private String sSoapServerURL = null;
    private String sSharedFilesPath = null;
    private String sInviteCipherKey = null;
    private bool bInviteCipherKeySet = false;
    private Object[] settings;
    private bool bAllowNumericAuthentication = false;
    private bool bAllowNumericAuthenticationSet = false;
    private bool bAllowUserCreation = false;
    private bool bAllowUserCreationSet = false;
    private bool bAutoAssignNumericID = false;
    private bool bAutoAssignNumericIDSet = false;
    private bool bEnableAccountLocking = false;
    private bool bEnableAccountLockingSet = false;
    private bool bEnableDebugSubportalRulesMode = false;
    private bool bEnableDebugSubportalRulesModeSet = false;
    private bool bEnableDebugPortletErrorsMode = false;
    private bool bEnableDebugPortletErrorsModeSet = false;
    
    /// <summary>
    /// Implements some actions to perform on start.
    /// Use the Editor Type if needed.
    /// </summary>
    /// <param name="_htFormData"></param>
    /// <returns>boolean Is true if the current user has the rights to access this Editor.</returns>
    public override bool CheckEditorAccessAndStart(XPHashtable _htFormData)
    {
      IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
      if (!ptSession.GetSessionInfo().CheckCurrentUserIsAdmin())
      {
        return false;
      }
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SetServerSettingsModel();
    }
    
    /// <summary>
    /// Code executed after the object is stored.
    /// </summary>
    public override void DoTaskAfterStore()
    {
    }
    // ***CHANGE_HERE*** Put the code that you want to be
    //       executed just AFTER the object is stored in the DB.
    
    /// <summary>
    /// Initializes IPTProperty with the property type member
    /// variable just before we store the object in the DB.
    /// Also sets 2 other values to default.
    /// </summary>
    public override void DoTaskBeforeStore()
    {
    }
    // ***CHANGE_HERE*** Put the code that you want to be
    //       executed just BEFORE the object is stored in the DB.
    // ***COMMENT_1*** You don't need to store the object in the DB.
    /*
     if (EditorStartControl.EDITOR_START_FLAG_CREATE == GetEditorType())
     {
     try
     {
     ((IPTProperty)m_ptObject).Initialize(m_nPropType);
     }
     catch (Exception e)
     {
     if ( log.IsErrorEnabled() ) {
     log.Error("PropModel::DoTaskBeforeStore Unable to initialize the Property with type: "
     + m_nPropType + ". The following exception occured: " + e);
     }
     throw new XPException(_ui_InitError, e);
     }
     
     try
     {
     ((IPTProperty)m_ptObject).SetCharacteristics(PT_PROPERTY_CHARACTERISTICS.PT_PROPCHAR_HREF, new Integer(0));
     ((IPTProperty)m_ptObject).SetCharacteristics(PT_PROPERTY_CHARACTERISTICS.PT_PROPCHAR_SEARCHABLE, new Integer(0));
     }
     catch (Exception e)
     {
     if ( log.IsErrorEnabled() ) {
     log.Error("PropModel::DoTaskBeforeStore Unable to set characteristics the Property." +
     " The following exception occured: " + e);
     }
     throw new XPException(_ui_SetCharError, e);
     }
     }
     
     // ***CHANGE_HERE PLUG-IN ONLY*** (delete if you are not using a plug-in section)
     // Get the settings back from the plug-in Model and sets them on the Object before the Framework stores it.
     // E.g.: ((SamplePlugInModel) m_asOwner.GetModel(PropEditorAS.m_strStoragePlugInKey)).GetSetting()
     */
     
    // ***CHANGE_HERE*** Put your set/get methods and other helper methods
    // BEGIN ***************** helper methods *****************
    /*
     public int GetPropertyType()
     {
     return(m_nPropType);
     }
     */
     
    /*
     public void SetPropertyType(int _nPropType)
     {
     if (PT_PROPERTY_TYPES.PT_PROPTYPE_INVALID != _nPropType)
     {
     m_nPropType = _nPropType;
     if ( log.IsDebugEnabled() ) {
     log.Debug("PropModel::SetPropertyType New property type: " + _nPropType);
     }
     }
     }
     */
     
    // END ***************** helper methods *****************
    
    /// <summary>
    /// Initializes the property type member variable with
    /// the one from IPTProperty in Edit mode and the default
    /// value in create mode.
    /// </summary>
    /// <param name="_htFormData"></param>
    public override void DoTaskOnStartEditor(XPHashtable _htFormData)
    {
    }
    // ***CHANGE_HERE*** Put the code that you want to be
    //       executed just after the Object was created or retrieved from the DB.
    /*
     if (EditorStartControl.EDITOR_START_FLAG_EDIT == GetEditorType())
     {
     
     try
     {
     m_nPropType = ((IPTProperty)m_ptObject).GetType();
     }
     catch (Exception e)
     {
     if ( log.IsErrorEnabled() ) {
     log.Error("PropModel::DoTaskOnStartEditor Unable to get the property type. The following exception occured: " + e);
     }
     throw new XPException(_ui_PropertyTypeError, e);
     }
     }
     else
     {
     // JF - This is the default type.
     m_nPropType = PT_PROPERTY_TYPES.PT_PROPTYPE_STRING;
     
     // ***CHANGE_HERE SECURITY PAGE*** Hide the security page in edit mode
     ((EditorAS) m_asOwner).GetLeftMenu().HideLink(true, ObjectSecurityDP.STR_MVC_CLASS_NAME);
     }
     */
     
    public override void Finish()
    {
      log.Debug("Finish()");
      IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
      //   PRIMARY WEB SERVER URL
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_WEBSERVER_URL,
         this.GetPrimaryWebServerURL());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   SOAP SERVER URL
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_SOAPAPI_URL,
         this.GetSoapServerURL());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   SharedFilesPath
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_INSTALL_PATH,
         this.GetSharedFilesPath());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //
      //
      //		//   INCOMING SEARCH URL
      //		try
      //		{
      //			IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
      //					true);
      //
      //			config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_OPENFEDERATEDSEARCH_URL,
      //				this.GetIncomingSearchURL());
      //		}
      //		catch (Exception ex)
      //		{
      //			
      //				log.Error(ex, //					"Error in SetServerSettingsModel::Finish: ");
      //			
      //		}
      //   AUTOASSIGN NUMERIC ID
      try
      {
        if (this.GetAutoAssignNumericID())
        {
          ptSession.SetSettings(PT_SESSION_SETTINGS.PT_SESSION_AUTOASSIGNNUMERICAUTH,
           1);
        } else
        {
          ptSession.SetSettings(PT_SESSION_SETTINGS.PT_SESSION_AUTOASSIGNNUMERICAUTH,
           0);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   DISPLAY FILES URL
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_DISPLAYFILESDIRECTORY_URL,
         this.GetDocumentDisplayURL());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   DEFAULT LOCALE
      try
      {
        //ptSession.SetSettings(PT_SESSION_SETTINGS.PT_SESSION_LOCALE,
        //	this.GetDefaultLocale());
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_DEFAULT_LOCALE,
         this.GetDefaultLocale());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   DEFAULT TIME ZONE
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_DEFAULT_TIMEZONE,
         this.GetDefaultTimeZone());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   ALLOW NUMERIC AUTHENTICATION
      try
      {
        if (this.GetAllowNumericAuthentication())
        {
          ptSession.SetSettings(PT_SESSION_SETTINGS.PT_SESSION_NUMERICAUTH,
           1);
        } else
        {
          ptSession.SetSettings(PT_SESSION_SETTINGS.PT_SESSION_NUMERICAUTH,
           0);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   ENABLE ACCOUNT LOCKING
      try
      {
        if (this.GetEnableAccountLocking())
        {
          IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
           true);
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_ENABLELOCKING,
           1);
        } else
        {
          IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
           true);
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_ENABLELOCKING,
           0);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   MINUTES TO LOCK
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_LOCKMINUTES,
         this.GetMinutesToLockAccounts());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   MINUTES TO TRACK
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_BADLOGONMINUTES,
         this.GetMinutesToTrackFailedLogins());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   NUMBER OF FAILURES
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_BADLOGONATTEMPTS,
         GetNumberOfFailedLoginsAllowed());
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   CORE INVITE CRYPTO KEY
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (bInviteCipherKeySet)
        {
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_INVITE_CIPHER_KEY,
           GetInviteCipherKey());
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      //   ALLOW USER CREATION TO ALL
      try
      {
        if (this.GetAllowUserCreation())
        {
          IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
           true);
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ALLOW_NEW_USER_CREATION_TO_ALL,
           1);
          //	this will change this value in the application cache
          //	used by the login page.		
          PTLoginHelper.SetAllowUserCreation(this.m_asasParent, this.m_asasParent.GetApplication(),
           true);
        } else
        {
          IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
           true);
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ALLOW_NEW_USER_CREATION_TO_ALL,
           0);
          //	this will change this value in the application cache
          //	used by the login page.		
          PTLoginHelper.SetAllowUserCreation(this.m_asasParent, this.m_asasParent.GetApplication(),
           false);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      // ENABLE SUBPORTAL RULES DEBUGGING MODE
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (this.GetEnableSubportalRulesDebugMode())
        {
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_SUBPORTAL_RULES_MODE,
           1);
        } else
        {
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_SUBPORTAL_RULES_MODE,
           0);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      // ENABLE PORTLET ERRORS DEBUGGING MODE
      try
      {
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (this.GetEnablePortletErrorsDebugMode())
        {
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_PORTLET_ERRORS_MODE,
           1);
        } else
        {
          config.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_PORTLET_ERRORS_MODE,
           0);
        }
      }
      catch (Exception ex)
      {
        log.Error(ex, "Error in SetServerSettingsModel::Finish: ");
      }
      ClearCachedValues();
    }
    
    /// <returns></returns>
    public virtual bool GetAllowNumericAuthentication()
    {
      log.Debug("GetAllowNumericAuthentication() - bAllowNumericAuthentication: " + XPConvert.ToString(bAllowNumericAuthentication));
      if (!bAllowNumericAuthenticationSet)
      {
        log.Debug("Obtaining from portal server");
        bAllowNumericAuthenticationSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        if (ptSession.GetSettingsAsInt(PT_SESSION_SETTINGS.PT_SESSION_NUMERICAUTH) == 1)
        {
          bAllowNumericAuthentication = true;
        } else
        {
          bAllowNumericAuthentication = false;
        }
      }
      return bAllowNumericAuthentication;
    }
    
    /// <returns></returns>
    public virtual bool GetAllowUserCreation()
    {
      if (!bAllowUserCreationSet)
      {
        bAllowUserCreationSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ALLOW_NEW_USER_CREATION_TO_ALL) == 1)
        {
          bAllowUserCreation = true;
        } else
        {
          bAllowUserCreation = false;
        }
      }
      return bAllowUserCreation;
    }
    
    /// <returns></returns>
    public virtual bool GetAutoAssignNumericID()
    {
      if (!bAutoAssignNumericIDSet)
      {
        bAutoAssignNumericIDSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        if ((ptSession.GetSettingsAsInt(PT_SESSION_SETTINGS.PT_SESSION_AUTOASSIGNNUMERICAUTH)) == 1)
        {
          bAutoAssignNumericID = true;
        } else
        {
          bAutoAssignNumericID = false;
        }
      }
      return bAutoAssignNumericID;
    }
    
    /// <returns></returns>
    public virtual String GetDefaultLocale()
    {
      if (sDefaultLocale == null)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        //sDefaultLocale = (String) ptSession.GetSettingsAsString(PT_SESSION_SETTINGS.PT_SESSION_LOCALE);
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        sDefaultLocale = (String) config.GetSettingAsString(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_DEFAULT_LOCALE);
        }
      return sDefaultLocale;
    }
    
    /// <returns></returns>
    public virtual String GetDefaultTimeZone()
    {
      log.Debug("GetDefaultTimeZone() - sDefaultTimeZone: " + sDefaultTimeZone);
      if (sDefaultTimeZone == null)
      {
        //	The server config var might be an Integer or a 
        //	String.  If it's an int, it's garbage to be 
        //	thrown away.  We set it as a String.
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        sDefaultTimeZone = (String) config.GetSettingAsString(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_DEFAULT_TIMEZONE);
        }
      log.Debug("GetDefaultTimeZone() - sDefaultTimeZone: " + sDefaultTimeZone);
      return sDefaultTimeZone;
    }
    
    /// <returns></returns>
    public virtual String GetDocumentDisplayURL()
    {
      if (sDocumentDisplayURL == null)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        sDocumentDisplayURL = (String) ptSession.GetSettingsAsString(PT_SESSION_SETTINGS.PT_SESSION_DISPLAYFILESDIRECTORYURL);
        }
      return sDocumentDisplayURL;
    }
    
    /// <returns></returns>
    public virtual bool GetEnableAccountLocking()
    {
      if (!bEnableAccountLockingSet)
      {
        bEnableAccountLockingSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_ENABLELOCKING) == 1)
        {
          bEnableAccountLocking = true;
        } else
        {
          bEnableAccountLocking = false;
        }
      }
      return bEnableAccountLocking;
    }
    
    /// <returns></returns>
    public virtual bool GetEnableSubportalRulesDebugMode()
    {
      if (!bEnableDebugSubportalRulesModeSet)
      {
        bEnableDebugSubportalRulesModeSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_SUBPORTAL_RULES_MODE) == 1)
        {
          bEnableDebugSubportalRulesMode = true;
        } else
        {
          bEnableDebugSubportalRulesMode = false;
        }
      }
      return bEnableDebugSubportalRulesMode;
    }
    
    /// <returns></returns>
    public virtual bool GetEnablePortletErrorsDebugMode()
    {
      if (!bEnableDebugPortletErrorsModeSet)
      {
        bEnableDebugPortletErrorsModeSet = true;
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        if (config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_PORTLET_ERRORS_MODE) == 1)
        {
          bEnableDebugPortletErrorsMode = true;
        } else
        {
          bEnableDebugPortletErrorsMode = false;
        }
      }
      return bEnableDebugPortletErrorsMode;
    }
    //	/**
    //	 * 
    //	 *
    //	 * @return 
    //	 */
    //	public String GetIncomingSearchURL()
    //	{
    //		if (sIncomingSearchURL == null)
    //		{
    //			IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
    //
    //			sIncomingSearchURL = ptSession.GetSettingsAsString(PT_SESSION_SETTINGS.PT_SESSION_OPENFEDERATEDSEARCHURL);
    //		}
    //
    //		return sIncomingSearchURL;
    //	}
    
    /// <returns></returns>
    public virtual String GetSharedFilesPath()
    {
      if (sSharedFilesPath == null)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        sSharedFilesPath = config.GetSettingAsString(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_INSTALL_PATH);
        }
      return sSharedFilesPath;
    }
    
    /// <returns></returns>
    public virtual String GetSoapServerURL()
    {
      if (sSoapServerURL == null)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        sSoapServerURL = config.GetSettingAsString(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_PLUMTREE_SOAPAPI_URL);
        }
      return sSoapServerURL;
    }
    
    /// <returns></returns>
    public virtual int GetMinutesToLockAccounts()
    {
      if (iMinutesToLockAccounts == -1)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        iMinutesToLockAccounts = config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_LOCKMINUTES);
        }
      return iMinutesToLockAccounts;
    }
    
    /// <returns></returns>
    public virtual int GetMinutesToTrackFailedLogins()
    {
      if (iMinutesToTrackFailedLogins == -1)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        iMinutesToTrackFailedLogins = config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_BADLOGONMINUTES);
        }
      return iMinutesToTrackFailedLogins;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual int GetNumberOfFailedLoginsAllowed()
    {
      if (iNumberOfFailedLoginsAllowed == -1)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        IPTServerConfigSettings config = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
         true);
        iNumberOfFailedLoginsAllowed = config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_USERACCOUNT_BADLOGONATTEMPTS);
        }
      return iNumberOfFailedLoginsAllowed;
    }
    
    /// <returns></returns>
    public virtual String GetPrimaryWebServerURL()
    {
      if (sPrimaryWebServerURL == null)
      {
        IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
        sPrimaryWebServerURL = ptSession.GetSettingsAsString(PT_SESSION_SETTINGS.PT_SESSION_WEBSERVERURL);
        }
      return sPrimaryWebServerURL;
    }
    
    /// <returns></returns>
    public virtual Object[] GetServerSettings()
    {
      return settings;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModel#Init(IActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      m_asasParent = parent;
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      settings = (Object[]) application.GetCachingManager().GetEntry("DisplayServerSettings");
      base.Init(parent);
    }
    
    /// <summary>
    /// Does nothing for now.
    /// </summary>
    public virtual void RepostAdvPage()
    {
    }
    // JF- do nothing for this one, it will just save the page.
    
    /// <summary>
    /// Modifies the object description on repost.
    /// </summary>
    public virtual void RepostMainPage()
    {
    }
    
    /// <summary>
    /// Calls the right save function according to the page name passed in argument.
    /// </summary>
    /// <param name="_sPageName"></param>
    /// <param name="_htFormData"></param>
    /// <returns>int Page status for server side validation</returns>
    public override int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      int nPageStatus = RepostControl.PAGE_STATUS_VALID;
      if (_sPageName.Equals(UserSettingsDP.STR_MVC_CLASS_NAME))
      {
        SaveMainPage(_htFormData);
      } else
      if (_sPageName.Equals(PortalURLsDP.STR_MVC_CLASS_NAME))
      {
        SavePortalUrlsPage(_htFormData);
      }
      return nPageStatus;
    }
    
    /// <param name="b"></param>
    public virtual void SetAllowNumericAuthentication(bool b)
    {
      log.Debug("SetAllowNumericAuthentication()");
      bAllowNumericAuthentication = b;
    }
    
    /// <param name="b"></param>
    public virtual void SetAllowUserCreation(bool b)
    {
      bAllowUserCreation = b;
    }
    
    /// <param name="b"></param>
    public virtual void SetAutoAssignNumericID(bool b)
    {
      bAutoAssignNumericID = b;
    }
    
    /// <param name="s"></param>
    public virtual void SetDefaultLocale(String s)
    {
      sDefaultLocale = s;
    }
    
    /// <param name="s"></param>
    public virtual void SetDefaultTimeZone(String s)
    {
      sDefaultTimeZone = s;
    }
    
    /// <param name="s"></param>
    public virtual void SetDocumentDisplayURL(String s)
    {
      sDocumentDisplayURL = s;
    }
    
    /// <param name="s"></param>
    public virtual void SetSoapServerURL(String s)
    {
      sSoapServerURL = s;
    }
    
    /// <param name="s"></param>
    public virtual void SetSharedFilesPath(String s)
    {
      sSharedFilesPath = s;
    }
    
    /// <param name="b"></param>
    public virtual void SetEnableAccountLocking(bool b)
    {
      bEnableAccountLocking = b;
    }
    
    /// <param name="b"></param>
    public virtual void SetEnableDebugSubportalRulesMode(bool b)
    {
      bEnableDebugSubportalRulesMode = b;
    }
    
    /// <param name="b"></param>
    public virtual void SetEnableDebugPortletErrorsMode(bool b)
    {
      bEnableDebugPortletErrorsMode = b;
    }
    //	/**
    //	 * 
    //	 *
    //	 * @param s 
    //	 */
    //	public void SetIncomingSearchURL(String s)
    //	{
    //		sIncomingSearchURL = s;
    //	}
    
    /// <param name="s"></param>
    public virtual void SetMinutesToLockAccounts(int i)
    {
      iMinutesToLockAccounts = i;
    }
    
    /// <param name="s"></param>
    public virtual void SetMinutesToTrackFailedLogins(int i)
    {
      iMinutesToTrackFailedLogins = i;
    }
    
    /// <param name="s"></param>
    public virtual void SetNumberOfFailedLoginsAllowed(int i)
    {
      iNumberOfFailedLoginsAllowed = i;
    }
    
    /// <param name="s"></param>
    public virtual void SetPrimaryWebServerURL(String s)
    {
      sPrimaryWebServerURL = s;
    }
    // ***CHANGE_HERE*** Implement one method per DP to save it
    // BEGIN ***************** save DP methods *****************
    
    /// <summary>
    /// Saves the data on the Main page.
    /// </summary>
    /// <param name="_htFormData"></param>
    /// <returns>int Page status for server side validation</returns>
    protected virtual int SaveMainPage(XPHashtable _htFormData)
    {
      String[] data;
      int nPageStatus = RepostControl.PAGE_STATUS_VALID;
      log.Debug("SaveMainPage()");
      //	ALLOW USER CREATION
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_ALLOW_USER_CREATION);
      if (data != null)
      {
        this.SetAllowUserCreation(XPConvert.ToBoolean(data[0]));
      } else
      {
        this.SetAllowUserCreation(false);
      }
      //	ALLOW NUMERIC LOGIN
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_ALLOW_NUMERIC_LOGIN);
      if (data != null)
      {
        log.Debug("SaveMainPage() - data is PARAM_ALLOW_NUMERIC_LOGIN");
        log.Debug("SaveMainPage() - data[0]: " + data[0]);
        this.SetAllowNumericAuthentication(XPConvert.ToBoolean(data[0]));
        } else
      {
        this.SetAllowNumericAuthentication(false);
      }
      //	AUTO ASSIGN IDS
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_AUTO_ASSIGN_IDS);
      if (data != null)
      {
        this.SetAutoAssignNumericID(XPConvert.ToBoolean(data[0]));
      } else
      {
        this.SetAutoAssignNumericID(false);
      }
      // ENABLE ACCOUNT LOCKING
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_ENABLE_ACCOUNT_LOCKING);
      if (data != null)
      {
        this.SetEnableAccountLocking(XPConvert.ToBoolean(data[0]));
      } else
      {
        this.SetEnableAccountLocking(false);
      }
      //	MINUTES TO TRACK FAILED LOGINS
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_MINUTES_TO_TRACK_FAILED_LOGINS);
      if (data != null)
      {
        String sPostedVal = data[0];
        //MES- Try to convert it to a number- if the conversion
        //	fails, don't modify the setting!
        try
        {
          int iPostedVal = XPConvert.ToInteger(sPostedVal);
          //MES- Do some simple validation
          if (0 <= iPostedVal)
          {
            this.SetMinutesToTrackFailedLogins(iPostedVal);
          } else
          {
            //MES- This is a disallowed value, report
            log.Warn("Error in SetServerSettingsModel when attempting to store Minutes To Track Failed Logins- value \'{0}\' is not an allowed value.  Change not stored.",
             sPostedVal);
          }
        }
        catch (XPException xpe)
        {
          //MES- Log the error, but don't store any changes
          log.Warn(xpe, "Error in SetServerSettingsModel when attempting to store Minutes To Track Failed Logins- value \'{0}\' could not be converted to an integer.  Change not stored.",
           sPostedVal);
        }
      }
      //	MAX FAILURES ALLOWED
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_NUMBER_FAILURES_ALLOWED);
      if (data != null)
      {
        String sPostedVal = data[0];
        //MES- Try to convert it to a number- if the conversion
        //	fails, don't modify the setting!
        try
        {
          int iPostedVal = XPConvert.ToInteger(sPostedVal);
          //MES- Do some simple validation
          if (0 <= iPostedVal)
          {
            this.SetNumberOfFailedLoginsAllowed(iPostedVal);
          } else
          {
            //MES- This is a disallowed value, report
            log.Warn("Error in SetServerSettingsModel when attempting to store Number Of Failed Logins Allowed- value \'{0}\' is not an allowed value.",
             sPostedVal);
          }
        }
        catch (XPException xpe)
        {
          //MES- Log the error, but don't store any changes
          log.Warn(xpe, "Error in SetServerSettingsModel when attempting to store Number Of Failed Logins - value \'{0}\' could not be converted to a number.  Change not stored.",
           sPostedVal);
        }
      }
      //	MINUTES TO LOCK
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_MINUTES_TO_LOCK_ACCOUNTS);
      if (data != null)
      {
        String sPostedVal = data[0];
        //MES- Try to convert it to a number- if the conversion
        //	fails, don't modify the setting!
        try
        {
          int iPostedVal = XPConvert.ToInteger(sPostedVal);
          //MES- Do some simple validation
          if (0 <= iPostedVal)
          {
            this.SetMinutesToLockAccounts(iPostedVal);
          } else
          {
            //MES- This is a disallowed value, report
            log.Warn("Error in SetServerSettingsModel when attempting to store Minutes To Lock Accounts- value \'{0}\' is not an allowed value.",
             sPostedVal);
          }
        }
        catch (XPException xpe)
        {
          //MES- Log the error, but don't store any changes
          log.Warn(xpe, "Error in SetServerSettingsModel when attempting to store Minutes To Lock Accounts - value \'{0}\' could not be converted to a number.  Change not stored.",
           sPostedVal);
        }
      }
      //	DEFAULT LOCALE
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_DEFAULT_LOCALE);
      if (data != null)
      {
        this.SetDefaultLocale(data[0]);
      }
      //	DEFAULT TIME ZONE
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_DEFAULT_TIMEZONE);
      if (data != null)
      {
        this.SetDefaultTimeZone(data[0]);
      }
      //	INVITE CIPHER KEY
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_INVITE_CIPHER_KEY);
      if (data != null)
      {
        this.SetInviteCipherKey(data[0]);
      }
      // ENABLE SUBPORTAL RULES DEBUGGING MODE
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_ENABLE_DEBUG_SUBPORTAL_RULES_MODE);
      if (data != null)
      {
        this.SetEnableDebugSubportalRulesMode(XPConvert.ToBoolean(data[0]));
        } else
      {
        this.SetEnableDebugSubportalRulesMode(false);
      }
      // ENABLE DEBUGGING MODE
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_ENABLE_DEBUG_PORTLET_ERRORS_MODE);
      if (data != null)
      {
        this.SetEnableDebugPortletErrorsMode(XPConvert.ToBoolean(data[0]));
        } else
      {
        this.SetEnableDebugPortletErrorsMode(false);
      }
      return nPageStatus;
    }
    
    /// <param name="_htFormData"></param>
    protected virtual void SavePortalUrlsPage(XPHashtable _htFormData)
    {
      log.Debug("SavePortalUrlsPage()");
      String[] data;
      //	WEB SERVER URL
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_PRIMARY_WEB_SERVER_URL);
      if (data != null)
      {
        this.SetPrimaryWebServerURL(data[0]);
      }
      //	DISPLAY FILES URL
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_DISPLAY_FILES_URL);
      if (data != null)
      {
        this.SetDocumentDisplayURL(data[0]);
      }
      //	SOAP SERVER URL
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_SOAP_SERVER_URL);
      if (data != null)
      {
        this.SetSoapServerURL(data[0]);
      }
      //	SHARED FILES PATH
      data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_SHARED_FILES_PATH);
      if (data != null)
      {
        this.SetSharedFilesPath(data[0]);
      }
    }
    //
    //		//	WEB INCOMING SEARCH URL
    //
    //		data = (String[]) _htFormData.GetElement(SetServerSettingsRepostControl.PARAM_INCOMING_SEARCH_URL);
    //
    //		if (data != null)
    //		{
    //			this.SetIncomingSearchURL(data[0]);
    //		}
    private void ClearCachedValues()
    {
      log.Debug("ClearCachedValues()");
      bAllowUserCreation = false;
      bAllowNumericAuthentication = false;
      bAutoAssignNumericID = false;
      bEnableAccountLocking = false;
      bAllowUserCreationSet = false;
      bAllowNumericAuthenticationSet = false;
      bAutoAssignNumericIDSet = false;
      bEnableAccountLockingSet = false;
      iMinutesToTrackFailedLogins = -1;
      iNumberOfFailedLoginsAllowed = -1;
      iMinutesToLockAccounts = -1;
      sDefaultLocale = null;
      sDefaultTimeZone = null;
      sPrimaryWebServerURL = null;
      sSoapServerURL = null;
      sSharedFilesPath = null;
      sDocumentDisplayURL = null;
      //		sIncomingSearchURL		 = null;
      sInviteCipherKey = null;
    }
    public virtual void UpdateLoginTokenKey()
    {
      //DCD TODO: Update Server Config here
      log.Debug("Called UpdateLoginTokenKey");
      IPTSession ptSession = (IPTSession) m_asasParent.GetUserSession();
      IPTServerConfigSettings SCS = (IPTServerConfigSettings) ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
       false);
      XPSecureRandom rand = new XPSecureRandom();
      String sNewKey = XPConvert.ToString(rand.NextInt()) + XPConvert.ToString(rand.NextInt());
      SCS.SetSetting(PT_SERVER_CONFIG_SETTINGNAME.PT_TOKEN_PASSWORD, sNewKey);
      }
    
    /// <summary>
    /// GetInviteCipherKey - the key used to encrypt the codes for CreateAccount invites
    /// </summary>
    /// <returns></returns>
    public virtual String GetInviteCipherKey()
    {
      return sInviteCipherKey;
    }
    
    /// <summary>
    /// SetInviteCipherKey - the key used to encrypt the codes for CreateAccount invites
    /// </summary>
    /// <param name="sKey"></param>
    public virtual void SetInviteCipherKey(String sKey)
    {
      sInviteCipherKey = sKey;
      bInviteCipherKeySet = true;
    }
  }
}