using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public class UserSettingsDP : EditorDP
  {
    // ***CHANGE_HERE*** Set the class name.
    // COMMENT1- All the DPs in your AS need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "SetServerSettingsDP";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(1348, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2962, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(NewUserCreationView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(NumericAuthenticationView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(AccountLockingView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      /* JHQ bug 25352: Doc Team says to remove this view because it is not
       * accurate.  I will not delete the class, since we may change our mind
       * in the future.  For now I'll just comment this out. */
       
      //		 views.AddInnerHTMLElement(
      //			((EditorView) m_asOwner
      //				.GetView(DefaultLanguageSettingsView.STR_MVC_CLASS_NAME))
      //				.Display());
      //
      //		views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(UpdateLoginTokenKeyView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(DebuggingModeView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(AccountLockingView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}
// ***CHANGE_HERE*** This method is optional. 
//      You can implement it if you want to display some HTML in the head.
//		If that method exists the framework will automatically call it
//      and the HTML returned will get displayed in the head tag.
//      WARNING: META and LINK tags only should be returned.
/*public HTMLElementCollection DisplayHTMLinHEAD() throws HTMLException
 {
 HTMLElementCollection myHTMLinHead = new HTMLElementCollection();
 // ***CHANGE_HERE*** Add your HTML to the myHTMLinHead HTML collection.
 
 return(myHTMLinHead);
 }*/
 
// ***CHANGE_HERE*** This method is optional. 
//      You can implement it if you want to display some HTML after 
//      the BODY tag and before the FORM tag.
//		If that method exists, the framework will automatically call it.
//      E.g.: DIV tags should go in that method.
/*public HTMLElementCollection DisplayHTMLBeforeForm() throws HTMLException
 {
 HTMLElementCollection myHTMLBeforeForm = new HTMLElementCollection();
 // ***CHANGE_HERE*** Add your HTML to the myHTMLBeforeForm HTML collection.
 
 return(myHTMLBeforeForm);
 }*/
 
