using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  /// <author>OlegS</author>
  public class SearchServerSettingsEditorDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "SearchServerSettingsEditor";
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      ISearchServerSettingsEditorModelRO ptROModel = (ISearchServerSettingsEditorModelRO) m_asOwner.GetModel(STR_MVC_CLASS_NAME);
      return ptROModel.GetDateTimePickerControlManager().GetPagePreFormContent();
      }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public virtual HTMLElementCollection GetDatePickerScripts()
    {
      AActivitySpace asOwner = GetOwner();
      HTMLElementCollection retVal = new HTMLElementCollection();
      JSDateTimePickerMgr ptDatePickerMgr = ((ISearchServerSettingsEditorModelRO) m_asOwner.GetModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME)).GetDateTimePickerControlManager();
      retVal.AddInnerHTMLElement(ptDatePickerMgr.GetJSIncludes());
      return retVal;
    }
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(154, "ptmsgs_portalcommonmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1640, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SearchServerSettingsEditorView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      /* EDITOR WITH NO HEADER AND NO LEFT NAV?
       * Replace the code above with the 2 lines bellow:
       * HTMLElementCollection result = new HTMLElementCollection(); result.
       * AddInnerHTMLElement(((EditorView)m_asOwner.GetView
       * (SearchServerSettingsEditorView.STR_MVC_CLASS_NAME)).Display());
       */
       
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(SearchServerSettingsEditorView.STR_MVC_CLASS_NAME).DisplayJavascript());
      myScripts.AddInnerHTMLElement(GetDatePickerScripts());
      return myScripts;
    }
  }
}