using System;
using com.plumtree.portalpages.rest;
namespace com.plumtree.portalpages.browsing.directory.rest
{
  /// <summary>
  /// This class enumerates the errors generated by the KD Rest API.
  /// 2000 - 2499 is reserved for KD errors.
  /// </summary>
  public class DirRestErrors : ARESTErrors,IRESTError
  {
    public static readonly IRESTError NO_JSON_DOCUMENT_OBJECT = new DirRestErrors(2000,
     "Document node not " + "in JSON document.");
    public static readonly IRESTError NO_FOLDER_ID = new DirRestErrors(2010,
     "The API URL did not contain " + "the folder ID.");
    public static readonly IRESTError NO_DATA_SOURCE_ID = new DirRestErrors(2020,
     "The API data did not include a valid data source ID.");
    public static readonly IRESTError NO_CONTENT_URL = new DirRestErrors(2030,
     "The API data did not include a valid content source URL.");
    private int m_nCode;
    private String m_strMessage;
    private DirRestErrors(int _nCode, String _strMessage) : base(_nCode, _strMessage)
    {
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetCode()"></seealso>
    public override int GetCode()
    {
      return m_nCode;
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetMessage()"></seealso>
    public override String GetMessage()
    {
      return m_strMessage;
    }
  }
}