using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.gateway
{
  /// <author>daniilk</author>
  public class GatewayReturnDP : IDisplayPage
  {
    public static String STR_MVC_CLASS_NAME = "GatewayReturn";
    private AActivitySpace m_asOwner = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display(IWebData)"></seealso>
    public virtual void Display(IWebData webData)
    {
      IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.strModelName);
      String strRawHeaders = gwModel.GetHeaders();
      webData.SetStatus(gwModel.GetStatus());
      if (null != strRawHeaders)
      {
        GatewayUtils.AddHeadersToResponse(strRawHeaders, webData);
      }
      webData.SetData(gwModel.GetBinaryBody());
      return;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetParent()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public virtual HTMLElement PageDisplay()
    {
      return null;
    }
  }
}