using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.search.basic;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.advanced
{
  /// <author>CraigS</author>
  public class ASButtonView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.search.advanced.ASButtonView");
    public const String STR_MVC_CLASS_NAME = "ASButton";
    // Strings to localize.
    // HTML inputs
    public const String HTMLINPUT_SEARCH_BUTTON = "in_bu_submitsearch";
    protected AActivitySpace m_asOwner = null;
    protected IAdvancedSearchModelRO _model = null;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new ASButtonView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement Display()
    {
      HTMLElement result = new HTMLElementCollection();
      ASURL url = BasicSearchView.GetBasicSearchURL(m_asOwner);
      result.AddInnerHTMLElement(url.GetURLAsHTMLElement());
      result.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;&nbsp;");
      try
      {
        HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON, HTMLINPUT_SEARCH_BUTTON,
         "");
        button.SetOnClick("postToSelf(" + AdvancedSearchRepostControl.SEARCH_ACTION + ");");
        button.SetValue(m_asOwner.GetString(774, "ptmsgs_portalbrowsingmsgs"));
        button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        result.AddInnerHTMLElement(button);
      }
      catch (Exception e)
      {
        log.Error(m_asOwner.GetString(773, "ptmsgs_portalbrowsingmsgs"));
        throw new XPException(m_asOwner.GetString(773, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      _model = (IAdvancedSearchModelRO) model;
      m_asOwner = parent;
    }
  }
}