using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.advanced
{
  /// <author>CraigS</author>
  public class ASFooterView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.search.advanced.ASFooterView");
    public const String STR_MVC_CLASS_NAME = "ASFooter";
    // Strings to localize.
    // HTML inputs
    public const String HTMLINPUT_RESET_BUTTON = "in_bu_reset";
    protected AActivitySpace m_asOwner = null;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new ASFooterView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement Display()
    {
      HTMLElement result = new HTMLElementCollection();
      try
      {
        // Make an URL for a brand-new advanced search space.
        ASURL newAS = new ASURL(m_asOwner);
        newAS.SetLinkCreateNewSpace(AdvancedSearchAS.STR_MVC_CLASS_NAME, m_asOwner);
        newAS.SetControl("EditorStart");
        newAS.AddControlArgument("editorType", "10");
        String url = newAS.GetURLAsString();
        // Make a reset button.
        HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON, HTMLINPUT_RESET_BUTTON,
         "");
        button.SetValue(m_asOwner.GetString(783, "ptmsgs_portalbrowsingmsgs"));
        button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        button.SetOnClick("window.location.href=\'" + url + "\';");
        result.AddInnerHTMLElement(button);
      }
      catch (Exception e)
      {
        log.Error(m_asOwner.GetString(782, "ptmsgs_portalbrowsingmsgs"));
        throw new XPException(m_asOwner.GetString(782, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return result;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}