using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: DisplayInPortletControl.java
  /// -------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class DisplayInPortletControl : RepostControl
  {
    public const String STR_MVC_CLASS_NAME = "DisplayInPortlet";
    public static String QS_FOLDERID = "FOLDERID";
    public static String QS_PAGEISLOADING = "PAGEISLOADING";
    public static String QS_COMMUNITYID = "COMMUNITYID";
    public static int POSTTOSELF_ACTION_SORT = 24;
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private SiteMapModel m_asModel;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public override Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues;
      int nPageIsLoading = 0;
      sValues = (String[]) arguments.GetElement(QS_PAGEISLOADING);
      if (sValues != null)
      {
        nPageIsLoading = XPConvert.ToInteger(sValues[0]);
      }
      if (nPageIsLoading != 0)
      {
        sValues = (String[]) arguments.GetElement(QS_COMMUNITYID);
        if (sValues != null)
        {
          try
          {
            m_asModel.SetCommunityID(XPConvert.ToInteger(sValues[0]));
          }
          catch (Exception e)
          {
          }
        }
        sValues = (String[]) arguments.GetElement(QS_FOLDERID);
        if (sValues != null)
        {
          try
          {
            m_asModel.OpenSubFolder(XPConvert.ToInteger(sValues[0]));
          }
          catch (Exception e)
          {
          }
        } else
        {
          m_asModel.OpenSubFolder(-1);
        }
      }
      if (nPageIsLoading == 0)
      {
        base.CheckActionSecurityAndExecute(arguments);
        ClosePopUpDP objDP = (ClosePopUpDP) m_asOwner.GetPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
        HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
        try
        {
          script.AddInnerHTMLString("window.opener." + AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + POSTTOSELF_ACTION_SIMPLEREPOST + ");");
          }
        catch (HTMLException he)
        {
        }
        objDP.SetScript(script);
        Redirect redirect = new Redirect();
        try
        {
          redirect.SetLinkGetCachedSpace(m_asOwner);
          redirect.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
        }
        catch (Exception e)
        {
          UIError myError = new UIError(UIErrorLevel.FRIENDLY, UIErrorScope.CURRENT_USER,
           e, e.Message, e.Message);
          UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(), m_asOwner.GetApplication());
          }
        return redirect;
      } else
      {
        return null;
      }
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DisplayInPortletControl();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public override void Init(IModel model, AActivitySpace space)
    {
      base.Init(model, space);
      m_asModel = (SiteMapModel) model;
      m_asOwner = space;
    }
    
    /// <summary>
    /// Given the repost action mode, calls the associated method in the model.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      }
    }
  }
}
/*case POSTTOSELF_ACTION_SORT:
 
 break;
 */
 
// JF: Do not add a default case because sub classes will extend this one and add their own action modes.
