using System;
namespace com.plumtree.portalpages.rest
{
  /// <summary>
  /// Abstract base class for the mechanics of REST errors.
  /// </summary>
  public abstract class ARESTErrors : IRESTError
  {
    protected int m_nCode;
    protected String m_strMessage;
    protected ARESTErrors(int _nCode, String _strMessage)
    {
      m_nCode = _nCode;
      m_strMessage = _strMessage;
      RESTErrors.AddRestError(this);
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetCode()"></seealso>
    public virtual int GetCode()
    {
      return m_nCode;
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetMessage()"></seealso>
    public virtual String GetMessage()
    {
      return m_strMessage;
    }
  }
}