package com.plumtree.portalpages.admin.editors.externaloperations;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author OlegS
 */
public class ExternalOperationEditorMainView extends EditorView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.externaloperations.ExternalOperationEditorMainView");


	public static final String STR_MVC_CLASS_NAME = "ExternalOperationEditorMain";


	public static final String HTMLTEXT_CommandLine = "in_ta_cmdline";

	/**
 	 * @deprecated ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
	 */ 
	public static final String HTMLTEXT_User	  = "in_tx_user";


	/**
	 * @deprecated ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
	 */ 
	public static final String HTMLTEXT_Password  = "in_pw_pwd";


	/**
	 * @deprecated ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
	 */ 
	public static final String HTMLTEXT_Password2 = "in_pw_pwd2";


	public static final String HTMLTEXT_Timeout = "in_tx_timeout";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ExternalOperationEditorMainView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		try
		{
			HTMLElementCollection result = new HTMLElementCollection();
			HTMLComment myComment = new HTMLComment( "Begin: Display ExternalOperationEditorMainView");
			result.AddInnerHTMLElement(myComment);

			DisplayObjectHeader(result,m_asOwner.GetString(357, "ptmsgs_portaladminmsgs"));
			DisplayCommandLine(result);
			spacer15.display(result);

			// JHQ ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
//			DisplayObjectHeader(result,m_asOwner.GetString(358, "ptmsgs_portaladminmsgs"));
//			DisplayRunAs(result);
//			spacer15.display(result);

			DisplayObjectHeader(result,m_asOwner.GetString(362, "ptmsgs_portaladminmsgs"));
			DisplayTimeout(result);
			spacer15.display(result);
			myComment = new HTMLComment( "End: Display ExternalOperationEditorMainView");
			result.AddInnerHTMLElement(myComment);

			return result;
		}
		catch (Exception e)
		{
			log.Error(e, "ExternalOperationEditorMainView::Display An error occured when trying to display the HTML.");

			throw new XPException(m_asOwner.GetString(364,
					"ptmsgs_portaladminmsgs"), e);
		}
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		// JHQ ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
//		HTMLScript myScript;

//		try
//		{
//			XPStringBuilder sb = new XPStringBuilder(300);
//			myScript = new HTMLScript("text/javaScript");

			// The JavaScript below checks if the password is empty.
//			sb.Append("function CheckPassword()\n");
//			sb.Append("{\n");
//			sb.Append("  if (\"\" == document." + EditorDP.HTMLFORM_NAME + "." +
//				HTMLTEXT_Password + ".value)\n");
//			sb.Append("  {\n");
//			sb.Append("      return confirm(\"" + m_asOwner.GetString(1827, "ptmsgs_portaladminmsgs") +
//				"\");\n");
//			sb.Append("  }\n");
//			sb.Append("  return true;\n");
//			sb.Append("}\n");
//			myScript.AddInnerHTMLString(sb.ToString());
//		}
//		catch (Exception e)
//		{
//			
//				log.Error(e, //					"PropMainView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
//					e.getMessage());
//			
//
//			throw new XPException(m_asOwner.GetString(1826, "ptmsgs_portaladminmsgs"), e);
//		}

//		return myScript;
		return null;
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 *
	 * @return
	 */
	protected IExternalOperationEditorModelRO GetModel()
	{
		return (IExternalOperationEditorModelRO) m_model;
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayCommandLine(HTMLElementCollection result)
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLTextArea myInput;
		HTMLComment myComment = new HTMLComment( "Begin: DisplayCommandLine ExternalOperationEditorMainView");
		result.AddInnerHTMLElement(myComment);

		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myInput = new HTMLTextArea("80", "6");
		myInput.SetName(HTMLTEXT_CommandLine);
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_TEXTBOX_TEXT);
		myInput.AddInnerHTMLString(GetModel().GetCommandLine()); // i.e. setValue
		myComment = new HTMLComment( "End: DisplayCommandLine ExternalOperationEditorMainView");
		result.AddInnerHTMLElement(myComment);
	}

	/**
	 *
	 *
	 * @param result
	 * @param name
	 *
	 * @throws HTMLException
	 */
	protected void DisplayObjectHeader(HTMLElementCollection result, String name)

	{
		result.AddInnerHTMLElement(super.GetHeaderView(name));
		/*
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("0");
		myTable.SetCellSpacing("0");
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("100%");
		myCell.SetHeight("20");
		myCell.SetVAlign("center");
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
		mySpan.AddInnerHTMLString(name);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("10");
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

		*/
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 * 
	 * @deprecated ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
	 */
	protected void DisplayRunAs(HTMLElementCollection result)

	{
//		HTMLTable myTable;
//		HTMLTableRow myRow;
//		HTMLTableCell myCell;
//		HTMLInput myInput;
//		HTMLSpan mySpan;
//		HTMLComment myComment = new HTMLComment( "Begin: DisplayRunAs ExternalOperationEditorMainView");
//		result.AddInnerHTMLElement(myComment);
//		myTable = new HTMLTable();
//		result.AddInnerHTMLElement(myTable);
//		myTable.SetWidth("100%");
//		myTable.SetBorder("0");
//		myTable.SetCellPadding("5");
//		myTable.SetCellSpacing("0");
//
//		myRow = new HTMLTableRow();
//		myTable.AddInnerHTMLElement(myRow);
//		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetWidth("150");
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
//		mySpan.AddInnerHTMLString(m_asOwner.GetString(359,"ptmsgs_portaladminmsgs"));
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
//		mySpan.AddInnerHTMLString("*");
//
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetAlign("left");
//		myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLTEXT_User, "");
//		myCell.AddInnerHTMLElement(myInput);
//		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
//		myInput.SetSize("20");
//		myInput.SetValue(GetModel().GetUser());
//
//		myRow = new HTMLTableRow();
//		myTable.AddInnerHTMLElement(myRow);
//		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetWidth("150");
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
//		mySpan.AddInnerHTMLString(m_asOwner.GetString(360,"ptmsgs_portaladminmsgs"));
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
//		mySpan.AddInnerHTMLString("*");
//
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetAlign("left");
//		myInput = new HTMLInput(HTMLInputTypes.PASSWORD, HTMLTEXT_Password, "");
//		myCell.AddInnerHTMLElement(myInput);
//		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
//		myInput.SetSize("20");
//		myInput.SetValue(GetModel().GetPasswordToDisplay());
//
//		myRow = new HTMLTableRow();
//		myTable.AddInnerHTMLElement(myRow);
//		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetWidth("150");
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
//		mySpan.AddInnerHTMLString(m_asOwner.GetString(361,"ptmsgs_portaladminmsgs"));
//
//		mySpan = new HTMLSpan();
//		myCell.AddInnerHTMLElement(mySpan);
//		mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
//		mySpan.AddInnerHTMLString("*");
//
//		myCell = new HTMLTableCell();
//		myRow.AddInnerHTMLElement(myCell);
//		myCell.SetAlign("left");
//		myInput = new HTMLInput(HTMLInputTypes.PASSWORD, HTMLTEXT_Password2, "");
//		myCell.AddInnerHTMLElement(myInput);
//		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
//		myInput.SetSize("20");
//		myInput.SetValue(GetModel().GetPasswordToDisplay());
//
//		myComment = new HTMLComment( "End: DisplayRunAs ExternalOperationEditorMainView");
//		result.AddInnerHTMLElement(myComment);
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayTimeout(HTMLElementCollection result)

	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;
		HTMLComment myComment = new HTMLComment( "Begin: DisplayTimeout ExternalOperationEditorMainView");
		result.AddInnerHTMLElement(myComment);

		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");

		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("150");

		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
		mySpan.AddInnerHTMLString(m_asOwner.GetString(363,"ptmsgs_portaladminmsgs"));

		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetAlign("left");
		myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLTEXT_Timeout, "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue(XPConvert.ToString(GetModel().GetTimeout() / 1000));
		myInput.SetSize("20");

		myComment = new HTMLComment( "End: DisplayTimeout ExternalOperationEditorMainView");
		result.AddInnerHTMLElement(myComment);
	}

	protected static Spacer spacer15 = new Spacer("15");
}

