package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;
/**
 * @author josephc
 */
public class AdvSpaceSettingsDP extends WSPluginDP {
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "AdvSpaceSettingsDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews() {
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(
			WebServiceEditorAS.strStorage_IntrinsicHelpSpacePluginView);

		return xpWSViews;
	}

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		
		//TODO: OBSOLETE String 1184
		return m_asOwner.GetString(1185, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1672, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode) {
		XPArrayList xpWSViews = new XPArrayList();

		switch (nWSMode) {
			case WebServiceModel.WSMODE_PORTLET :
				break;

			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				break;

			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_MWS :
				break;

			case WebServiceModel.WSMODE_CWS :
			case WebServiceModel.WSMODE_SWS :
				break;

			case WebServiceModel.WSMODE_NONE :
			default :
				}

		return xpWSViews;
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				return "PT_WebService_Portlet_Intrinsic_AdvancedSpaceSettings";
			case WebServiceModel.WSMODE_PORTLET :				
			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_CWS :
			case WebServiceModel.WSMODE_SWS :
			case WebServiceModel.WSMODE_MWS :
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}

}

