package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class AssocObjectsDP extends WSPluginDP
{
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "AssocObjectsDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews()
	{
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_AssocObjectsPluginView);

		return xpWSViews;
	}


	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1186, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode)
	{
		XPArrayList xpWSViews = new XPArrayList();

//		switch (nWSMode)
//		{
//		case WebServiceModel.WSMODE_PORTLET:
//		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
//
			// AGC- Only show the associated objects view in EDIT MODE (it will always be empty in create mode).		
			if (EditorStartControl.EDITOR_START_FLAG_EDIT == ((WebServiceModel) m_asOwner.GetModel(
						WebServiceModel.STR_MVC_CLASS_NAME)).GetEditorType())
			{
				xpWSViews.Add(WebServiceEditorAS.strStorage_AssocObjectsPluginView);
			}

//			break;
//
//		case WebServiceModel.WSMODE_NONE:default:
//			break;
//		}

		return xpWSViews;
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PORTLET :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_AWS :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_PWS :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_CWS :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_SWS :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_MWS :
				return "PT_WebService_Portlet_AssociatedObjects";
			case WebServiceModel.WSMODE_NONE :
				return "PT_WebService_Portlet_AssociatedObjects";
			default :					
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetHTMLBelowSubHeader()
	 */
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2503,"ptmsgs_portaladminmsgs"),m_asOwner);
	}

}

