package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class DevicesDP extends WSPluginDP
{
	//MES- CR: Doesn't match actual class name
	//AGC- CR-Response: Nope - some doohicky stole my DP name after I wrote this
	//    class and I was having trouble with name collision, so I changed it.
	//    The value of this string is arbitrary as long as it is reasonably unique.
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "WebServiceDevicesDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews()
	{
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_SelectDevicesPluginView);

		return xpWSViews;
	}

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1187, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode)
	{
		XPArrayList xpWSViews = new XPArrayList();

		switch (nWSMode)
		{
		case WebServiceModel.WSMODE_PORTLET:
			xpWSViews.Add(WebServiceEditorAS.strStorage_SelectDevicesPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_SummaryURLPluginView);

			break;

		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
			xpWSViews.Add(WebServiceEditorAS.strStorage_SelectDevicesPluginView);
			break;
		}

		return xpWSViews;
	}
	
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		// Specify the additional settings for this Web Service.
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1672,"ptmsgs_portaladminmsgs"),m_asOwner);
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PORTLET :
				return "PT_WebService_Portlet_AlternativeBrowsingDevices";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				return "PT_WebService_Portlet_AlternativeBrowsingDevices";
			case WebServiceModel.WSMODE_CWS :
				return "PT_WebService_Portlet_AlternativeBrowsingDevices";
			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_SWS :
			case WebServiceModel.WSMODE_MWS :
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}

}

