package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * @author adolfoc
 *
 */
public class MainDP extends WSPluginDP
{
	/** Class Name */

	//MES- CR: Doesn't match the class name
	//AGC- CR-Response: Doesn't have to. See the other DP's for why.
	public static final String STR_MVC_CLASS_NAME = "WebServiceMainDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews()
	{
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_HTTPSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_AWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_PWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_CWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_SWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicPortletWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_MWSSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

		return xpWSViews;
	}

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1189, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode)
	{
		XPArrayList xpWSViews = new XPArrayList();

		switch (nWSMode)
		{
		case WebServiceModel.WSMODE_PORTLET:
			xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_HTTPSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

		case WebServiceModel.WSMODE_AWS:
			xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AWSSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

		case WebServiceModel.WSMODE_PWS:
			xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_PWSSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

		case WebServiceModel.WSMODE_CWS:
			xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_CWSSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

		case WebServiceModel.WSMODE_SWS:
			xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_SWSSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
			xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicPortletWSSettingsPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

			break;

			case WebServiceModel.WSMODE_MWS:
				xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_MWSSettingsPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);

				break;

		case WebServiceModel.WSMODE_NONE:default:
			break;
		}

		return xpWSViews;
	}
	
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		WebServiceModel myWSModel=(WebServiceModel)m_asOwner.GetModel(m_asOwner.m_strModelName);
		String s=myWSModel.GetWSObjectMiniHelp();
		if(s==null)
			return super.GetHTMLBelowSubHeader();
		else
			return HTMLConstructHelpers.GetSubHeader(s,m_asOwner);
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PORTLET :
				return "PT_WebService_Portlet_Remote_MainSettings";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				return "PT_WebService_Portlet_Intrinsic_MainSettings";
			case WebServiceModel.WSMODE_AWS :
				return "PT_WebService_Authentication_MainSettings";
			case WebServiceModel.WSMODE_PWS :
				return "PT_WebService_Profile_MainSettings";
			case WebServiceModel.WSMODE_CWS :
				return "PT_WebService_Crawler_MainSettings";
			case WebServiceModel.WSMODE_SWS :
				return "PT_WebService_Search_MainSettings";
			case WebServiceModel.WSMODE_MWS :
				return "PT_WebService_Migration_MainSettings";
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}

}

