package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class UserInfoDP extends WSPluginDP
{
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "UserInfoDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews()
	{
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_UserInfoPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_AddUserInfoPluginView);

		return xpWSViews;
	}

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1191, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode)
	{
		XPArrayList xpWSViews = new XPArrayList();

		switch (nWSMode)
		{
		case WebServiceModel.WSMODE_PORTLET:
		case WebServiceModel.WSMODE_CWS:
		case WebServiceModel.WSMODE_SWS:
			xpWSViews.Add(WebServiceEditorAS.strStorage_UserInfoPluginView);
			xpWSViews.Add(WebServiceEditorAS.strStorage_AddUserInfoPluginView);

			break;

		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
		case WebServiceModel.WSMODE_AWS:
		case WebServiceModel.WSMODE_PWS:
		case WebServiceModel.WSMODE_MWS:
		case WebServiceModel.WSMODE_NONE:default:}

		return xpWSViews;
	}
	
	protected HTMLElement GetHTMLBelowSubHeader() {
		// Specify the additional settings for this Web Service.
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1672,"ptmsgs_portaladminmsgs"),m_asOwner);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PORTLET :
				return "PT_WebService_UserInformation";
			case WebServiceModel.WSMODE_CWS :
				return "PT_WebService_UserInformation";
			case WebServiceModel.WSMODE_SWS :
				return "PT_WebService_UserInformation";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_MWS :
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}

}

