/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class AddSettingsPluginModel extends EditorHelperModel
	implements IAddSettingsPluginModelRO, IWSSubModel
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "AddSettingsPlugin";

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/** URL to the Administrative Prefs (AdditionalSettingsView) */
	private String m_strDisabledMessage = "";

	/** Logging object and booleans */
	/** Radio item that chooses whether this WebService is enabled or not
	 * (AdditionalSettingsView)
	 */
	private boolean m_bEnabledRadio = true;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AddSettingsPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		m_ptWebService.SetDisabledMessage(GetDisabledMessage());
		m_ptWebService.SetEnabled(GetEnabled());
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * Returns the m_strDisabledMessage.
	 *
	 * @return String
	 */
	public String GetDisabledMessage()
	{
		return m_strDisabledMessage;
	}

	/**
	 * Returns the m_nEnabledRadio.
	 *
	 * @return int
	 */
	public boolean GetEnabled()
	{
		return m_bEnabledRadio;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;
		
		WebServiceModel mParent = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);

		// Initialize ourselves
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == mParent.GetEditorType())
		{
			String strDefaultDisabledMessage = m_asOwner.GetString(2510, "ptmsgs_portaladminmsgs");
			switch (mParent.GetWSMode())
			{
				case WebServiceModel.WSMODE_AWS:
					strDefaultDisabledMessage = m_asOwner.GetString(2505, "ptmsgs_portaladminmsgs");
					break;
				case WebServiceModel.WSMODE_CWS:
					strDefaultDisabledMessage = m_asOwner.GetString(2506, "ptmsgs_portaladminmsgs");
					break;
				case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
				case WebServiceModel.WSMODE_PORTLET:
					strDefaultDisabledMessage = m_asOwner.GetString(2507, "ptmsgs_portaladminmsgs");
					break;
				case WebServiceModel.WSMODE_PWS:
					strDefaultDisabledMessage = m_asOwner.GetString(2508, "ptmsgs_portaladminmsgs");
					break;
				case WebServiceModel.WSMODE_SWS:
					strDefaultDisabledMessage = m_asOwner.GetString(2509, "ptmsgs_portaladminmsgs");
					break;
				case WebServiceModel.WSMODE_NONE:
				default:
					break;				
			}
			SetDisabledMessage(strDefaultDisabledMessage);
		} else
		{
			SetDisabledMessage(ptWebService.GetDisabledMessage());
		}		
		SetEnabled(ptWebService.GetEnabled());
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		SetEnabled(WSModelHelper.GetFormElementBool(_htFormData,
				AddSettingsPluginView.HTMLRADIO_ENABLED, m_bEnabledRadio));
		SetDisabledMessage(WSModelHelper.GetFormElementString(_htFormData,
				AddSettingsPluginView.HTMLINPUT_DISABLED_TEXT,
				m_strDisabledMessage));

		return RepostControl.PAGE_STATUS_VALID;
	}

	/**
	 * Sets the m_strDisabledMessage.
	 *
	 * @param strDisabledMessage The strDisabledMessage to set
	 */
	public void SetDisabledMessage(String strDisabledMessage)
	{
		//MES- CR: Is there any max length for the disabled message?
		//AGC- This is enforced by the maxlength set on the UI input.    	
		if (null == strDisabledMessage)
		{
			m_strDisabledMessage = "";
		}
		else
		{
			m_strDisabledMessage = XPHttpUtility.HtmlEncode(strDisabledMessage);
		}
	}

	/**
	 * Sets the m_nEnabledRadio. Value must be WS_ENABLED or WS_DISABLED (will
	 * silently set value to WS_DISABLED if out of range.
	 *
	 * @param nEnabledRadio The nEnabledRadio to set
	 */
	public void SetEnabled(boolean bEnabledRadio)
	{
		m_bEnabledRadio = bEnabledRadio;
	}
}

