/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class AssocObjectsPluginModel extends EditorHelperModel
	implements IAssocObjectsPluginModelRO, IWSSubModel
{
	public static final String STR_MVC_CLASS_NAME = "AssocObjectsPlugin";

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/**
	 * WSMode setting. We use this to determine which checkboxes to display
	 * and store.
	 */
	private int m_nWSMode;

	public AssocObjectsPluginModel()
	{
		super();
		m_nWSMode = WebServiceModel.WSMODE_NONE;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AssocObjectsPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
		m_nWSMode = nNewWSMode;
	}

	/**
	 * Gets Objects Associated with the current object. Only works for Portlets and Web Services. 
	 *
	 * @param nCLASSID The classid of the objects to return
	 *
	 * @return IASQueryResult
	 */
	public IASQueryResult GetAssocObjects(int nCLASSID)
	{
		WebServiceModel mParent = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);

		if (EditorStartControl.EDITOR_START_FLAG_CREATE == mParent.GetEditorType())
		{
			return null;
		}
		else
		{
			IPTSession ptSession			  = mParent.GetPTSession();
			IPTObjectManager ptObjectManagers = (IPTObjectManager) ptSession.GetObjectManagers(nCLASSID);
			PTObjectManagerQueryWrapper omqr  = new PTObjectManagerQueryWrapper(ptObjectManagers);

			IPTServerContext ptSCRemoteServer = (IPTServerContext) m_ptWebService.GetInterfaces(
					"IPTServerContext");

			//MES-: So you're querying for all the objects with the given WebServiceID?  What if the
			//	classid passe in in nCLASSID doesn't correspond to an object that has PT_PROPID_GADGET_WEBSERVICEID?			
			// Query filter
			//AGC-: It fail. This method will only work for portlets and portlet templates. To expand this to work with
			//crawlers and other objects would require significant server changes (the addition of new queries). 
			Object[][] ptqf = new Object[3][1];
			
			switch (nCLASSID) {
				case PT_CLASSIDS.PT_GADGET_ID :
				case PT_CLASSIDS.PT_GADGETTEMPLATE_ID :
					ptqf[0][0]     = new Integer(PT_PROPIDS.PT_PROPID_GADGET_WEBSERVICEID);
					break;
				case PT_CLASSIDS.PT_AUTHSOURCE_ID :
					ptqf[0][0]     = new Integer(PT_PROPIDS.PT_PROPID_AUTHSOURCE_WEBSERVICEID);
					break;
				case PT_CLASSIDS.PT_DATASOURCE_ID :
					ptqf[0][0]     = new Integer(PT_PROPIDS.PT_PROPID_DS_WEBSERVICEID);
					break;
				case PT_CLASSIDS.PT_FEDERATEDPORTAL_ID :
					ptqf[0][0]     = new Integer(PT_PROPIDS.PT_PROPID_FEDERATEDPORTAL_WEBSERVICEID);
					break;
				case PT_CLASSIDS.PT_PROFILESOURCE_ID :
					ptqf[0][0]     = new Integer(PT_PROPIDS.PT_PROPID_PROFILESOURCE_WEBSERVICEID);
					break;

			}
			ptqf[1][0]     = new Integer(PT_FILTEROPS.PT_FILTEROP_EQ);
			ptqf[2][0]     = new Integer(ptSCRemoteServer.GetObjectID());
			omqr.Query(-1, -1, null, ptqf);

			return omqr;
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		return RepostControl.PAGE_STATUS_VALID;
	}
}

