/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 */
public class HTTPSettingsPluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.HTTPSettingsPluginView");

	/** This object's name */
	public static final String STR_MVC_CLASS_NAME = "HTTPSettingsPluginView";

	
	/**
	 * The name of our validation function. This must be added by the Page to the
	 * page level validation function. See WSPluginDP for details.
	 */
	public static final String VALIDATION_FUNCTION_NAME = "IsValidHTTPSettings";

	/** Logging stuff */
	public static final String HTMLINPUT_PORTLET_URL			 = "in_tx_PortletURL";
	public static final String HTMLINPUT_TIMEOUT_DURATION		 = "in_tx_Timeout";
	public static final String HTMLSELECT_TIMEOUT_UNITS			 = "in_se_TimeoutUnits";
	public static final String HTMLINPUT_TIMEOUT_GATEWAYDURATION = "in_tx_GatewayTimeout";
	public static final String HTMLSELECT_TIMEOUT_GATEWAYUNITS = "in_se_GatewayTimeoutUnits";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new HTTPSettingsPluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1094, "ptmsgs_portaladminmsgs")));
 
 			myTable = WSViewHelper.AddTable(result);
 			
 			
			// 1st row begins (Top Margin)
			WSViewHelper.AddEmptyRow(myTable, "5");

			// 1st row ends
			// 2 - 3rd rows
			String strBaseURL = ((IHTTPSettingsPluginModelRO) m_model).GetBaseURL();
			String strDefault = ((IHTTPSettingsPluginModelRO) m_model).GetPortletURL();

			WSViewHelper.AddSimpleEditBox(myTable, 5,
				m_asOwner.GetString(1095, "ptmsgs_portaladminmsgs"),
				strBaseURL, strDefault, HTMLINPUT_PORTLET_URL);

			// 4.5th row... spacer
			WSViewHelper.AddEmptyRow(myTable, "5");

			//////// Portlet Timeout
			PTDuration ptdDefault = ((IHTTPSettingsPluginModelRO) m_model).GetPortletDuration();
			WSViewHelper.AddSimpleDurationCombo(myTable, 5,
				m_asOwner.GetString(1097, "ptmsgs_portaladminmsgs"),
				HTMLINPUT_TIMEOUT_DURATION, HTMLSELECT_TIMEOUT_UNITS, ptdDefault, m_asOwner);

			//////// GATEWAY Timeout
			ptdDefault = ((IHTTPSettingsPluginModelRO) m_model).GetGatewayDuration();
			WSViewHelper.AddSimpleDurationCombo(myTable, 5,
				m_asOwner.GetString(1098, "ptmsgs_portaladminmsgs"),
				HTMLINPUT_TIMEOUT_GATEWAYDURATION, HTMLSELECT_TIMEOUT_GATEWAYUNITS, ptdDefault, m_asOwner);

			// 11th row begins
			WSViewHelper.AddEmptyRow(myTable, "5");
		}
		catch (Exception e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1096,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript script  = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
		XPStringBuilder sb = new XPStringBuilder(300);

		try
		{
			sb.Append("\n" + "function " + VALIDATION_FUNCTION_NAME + "()\n");
			sb.Append("{\n");

			WebServiceModel mParent = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);

			if (WebServiceModel.WSMODE_PORTLET == mParent.GetWSMode())
			{
				sb.Append(WSViewHelper.ValidateNumericInputJS(
						WSPluginDP.HTMLFORM_NAME,
						HTTPSettingsPluginView.HTMLINPUT_TIMEOUT_DURATION,
						m_asOwner.GetString(1099, "ptmsgs_portaladminmsgs")));

				sb.Append(WSViewHelper.ValidateNumericInputJS(
						WSPluginDP.HTMLFORM_NAME,
						HTTPSettingsPluginView.HTMLINPUT_TIMEOUT_GATEWAYDURATION,
						m_asOwner.GetString(1100, "ptmsgs_portaladminmsgs")));
			}

			sb.Append(" 	return true;\n");
			sb.Append("}\n\n");

			script.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			log.Error(he.getMessage());
		}

		return script;
	}

	/**
	* @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	*/
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
}

