package com.plumtree.portalpages.admin.serversettings.general;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author $author$
 */
public class UserSettingsDP extends EditorDP {
	// ***CHANGE_HERE*** Set the class name.
	// COMMENT1- All the DPs in your AS need to have a unique name.

	
	public static final String STR_MVC_CLASS_NAME = "SetServerSettingsDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(1348, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader(){
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2962, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(NewUserCreationView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(NumericAuthenticationView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(AccountLockingView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		/* JHQ bug 25352: Doc Team says to remove this view because it is not
		 * accurate.  I will not delete the class, since we may change our mind
		 * in the future.  For now I'll just comment this out. */
//		 views.AddInnerHTMLElement(
//			((EditorView) m_asOwner
//				.GetView(DefaultLanguageSettingsView.STR_MVC_CLASS_NAME))
//				.Display());
//
//		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(UpdateLoginTokenKeyView.STR_MVC_CLASS_NAME))
				.Display());
		
		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(DebuggingModeView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(AccountLockingView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());

		return myScripts;
	}

	// ***CHANGE_HERE*** This method is optional. 
	//      You can implement it if you want to display some HTML in the head.
	//		If that method exists the framework will automatically call it
	//      and the HTML returned will get displayed in the head tag.
	//      WARNING: META and LINK tags only should be returned.

	/*public HTMLElementCollection DisplayHTMLinHEAD() throws HTMLException
	{
	    HTMLElementCollection myHTMLinHead = new HTMLElementCollection();
	    // ***CHANGE_HERE*** Add your HTML to the myHTMLinHead HTML collection.
	
	    return(myHTMLinHead);
	}*/

	// ***CHANGE_HERE*** This method is optional. 
	//      You can implement it if you want to display some HTML after 
	//      the BODY tag and before the FORM tag.
	//		If that method exists, the framework will automatically call it.
	//      E.g.: DIV tags should go in that method.

	/*public HTMLElementCollection DisplayHTMLBeforeForm() throws HTMLException
	{
	    HTMLElementCollection myHTMLBeforeForm = new HTMLElementCollection();
	    // ***CHANGE_HERE*** Add your HTML to the myHTMLBeforeForm HTML collection.
	
	    return(myHTMLBeforeForm);
	}*/
}

