package com.plumtree.portalpages.admin.serversettings.search;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author OlegS
 */
public class SearchServerSettingsEditorDP extends EditorDP {
	
	public static final String STR_MVC_CLASS_NAME =
		"SearchServerSettingsEditor";

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElementCollection DisplayHTMLBeforeForm() {
		
		ISearchServerSettingsEditorModelRO ptROModel = (ISearchServerSettingsEditorModelRO) m_asOwner.GetModel(STR_MVC_CLASS_NAME);

		return ptROModel.GetDateTimePickerControlManager().GetPagePreFormContent();
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElementCollection GetDatePickerScripts() {
		AActivitySpace asOwner = GetOwner();

		HTMLElementCollection retVal = new HTMLElementCollection();
		JSDateTimePickerMgr ptDatePickerMgr = ((ISearchServerSettingsEditorModelRO)m_asOwner.GetModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME)).GetDateTimePickerControlManager();
			retVal.AddInnerHTMLElement(ptDatePickerMgr.GetJSIncludes());
		
		return retVal;
	}

	public String GetLeftNavString() {
		return (m_asOwner.GetString(154, "ptmsgs_portalcommonmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1640, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElement PageDisplay()  {
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(SearchServerSettingsEditorView.STR_MVC_CLASS_NAME))
				.Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		/* EDITOR WITH NO HEADER AND NO LEFT NAV?
		 * Replace the code above with the 2 lines bellow:
		 * HTMLElementCollection result = new HTMLElementCollection(); result.
		 * AddInnerHTMLElement(((EditorView)m_asOwner.GetView
		 * (SearchServerSettingsEditorView.STR_MVC_CLASS_NAME)).Display());
		 */
		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(SearchServerSettingsEditorView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());
		myScripts.AddInnerHTMLElement(GetDatePickerScripts());
		return myScripts;
	}

}

