package com.plumtree.portalpages.browsing.gateway;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author daniilk
 *
 */
public class GatewayReturnDP implements IDisplayPage
{
	
	public static String STR_MVC_CLASS_NAME = "GatewayReturn";
	private AActivitySpace m_asOwner	    = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display(IWebData)
	 */
	public void Display(IWebData webData)
	{
		IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.strModelName);
		String strRawHeaders = gwModel.GetHeaders();

		webData.SetStatus(gwModel.GetStatus());
		
		if (null != strRawHeaders)
		{
			GatewayUtils.AddHeadersToResponse(strRawHeaders, webData);
		}

		webData.SetData(gwModel.GetBinaryBody());

		return;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetParent()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return null;
	}
}

