package com.plumtree.portalpages.browsing.portalsettings.password;

import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author DonH
 *
 * This activity space lets you change your password.
 */
public class PasswordAS extends PTEditorAS
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "ChangePassword";

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()
	 */
	public String GetEditorTitle()
	{
		return GetString(1305, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PasswordAS();
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = PasswordModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Register DisplayPages
		PasswordDP passwordDP = new PasswordDP();
		RegisterPage(passwordDP);

		// Default page
		SetCurrentPage(PasswordDP.STR_MVC_CLASS_NAME);

		// Register Views
		RegisterView(PasswordView.STR_MVC_CLASS_NAME, myModel);

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1305, "ptmsgs_portalbrowsingmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			PasswordDP.STR_MVC_CLASS_NAME);
			
		this.SetHelpTopic( "PT_ChangePassword_MainSettings" );
		
		// register the javascript handler for password validation
		passwordDP.AddToValidationFunction("CheckPassword");
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		// make sure this is not the guest user
		boolean isGuest = PlumtreeHelpers.IsGuestSession(this);
		if (isGuest)
			return false;

		// Only allow user to change password if user is not synced
		// to an auth source
		if (((IPTSession) GetUserSession()).GetUser().GetAuthenticationSourceID()
			!= PT_INTRINSICS.PT_AUTHSOURCE_PLUMTREE)
		{
			return false;
		}

		return true;
	}	
}

