package com.plumtree.portalpages.browsing.portalsettings.password;

import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author DonH
 *
 * This page displays the basic change password page.
 */
public class PasswordDP extends EditorDP
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "ChangePassword";

	
	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1305, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(m_asOwner.GetView(
				PasswordView.STR_MVC_CLASS_NAME).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = null;
		if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
		{
			myScripts = super.DisplayJavaScriptFromChild();
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				PasswordView.STR_MVC_CLASS_NAME).DisplayJavascript());
		}

		return myScripts;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLElement GetHTMLBelowSubHeader()

	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;

		myTable = new HTMLTable();
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");
		myTable.SetSummary(m_asOwner.GetString( 1611, "ptmsgs_portalbrowsingmsgs"));

		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

		// display sub header message
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		mySpan.AddInnerHTMLString(m_asOwner.GetString(1289, "ptmsgs_portalbrowsingmsgs"));

		return myTable;
	}
}

