package com.plumtree.portalpages.browsing.search.advanced;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class ASFooterView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.search.advanced.ASFooterView");

	
	public static final String STR_MVC_CLASS_NAME = "ASFooter";

	// Strings to localize.
	// HTML inputs

	
	public static final String HTMLINPUT_RESET_BUTTON = "in_bu_reset";
	protected AActivitySpace m_asOwner = null;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new ASFooterView();
	}

	/**
	 * Returns the HTML for the Section.
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElement result = new HTMLElementCollection();

		try
		{
			// Make an URL for a brand-new advanced search space.
			ASURL newAS = new ASURL(m_asOwner);
			newAS.SetLinkCreateNewSpace(AdvancedSearchAS.STR_MVC_CLASS_NAME,
				m_asOwner);
			newAS.SetControl("EditorStart");
			newAS.AddControlArgument("editorType", "10");

			String url = newAS.GetURLAsString();

			// Make a reset button.
			HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON,
					HTMLINPUT_RESET_BUTTON, "");

			button.SetValue(m_asOwner.GetString(783, "ptmsgs_portalbrowsingmsgs"));
			button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			button.SetOnClick("window.location.href='" + url + "';");

			result.AddInnerHTMLElement(button);
		}
		catch (Exception e)
		{
			
				log.Error(m_asOwner.GetString(782, "ptmsgs_portalbrowsingmsgs"));
			

			throw new XPException(m_asOwner.GetString(782,
					"ptmsgs_portalbrowsingmsgs"), e);
		}

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param model 
	 * @param parent 
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asOwner = parent;
	}
}

