package com.plumtree.portalpages.browsing.sitemap.sitemappage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: DisplayInPortletControl.java
 * -------------------------------------
 *
 * @author NaveenP
 */
public class DisplayInPortletControl extends RepostControl
{
	
	public static final String STR_MVC_CLASS_NAME = "DisplayInPortlet";

	
	public static String QS_FOLDERID	  = "FOLDERID";

	
	public static String QS_PAGEISLOADING = "PAGEISLOADING";

	
	public static String QS_COMMUNITYID = "COMMUNITYID";

	
	public static int POSTTOSELF_ACTION_SORT = 24;

	/** Activity Space */
	private AActivitySpace m_asOwner;

	/** model */
	private SiteMapModel m_asModel;

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] sValues;

		int nPageIsLoading = 0;
		sValues = (String[]) arguments.GetElement(QS_PAGEISLOADING);

		if (sValues != null)
		{
			nPageIsLoading = XPConvert.ToInteger(sValues[0]);
		}

		if (nPageIsLoading != 0)
		{
			sValues = (String[]) arguments.GetElement(QS_COMMUNITYID);

			if (sValues != null)
			{
				try
				{
					m_asModel.SetCommunityID(XPConvert.ToInteger(sValues[0]));
				}
				catch (Exception e)
				{
				}
			}

			sValues = (String[]) arguments.GetElement(QS_FOLDERID);

			if (sValues != null)
			{
				try
				{
					m_asModel.OpenSubFolder(XPConvert.ToInteger(sValues[0]));
				}
				catch (Exception e)
				{
				}
			}
			else
			{
				m_asModel.OpenSubFolder(-1);
			}
		}

		if (nPageIsLoading == 0)
		{
			super.CheckActionSecurityAndExecute(arguments);

			ClosePopUpDP objDP = (ClosePopUpDP) m_asOwner.GetPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
			HTMLScript script  = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);

			try
			{
				script.AddInnerHTMLString("window.opener." +
					AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" +
					POSTTOSELF_ACTION_SIMPLEREPOST + ");");
			}
			catch (HTMLException he)
			{
			}

			objDP.SetScript(script);

			Redirect redirect = new Redirect();

			try
			{
				redirect.SetLinkGetCachedSpace(m_asOwner);
				redirect.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
			}
			catch (Exception e)
			{
				UIError myError = new UIError(UIErrorLevel.FRIENDLY,
						UIErrorScope.CURRENT_USER, e, e.getMessage(),
						e.getMessage());
				UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(),
					m_asOwner.GetApplication());
			}

			return redirect;
		}
		else
		{
			return null;
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DisplayInPortletControl();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,
	 *      AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		super.Init(model, space);
		m_asModel     = (SiteMapModel) model;
		m_asOwner     = space;
	}

	/**
	 * Given the repost action mode, calls the associated method in the model.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
			/*case POSTTOSELF_ACTION_SORT:

			break;
			*/

			// JF: Do not add a default case because sub classes will extend this one and add their own action modes.
		}
	}
}

