package com.plumtree.portalpages.browsing.unsubscribe.communities;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.errordisplay.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MyCommunitiesListView extends ExpListView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.unsubscribe.communities.MyCommunitiesListView");

	
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "MyCommunitiesListView";
	
	public static final String HTMLBUTTON_DONE   = "in_bu_Done";
	public static final String HTMLBUTTON_CANCEL = "in_bu_Cancel";

	
	UnsubscribeCommunitiesAS m_asOwner;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MyCommunitiesListView();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Inits the Model with the IPTSession.
	 *
	 * @param parent
	 */
	public void Init(IModelRO _model, AActivitySpace parent)
	{
		super.Init(_model, parent);
		
		m_asOwner = (UnsubscribeCommunitiesAS) parent;

		m_model = _model;
	}

	/**
	 * Returns the HTML for the Action bar.
	 * (The one with the add icons).
	 * copied from JulieF's ExpListView but got rid of the delete Action cause invitation
	 * instances can't be deleted.
	 *
	 * @return HTMLTable
	 * @throws Exception
	 */
	protected HTMLTable GetHTMLForActionBar()
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		myTable = new HTMLTable();
		myTable.SetBorder("0");
		myTable.SetCellPadding("0");
		myTable.SetCellSpacing("0");
		
		// 1st Row begin (there is only one row)
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		
		// Add icon cell
		myRow.AddInnerHTMLElement(GetHTMLForUnsubscribeAction());

		// Empty Cell
		myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
		
		// Add Extra HTML to the action bar (like a "create" button)
		AddHTMLToActionBar(myRow);

		// Last Empty Cell
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetAutoFit(true);
		myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myCell.SetHeight("25");
		myCell.AddInnerHTMLString(SPACE);

		// 1st Row ends
		return myTable;
	}

	/**
	 * Returns the HTML for the unsubscribe cell in the action bar.
	 *
	 * @return HTMLTableCell
	 * @throws Exception
	 */
	protected HTMLTableCell GetHTMLForUnsubscribeAction()
	{
		HTMLTableCell myCell;
		PTConstruct myConstruct;
		HTMLImg myImage;
		HTMLAnchor myAnchor;
		HTMLSpan mySpan;

		myCell = new HTMLTableCell();
		myCell.SetHeight("25");
		myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
		myCell.SetNoWrap(true);
		myCell.AddInnerHTMLString(SPACE);

		// Add icon
		myConstruct     = UIConstructFactory.GetConstruct(((IExpListModelRO) m_model).GetAddIcon(),
				true, this.m_asOwner);
		myImage		    = (HTMLImg) myConstruct.GetHTMLElement();
		myImage.SetAlt("");
		myImage.SetAlign("absmiddle");

		myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
		if (0 != ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount()) {
			myAnchor.SetOnClick(((IExpListModelRO) m_model).GetUniqueString(
					"DeleteRows") + "(); return false;");
		}
		myAnchor.AddInnerHTMLElement(myImage);
		mySpan = new HTMLSpan();
		myAnchor.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);

		// Add label
		mySpan.AddInnerHTMLString(((IExpListModelRO) m_model).GetAddLabel());
		mySpan.AddInnerHTMLString(SPACE);
		mySpan.AddInnerHTMLString(SPACE);
		myCell.AddInnerHTMLElement(myAnchor);
		myCell.AddInnerHTMLString(SPACE);

		return myCell;
	}
	
	/**
	 * Returns the HTML for the row _nRowIndex.
	 *
	 * @param _saData
	 * @param _nRowIndex
	 *
	 * @return HTMLTableCell
	 * @throws Exception
	 */
	protected HTMLTableCell GetHTMLForNameColumn(
		IPTGrowableSortedArrayWrapperRO _saData, int _nRowIndex)
	{
		HTMLTableCell myCell;

		myCell = new HTMLTableCell();
		myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myCell.SetHeight("30");
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
		myCell.SetNoWrap(true);
		myCell.AddInnerHTMLString(SPACE);
		
		// Object Name
		String sPTObjectName = (String) _saData.GetItem(_nRowIndex,
				MyCommunitiesListModel.COMMLIST_COL_NAME);
				
		if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
		{
			// row icon
			HTMLImg myImage;
			PTConstruct myConstruct;
	
			myConstruct     = UIConstructFactory.GetConstruct(PTImageType.ICON_COMMUNITY, true,
					this.m_asOwner);
			myImage		    = (HTMLImg) myConstruct.GetHTMLElement();
			myImage.SetAlt(m_asOwner.GetString(701, "ptmsgs_portalbrowsingmsgs"));
			myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
	
			myCell.AddInnerHTMLElement(myImage);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
	
			myCell.AddInnerHTMLString(SPACE);
			myCell.AddInnerHTMLEncodedString(sPTObjectName);
			
			if (!((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
			{
				myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
				HTMLSpan mySpan = new HTMLSpan();
				myCell.AddInnerHTMLElement(mySpan);
				mySpan.SetStyleClass(PTStyleClass.LIST_NEW_TEXT);
				mySpan.AddInnerHTMLString(m_asOwner.GetString(1661, "ptmsgs_portalbrowsingmsgs"));
			}
		} else {
			myCell.AddInnerHTMLEncodedString(sPTObjectName);
			myCell.AddInnerHTMLElement(new HTMLBr());
			
			// DCA - only display unsubscribe link if user has free membership to community
			if (((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
			{
				ASURL myAsurl = ((AFormDP) m_asOwner.GetCurrentPage()).Get508RepostURL(UnsubscribeCommunitiesRepostControl.POSTTOSELF_508_ACTION_DELETE);
				myAsurl.AddControlArgument(UnsubscribeCommunitiesRepostControl.ROW_TO_DELETE, _nRowIndex);
				myAsurl.AddInnerHTMLString(XPResourceManager.FormatMessage(m_asOwner.GetString(1271, "ptmsgs_portalbrowsingmsgs"), 
					XPHttpUtility.HtmlEncode(sPTObjectName)));
				myCell.AddInnerHTMLElement(myAsurl.GetURLAsHTMLElement());
			}
		}

		return myCell;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForCheckBox(int)
	 */
	protected HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)
	{
		if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD &&
			((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
		{
			// DCA - only display checkbox if user has free membership to community
			return super.GetHTMLForCheckBox(_nRowIndex);
		}
		else
		{
			HTMLTableCell myCell = new HTMLTableCell();
			myCell = new HTMLTableCell();
			myCell.SetHeight("30");
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			myCell.SetVAlign(CommonHTMLStrings.MIDDLE);
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
	
			return (myCell);
		}
	}
	
	/**
	 * Returns the HTML for the row _nRowIndex.
	 * Each row contains just an icon and input text.
	 *
	 * @param _saData
	 * @param _nRowIndex
	 *
	 * @return HTMLElement
	 * @throws Exception
	 */
	public HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
		int _nRowIndex)
	{
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(GetHTMLForNameColumn(_saData, _nRowIndex));

		return result;
	}
	
	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection myResult = new HTMLElementCollection();

		try
		{
			myResult.AddInnerHTMLElement(super.Display());

			//	add the error display view.
			myResult.AddInnerHTMLElement(this.m_asOwner.GetView(
					ErrorView.STR_MVC_CLASS_NAME).Display());
		}
		catch (Exception e)
		{
			
				log.Error(e, "MyCommunitiesListView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1545, "ptmsgs_portalbrowsingmsgs"), e);
		}

		return myResult;
	}
	
	/**
	 * Returns Java Script for goToPage function.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = null;
		myScript = new HTMLScript("text/javaScript");

		try
		{
			XPStringBuilder sb;
	
			// JavaScript alert try to unsubscribe mandatory communities
			if (((IMyCommunitiesListModelRO) m_model).displayAllMandatoryAlert()) {
				sb = new XPStringBuilder(100);
				sb.Append("alert('" +
					m_asOwner.GetString(2360, "ptmsgs_portaladminmsgs") +
					"');");
				myScript.AddInnerHTMLString(sb.ToString());
			}
			
			sb = new XPStringBuilder(300);
			
			// JavaScript to sort by column	
			sb.Append("function " +
				((IExpListModelRO) m_model).GetUniqueString("DeleteRows") +
				"()\n");
			sb.Append("{\n");
			sb.Append("  if(0 != " +
				((IExpListModelRO) m_model).GetUniqueString("CountCheckedRows") +
				"()) \n");
			sb.Append("  {\n");
			sb.Append("    postToSelf(" +
				UnsubscribeCommunitiesRepostControl.POSTTOSELF_ACTION_DELETE + ");\n");
			sb.Append("  }\n");
			sb.Append("  else\n");
			sb.Append("  {\n");

			sb.Append("    alert('" +
				m_asOwner.GetString(60, "ptmsgs_infrastructure") + "');\n");
			sb.Append("  }\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(300);

			// JavaScript to return the number of checked rows.
			sb.Append("function " +
				((IExpListModelRO) m_model).GetUniqueString("CountCheckedRows") +
				"()\n");
			sb.Append("{ \n");
			sb.Append("  var frm = document." + UnsubscribeCommunitiesDP.HTMLFORM_NAME +
				"; \n");
			sb.Append("  var len = frm.elements.length; \n");
			sb.Append("  var nValue = frm." +
				((IExpListModelRO) m_model).GetUniqueString(
					HTMLCHECKBOX_CHECKALL) + ".checked; \n");
			sb.Append("  var i = 0; \n");
			sb.Append("  var nTotal = 0; \n");
			sb.Append("  \n");
			sb.Append("  for(i=0 ; i<len ; i++) \n");
			sb.Append("  { \n");
			sb.Append("    if (frm.elements[i].name == '" +
				((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW) +
				"') \n");
			sb.Append("    { \n");
			sb.Append("       if (frm.elements[i].checked) \n");
			sb.Append("       { \n");
			sb.Append("          nTotal++; \n");
			sb.Append("       } \n");
			sb.Append("    } \n");
			sb.Append("  } \n");
			sb.Append("  return (nTotal);\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(300);

			// JavaScript to check all the rows
			sb.Append("function " +
				((IExpListModelRO) m_model).GetUniqueString("CheckRows") +
				"()\n");
			sb.Append("{ \n");
			sb.Append("  var frm = document." + UnsubscribeCommunitiesDP.HTMLFORM_NAME +
				"; \n");
			sb.Append("  var len = frm.elements.length; \n");
			sb.Append("  var nValue = frm." +
				((IExpListModelRO) m_model).GetUniqueString(
					HTMLCHECKBOX_CHECKALL) + ".checked; \n");
			sb.Append("  var i = 0; \n");
			sb.Append("  \n");
			sb.Append("  for(i=0 ; i<len ; i++) \n");
			sb.Append("  { \n");
			sb.Append("    if (frm.elements[i].name == '" +
				((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW) +
				"') \n");
			sb.Append("    { \n");
			sb.Append("       frm.elements[i].checked = nValue;\n");
			sb.Append("    } \n");
			sb.Append("  } \n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());

			String sEmptyListAlert = ((IExpListModelRO) m_model).GetAlertMessageForEmptyList();

			if (null != sEmptyListAlert)
			{
				sb = new XPStringBuilder(300);

				// JavaScript to check if the list is not empty	
				// JF- Note that this method is not called anywhere in the framework. 
				// It has to be registered as a validation function inside the Editor
				sb.Append("function " +
					((IExpListModelRO) m_model).GetUniqueString(
						"CheckEmptyList") + "()\n");
				sb.Append("{\n");
				sb.Append("  \n");

				if (0 == ((IExpListModelRO) m_model).GetReadOnlyItems()
						.GetCount())
				{
					sb.Append("  alert(\"" + sEmptyListAlert + "\"); \n");
					sb.Append("  return false;\n");
				}
				else
				{
					sb.Append("  return true;\n");
				}

				sb.Append("}\n");

				myScript.AddInnerHTMLString(sb.ToString());
			}
		}
		catch (Exception e)
		{
			
				log.Error(e, "ExpListView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(53,
					"ptmsgs_infrastructure"), e);
		}

		return myScript;
	}

}

