package com.plumtree.portalpages.portlets.userprofile.infrastructure;

import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author chrisb To change this generated comment edit the template variable
 *         "typecomment": Window>Preferences>Java>Templates. To enable and
 *         disable the creation of type comments go to
 *         Window>Preferences>Java>Code Generation.
 */
public final class ProfileCell implements IProfileCell
{
	private HTMLAnchor m_anchor;
	private HTMLImg m_Img;
	private String m_mouseover;
	private String m_onClick;
	private String m_subtext;
	private String m_text;
	private boolean m_isHTML;
	private boolean m_isImg;

	/**
	 * Constructs a ReferenceProfileCell and sets the text, mouseover,  URI and
	 * isHTML properties.
	 *
	 * @param text The text to display in this ProfileCell.
	 * @param subtext The text that will be displayed below the main text of
	 *        the cell
	 * @param mouseover The description of this ProfileCell to display as a
	 *        mouseover.
	 * @param Anchor action for the profile cell if the URI is set.
	 * @param isHTML Whether or not this ProfileCell contains markup.
	 */
	public ProfileCell(String text, String subtext, String mouseover,
		HTMLAnchor Anchor, boolean isHTML)
	{
		m_text		    = text;
		m_mouseover     = mouseover;
		m_isHTML	    = isHTML;
		m_subtext	    = subtext;
		m_anchor	    = Anchor;
		m_isImg		    = false;
		m_Img		    = null;
	}

	/**
	 * Constructs a Profile Cell and sets it as an image.  This needs to be
	 * handled differently in order for the upper most HTMLElementCollection
	 * to be able to retrieve the image server URL.
	 *
	 * @param Image
	 */
	public ProfileCell(HTMLImg Image)
	{
		m_text		    = "";
		m_mouseover     = "";
		m_isHTML	    = false;
		m_subtext	    = "";
		m_onClick	    = "";
		m_anchor	    = null;
		m_isImg		    = true;
		m_Img		    = Image;
	}

	/**
	 * @see com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#isHTML()
	 */
	public boolean isHTML()
	{
		return m_isHTML;
	}

	/**
	 * @see com.plumtree.portlets.introspective2.IProfileCell#isImg()
	 */
	public boolean isImg()
	{
		return m_isImg;
	}

	/**
	 * @see com.plumtree.portlets.introspective2.IProfileCell#GetOnClickAction()
	 */
	public HTMLAnchor GetHTMLAnchor()
	{
		return m_anchor;
	}

	/**
	 * @see com.plumtree.portlets.introspective2.IProfileCell#GetImage()
	 */
	public HTMLImg GetImage()
	{
		return m_Img;
	}

	/**
	 * @see com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#getMouseOver()
	 */
	public String GetMouseOver()
	{
		return m_mouseover;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetSubText()
	{
		return m_subtext;
	}

	/**
	 * @see com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#getText()
	 */
	public String GetText()
	{
		return m_text;
	}
}

