package com.plumtree.portalpages.rest;

/**
 * This class enumerates the common errors generated by the portal Rest APIs.
 * 
 * 1000 - 1999 is reserved for common errors.
 */
public class CommonRestErrors extends ARESTErrors implements IRESTError
{
	// TODO: how do we document this?  Do people just look it up in code, or do we make a page
	// for it manually?  Javadocs?  Plus we need to doc the whole REST API.

	public static final IRESTError GENERAL = new CommonRestErrors(1000, "Unable to process request.");
	public static final IRESTError NOT_LOGGED_IN = new CommonRestErrors(1010, "The current user does " +
		"not have access to this API.");
	public static final IRESTError NOT_POST = new CommonRestErrors(1020, "This API only supports POSTs.");
	public static final IRESTError NO_POST_CONTENT = new CommonRestErrors(1030, "No POST content found.");
	public static final IRESTError NO_JSON_POST_CONTENT = new CommonRestErrors(1031, "JSON data not found " +
		"in POST content.");

	private CommonRestErrors(int _nCode, String _strMessage)
	{
		super(_nCode, _strMessage);
	}
}