using System;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework
{
  /// <author>John Osborne</author>
  public interface IProvInfo
  {
    
    /// <summary>
    /// Returns a boolean that tells the client if this provider 
    /// should appear in the main create new object menu.
    /// </summary>
    /// <returns>
    /// A boolean that tells the client if this provider 
    /// type should appear in the main create new object menu.
    /// </returns>
    bool AppearsInMainCreateNewClassMenu();
    
    /// <returns></returns>
    int[] GetArrayOfClassIDsRelatedTo();
    
    /// <returns></returns>
    String GetBinFileName();
    
    /// <param name="_strLangID"></param>
    /// <param name="__nClassID"></param>
    /// <returns></returns>
    String GetProviderAndClassLocalizedName(String _strLangID, int _nClassID);
    
    /// <returns></returns>
    String GetProviderCLSID();
    
    /// <returns></returns>
    String GetProviderEnglishName();
    
    /// <param name="_strLangID"></param>
    /// <returns></returns>
    String GetProviderLocalizedName(String _strLangID);
    
    /// <param name="_nClassIDToCreate"></param>
    /// <returns></returns>
    ClassIDProvCLSIDPair RequiresObjectChoiceOnStart(int _nClassIDToCreate);
    }
}