using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.search
{
  /// <author>
  /// CraigS
  /// This is a search control that does nothing except the behavior
  /// implicit in its superclass (i.e. reconstructing a model if necessary).
  /// </author>
  public class NullSearchControl : SearchResultControl
  {
    public const String STR_MVC_CLASS_NAME = "reconstruct";
    
    /// <returns></returns>
    public override Object Create()
    {
      return new NullSearchControl();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.search.SearchResultControl#ExecuteSearchControl()"></seealso>
    protected override Redirect ExecuteSearchControl(XPHashtable args, String key)
    {
      // Just display the page
      return null;
    }
  }
}