using System;
namespace com.plumtree.portaluiinfrastructure.statichelpers
{
  /// <summary>
  /// Static helpers related to debugging/logging.
  /// 1) Provides the component string that is used to
  /// for the component field in PTSpy.
  /// </summary>
  /// <author>RickyW</author>
  public class PTDebugHelpers
  {
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_UI_INFRASTRUCTURE = "Portal_UI_Infrastructure";
    public const String COMPONENT_PORTAL_FRIENDLYURL = "Portal_FriendlyURL";
    public const String COMPONENT_PORTAL_AJAX = "Portal_AJAX";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_ADMIN = "Portal_Admin";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_BROWSING = "Portal_Browsing";
    
    /// <summary>
    /// This component is used for any logging related to the processing of tags from a portlet but
    /// not loading of tag libraries 
    /// </summary>
    public const String COMPONENT_PORTAL_ADAPTIVETAGS = "Portal_Tags";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_COMMON = "Portal_Common";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_DEVICES = "Portal_Devices";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_PORTLETS = "Portal_Portlets";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_PROVIDERS = "Portal_Providers";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_REST = "Portal_REST";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_PORTAL_USERPROFILE = "Portal_UserProfile";
    
    /// <summary>
    /// Returns the string to be used for the component field in PTSpy. 
    /// </summary>
    public const String COMPONENT_GATEWAY = "Gateway";
  }
}