using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portaluiinfrastructure.tree.template
{
  /// <author>michaeld</author>
  public class InheritTemplateModel : IInheritTemplateModelRO,IModel,IRepostModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.browsing.editors.community.templatetree.InheritTemplateModel");
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "InheritTemplate";
    private AActivitySpace m_asOwner;
    private bool m_bInheritTemplate;
    public virtual void ResetInheritTemplate()
    {
      m_bInheritTemplate = true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.page.IInheritPageTempModelRO#IsPageTemplateInherited()"></seealso>
    public virtual bool IsTemplateInherited()
    {
      return m_bInheritTemplate;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new InheritTemplateModel();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IRepostModel#Finish()"></seealso>
    public virtual void Finish()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IRepostModel#GetRedirectAfterFinish()"></seealso>
    public virtual Redirect GetRedirectAfterFinish()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String,com.plumtree.openfoundation.util.XPHashtable)"></seealso>
    public virtual int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      // Get whether the Inherit Page Template checkbox was checked
      bool bInheritTemplate = false;
      String[] astrInheritTemplate = (String[]) _htFormData.GetElement(InheritTemplateView.HTMLBUTTON_CHECKBOX);
      if (null != astrInheritTemplate && 0 != astrInheritTemplate.Length)
      {
        String strInheritTemplate = astrInheritTemplate[0];
        if (null != strInheritTemplate)
        {
          bInheritTemplate = XPConvert.ToBoolean(strInheritTemplate);
        }
      }
      m_bInheritTemplate = bInheritTemplate;
      return RepostControl.PAGE_STATUS_VALID;
    }
  }
}