package com.plumtree.portaluiinfrastructure.tree.template;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author michaeld
 */
public class InheritTemplateModel implements IInheritTemplateModelRO, IModel, IRepostModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.browsing.editors.community.templatetree.InheritTemplateModel");

	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "InheritTemplate";

	private AActivitySpace m_asOwner;
	
	private boolean m_bInheritTemplate;
	
	public void ResetInheritTemplate()
	{
		m_bInheritTemplate = true;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.page.IInheritPageTempModelRO#IsPageTemplateInherited()
	 */
	public boolean IsTemplateInherited()
	{
		return m_bInheritTemplate;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new InheritTemplateModel();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
	 */
	public void Finish()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostModel#GetRedirectAfterFinish()
	 */
	public Redirect GetRedirectAfterFinish()
	{
		return null;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
	 */
	public int SavePage(String _sPageName, XPHashtable _htFormData)
	{
		// Get whether the Inherit Page Template checkbox was checked
		boolean bInheritTemplate = false;
		String[] astrInheritTemplate = (String[]) _htFormData.GetElement(InheritTemplateView.HTMLBUTTON_CHECKBOX);
		if (null != astrInheritTemplate && 0 != astrInheritTemplate.length)
		{
			String strInheritTemplate = astrInheritTemplate[0];
			if (null != strInheritTemplate)
			{
				bInheritTemplate = XPConvert.ToBoolean(strInheritTemplate);
			}
		}
		
		m_bInheritTemplate = bInheritTemplate;
		
		return RepostControl.PAGE_STATUS_VALID;
	}
}
