package com.plumtree.portaluiinfrastructure.mock.helper;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.*;
import com.plumtree.portaluiinfrastructure.helpers.*;
import com.plumtree.portaluiinfrastructure.mock.uiinfrastructure.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.web.*;

public class MockPTConfigHelper extends MockConfigHelper implements IPTConfigHelper   
{
	public XPHashtable m_sections = new XPHashtable();
	public boolean m_bUseAllFriendlyURLs = false;
	public IPTClassTypeDescManager m_classTypeManager;

	public void SetConfigVariable(String _strSection, String _strSubSection, String _strValue)
	{
		XPHashtable section = (XPHashtable) m_sections.GetElement(_strSection);
		if (section == null)
		{
			m_sections.PutElement(_strSection, new XPHashtable());
			section = (XPHashtable) m_sections.GetElement(_strSection);
		}

		section.PutElement(_strSubSection, _strValue);
	}

	public int GetConfigVariableAsInt(String strSection, String strSubSection,
		String strAttribute, AActivitySpace space)
	{
		return XPConvert.ToInteger(((XPHashtable) m_sections.GetElement(strSection)).GetElement(strSubSection));
	}

	public String GetConfigVariableAsString(String strSection,
		String strSubSection, String strAttribute, AActivitySpace space)
	{
		return (String) ((XPHashtable) m_sections.GetElement(strSection)).GetElement(strSubSection);
	}

	public String GetConfigVariableAsString(String strSection,
			String strSubSection, String strAttribute, IApplication app)
	{
		return (String) ((XPHashtable) m_sections.GetElement(strSection)).GetElement(strSubSection);
	}

	public Object[] GetConfigVariables(String strSection, String strSubSection,
			String strAttribute, AActivitySpace space) {
		// TODO Auto-generated method stub
		return null;
	}

	public Object[] GetConfigVariables(String strSection, String strSubSection,
			String strAttribute, IApplication application) {
		// TODO Auto-generated method stub
		return null;
	}

	public IPTClassTypeDescManager GetPTClassTypeDescrManager()
	{
		if (m_classTypeManager != null)
		{
			// Use mock manager if override is set.
			return m_classTypeManager;
		}

		// CR dLH: This is the real code, and it requires you to set up a mock application manager
		// and caching manager.  Since this is a mock object for a test, we should simplify this
		// to just return the appopriate mock object.
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		return (IPTClassTypeDescManager) application.GetCachingManager().GetEntry(AppWarmUp.KEY_CACHEMAN_CLASS_TYPE_MANAGER);
	}

	public boolean UseFriendlyURLS(int classId, String queryStringArgs)
	{
		if (m_bUseAllFriendlyURLs)
		{
			// Use friendly URLs for everything if override is set.
			return true;
		}
		// CR DLH: This is the real code, and it requires you to set up a mock application manager
		// and caching manager.  Since this is a mock object for a test, we should simplify this
		// to just return the appopriate mock object.

		// Friendly URL defined for a particular classId if there are friendly url token defined 
		String res = ((IFriendlyURLManager)PTConfigHelper.GetTypeDescrManager()).LookupFriendlyURLKeyFromClassId(XPConvert.ToString(classId));
		boolean useFriendly = true;
		useFriendly = (res == null) ? false : true;

		// check for specific cases when we shouldn't use friendly URLs
		if ( useFriendly && queryStringArgs != null ) 
		{
			// directory edit mode button, we don't have access to the directory constants since they are defined in portalpages
			// project, DirMode of 2 means edit mode
			if ( queryStringArgs.indexOf("DirMode=2") != -1 ) {
				useFriendly = false;
			}
			
			
		}
		
		return useFriendly;
	}

	public String GetAbsoluteImageServerBaseURL(AActivitySpace _space, String _strRequestURL) {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetAbsoluteImageServerRootURL(AActivitySpace _space, String _strRequestURL) {
		// TODO Auto-generated method stub
		return null;
	}
}