package com.plumtree.portaluiinfrastructure.mock.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Mock search result, for use by mock search results model.  This
 * way a mock result can be made and tested against without actually
 * requiring search to run.
 * 
 * @author smahendr
 */
public class MockSearchResult
{
	private String name = null;
	private HTMLAnchor clickthroughURL = null;
	private HTMLAnchor propertiesURL = null;
	private boolean bIsBestBet = false;
	private String app = null;
	private int classID = 0;
	private int objectID = 0;
	private int folderID = 0;
	private HTMLImg icon = null;
	private String kwic = null;
	private XPDateTime lastModified = null;
	private String contentLastPubUser = null;
	private int[] contentPortletIDs = null;
	
	public MockSearchResult() {
	}
	public void setName(String name) {
		this.name = name;
	}
	public void setClickthroughURL(HTMLAnchor clickthroughURL) {
		this.clickthroughURL = clickthroughURL;
	}
	public void setPropertiesURL(HTMLAnchor propertiesURL) {
		this.propertiesURL = propertiesURL;
	}
	public void setBestBet(boolean bIsBestBet) {
		this.bIsBestBet = bIsBestBet;
	}
	public void setApp(String app) {
		this.app = app;
	}
	public void setClassID(int classID) {
		this.classID = classID;
	}
	public void setObjectID(int objectID) {
		this.objectID = objectID;
	}
	public void setFolderID(int folderID) {
		this.folderID = folderID;
	}
	public void setIcon(HTMLImg icon) {
		this.icon = icon;
	}
	public void setKwic(String kwic) {
		this.kwic = kwic;
	}
	public void setLastModified(XPDateTime lastModified) {
		this.lastModified = lastModified;
	}
	public void setContentLastPubUser(String contentLastPubUser) {
		this.contentLastPubUser = contentLastPubUser;
	}
	public void setContentPortletIDs(int[] contentPortletIDs) {
		this.contentPortletIDs = contentPortletIDs;
	}

	public String getName() {
		return name;
	}
	public HTMLAnchor getClickthroughURL() {
		return clickthroughURL;
	}
	public HTMLAnchor getPropertiesURL() {
		return propertiesURL;
	}
	public boolean isBestBet() {
		return bIsBestBet;
	}
	public String getApp() {
		return app;
	}
	public int getClassID() {
		return classID;
	}
	public int getObjectID() {
		return objectID;
	}
	public int getFolderID() {
		return folderID;
	}
	public HTMLImg getIcon() {
		return icon;
	}
	public String getKwic() {
		return kwic;
	}
	public XPDateTime getLastModified() {
		return lastModified;
	}
	public String getContentLastPubUser() {
		return contentLastPubUser;
	}
	public int[] getContentPortletIDs() {
		return contentPortletIDs;
	}
}
