/*
 * Created on Jan 20, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.server;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the BrowseDirectory PTURL DO Data Tag
  /// </summary>
  /// <author>robertz</author>
  public class BrowseDirectoryDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    public static readonly OptionalTagAttribute FOLDER_ID;
    static BrowseDirectoryDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("directorybrowsedata", COMMON_PRETAGMETADATA_DESC + "URL to Knowledge Directory Folder in Browse Mode (Goes to " + "the root folder if no folder ID is specified). " + COMMON_POSTTAGMETADATA_DESC);
      FOLDER_ID = new OptionalTagAttribute("folderid", "Knowledge Directory Folder ID. If no folder is specified the default folder is the root folder.",
       AttributeType.INT, XPConvert.ToString(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER));
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      int nFolderID = GetTagAttributeAsInt(FOLDER_ID);
      IPTURL url = TaskAPIUIDirectory.GetURLForBrowseDirectory(TaskAPIUICommon.GetEnvTypeObject(env),
       nFolderID);
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new BrowseDirectoryDataTag();
    }
  }
}