/*
 * Created on Nov 30, 2007
 */
 
using System;
using XPArrayList=com.plumtree.openfoundation.util.XPArrayList;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using ATag=com.plumtree.portaluiinfrastructure.tags.ATag;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
using com.plumtree.uiinfrastructure.activityspace;
using AccessStyles=com.plumtree.uiinfrastructure.constants.AccessStyles;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the CurrentCommunityDataTag Data Tag
  /// </summary>
  public class CurrentCommunityDataTag : APTURLDODataTag
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
     typeof(CurrentCommunityDataTag));
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentCommunityDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currcommunitydata", "Returns information about the current community, including a URL to the home page and optionally the " + "Community Name and ID, and the Community Page Name and ID. Returns nothing if user is not on a community page.");
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      AActivitySpace owner = TaskAPIUICommon.GetEnvTypeObject(env);
      if (!TaskAPIUICommunity.IsCurrentPageCommunityPage(owner))
      {
        log.Info("Tag currcommunitydata used on a non-Community page. No data to set to datavar: \'{0}\' in scope \'{1}\'",
         GetTagAttributeAsString(ATTRIB_ID), GetTagAttributeAsString(ATTRIB_SCOPE));
        return null;
      }
      // current community URL
      XPArrayList urls = TaskAPIUICommunity.GetURLForCurrentCommunity(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new CurrentCommunityDataTag();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#SupportsAccessStyle(com.plumtree.uiinfrastructure.constants.AccessStyles)"></seealso>
    public override bool SupportsAccessStyle(AccessStyles style)
    {
      // This tag does not display any JavaScript, and therefore
      // supports all access styles.
      return true;
    }
  }
}