/*
 * Created on Jan 31, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.statichelpers;
using ATag=com.plumtree.portaluiinfrastructure.tags.ATag;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the CurrentCommunityPages PTURL DO Data Tag
  /// </summary>
  public class CurrentCommunityPagesDataTag : APTURLDODataTag
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
     typeof(CurrentCommunityPagesDataTag));
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentCommunityPagesDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currcommunitypagesdata", COMMON_PRETAGMETADATA_DESC + "List of URLs to current Community Pages (Community Pages a " + "user is currently in. Only URLs to Community Pages a user has " + "access to will be included) " + COMMON_POSTTAGMETADATA_DESC + "The URL will also set the " + PTURLConstants.KEY_CURRENTMARKER + " DO data component on a Community Page " + "if currently on that Community Page. ");
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList urls = TaskAPIUICommunity.GetCurrentCommunityPagesAsURLs(TaskAPIUICommon.GetEnvTypeObject(env));
      if (urls == null)
      {
        log.Info("Tag currcommunitypagesdata did not find any pages in current Community. No data to set to datavar: \'{0}\' in scope \'{1}\'",
         GetTagAttributeAsString(ATTRIB_ID), GetTagAttributeAsString(ATTRIB_SCOPE));
        urls = new XPArrayList();
      }
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new CurrentCommunityPagesDataTag();
    }
  }
}