using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  public class CurrentPageDataTag : APTURLDODataTag
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
     typeof(CurrentPageDataTag));
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentPageDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currpagedata", COMMON_PRETAGMETADATA_DESC + "URL for the current Community Page data. Nothing is set if the current page is not a Community page." + COMMON_POSTTAGMETADATA_DESC);
      }
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUICommunity.GetCurrentPageAsURL(TaskAPIUICommon.GetEnvTypeObject(env));
      if (url != null)
      {
        log.Info("Tag currpagedata did not find any Page data. No data to set to datavar: \'{0}\' in scope \'{1}\'",
         GetTagAttributeAsString(ATTRIB_ID), GetTagAttributeAsString(ATTRIB_SCOPE));
        SetPTURLDataEntry(url);
      }
      return null;
    }
    public override ATag Create()
    {
      return new CurrentPageDataTag();
    }
  }
}