/*
 * Created on Jan 31, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the HelpPage PTURL DO Data Tag
  /// </summary>
  public class HelpPageDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static HelpPageDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("helppagedata", COMMON_PRETAGMETADATA_DESC + "URL to open the Online Help Page. " + COMMON_POSTTAGMETADATA_DESC + "In standard display mode, the " + PTURLConstants.KEY_FULLURL + " component will just return #," + "since a popup is used. Use the " + PTURLConstants.KEY_JAVASCRIPT_ACTION + " to retrieve the javascript" + "call. In Accessibility and low-bandwidth mode a regular URL is used");
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUIPortalConfig.GetURLForCurrentPageHelp(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new HelpPageDataTag();
    }
  }
}