/*
 * Created on Jan 31, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the LoginLogoff PTURL DO Data Tag
  /// </summary>
  public class LoginLogoffDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static LoginLogoffDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("loginlogoffdata", COMMON_PRETAGMETADATA_DESC + "Login/Logoff Action URL (Login link if the current user is " + "not logged in or Logoff link if the current user is already signed in). " + COMMON_POSTTAGMETADATA_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUIUser.GetURLForLoginLogoff(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new LoginLogoffDataTag();
    }
  }
}