/*
 * Created on Jan 31, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MandatoryLinks PTURL DO Data Tag
  /// </summary>
  /// <author>robertz</author>
  public class MandatoryLinksDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static MandatoryLinksDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("mandatorylinksdata", COMMON_PRETAGMETADATA_DESC + "List of URLs to current user\'s Experience Definition Mandatory Links " + "(Only URLs to objects a user has access are included) " + COMMON_POSTTAGMETADATA_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList arURLs = TaskAPIUISubPortal.GetSubPortalMandatoryLinksAsURLs(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataCollection(arURLs);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MandatoryLinksDataTag();
    }
  }
}