/*
 * Created on Feb 2, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.server;
using com.plumtree.taskapi.portalui;
using com.plumtree.taskapi.server;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of Subportal Mandatory Links Folder Name String data tag
  /// </summary>
  public class MandatoryLinksFolderNameDataTag : ATag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    public static readonly RequiredTagAttribute KEY;
    static MandatoryLinksFolderNameDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("mandatorylinknamedata", "Sets String data on the PORTLET REQUEST scope with " + "Subportal Mandatory Links Folder Name (The name of the group " + "of mandatory links. Displayed as the menu tab title on dropdown menus).");
      KEY = new RequiredTagAttribute("key", "The reference to the String data stored on the Tag PORTLET REQUEST Scope.");
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IPTSession ptSession = TaskAPIUICommon.GetPTSession(TaskAPIUICommon.GetEnvTypeObject(GetEnvironment()));
      String strFolderName = TaskAPIServerSubPortal.GetSubPortalMyMandatoryLinksFolderName(ptSession);
      if (null == strFolderName)
      {
        strFolderName = "";
      }
      SetStateSharedVariable(GetTagAttributeAsString(KEY), strFolderName,
       Scope.PORTLET_REQUEST, false);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MandatoryLinksFolderNameDataTag();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#SupportsAccessStyle(com.plumtree.uiinfrastructure.constants.AccessStyles)"></seealso>
    public override bool SupportsAccessStyle(AccessStyles style)
    {
      // This tag does not display any JavaScript, and therefore
      // supports all access styles.
      return true;
    }
  }
}