/*
 * Created on Jan 20, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MyPages PTURL DO Data Tag
  /// </summary>
  public class MyPagesDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static MyPagesDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("mypagesdata", COMMON_PRETAGMETADATA_DESC + "List of URLs to users\'s My Pages. " + "The \'currurl\' DO data component is set on a MyPage URL if currently in that My Page " + COMMON_POSTTAGMETADATA_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList urls = TaskAPIUIMyPages.GetMyPagesAsURLs(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MyPagesDataTag();
    }
  }
}