/*
 * Created on Nov 27, 2007
 */
 
using System;
using IPTURL=com.plumtree.portaluiinfrastructure.ptlink.IPTURL;
using ATag=com.plumtree.portaluiinfrastructure.tags.ATag;
using TagDataSetterPTURLDOData=com.plumtree.portaluiinfrastructure.tags.data.TagDataSetterPTURLDOData;
using ITagMetaData=com.plumtree.portaluiinfrastructure.tags.metadata.ITagMetaData;
using TagMetaData=com.plumtree.portaluiinfrastructure.tags.metadata.TagMetaData;
using IPTSession=com.plumtree.server.IPTSession;
using TaskAPIUICommon=com.plumtree.taskapi.portalui.TaskAPIUICommon;
using TaskAPIUICommunity=com.plumtree.taskapi.portalui.TaskAPIUICommunity;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using IEnvironment=com.plumtree.uiinfrastructure.uitasks.IEnvironment;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MyProfile PTURL DO Data Tag
  /// </summary>
  public class MyProfileDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static MyProfileDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("myprofiledata", COMMON_PRETAGMETADATA_DESC + "URL to user\'s Profile Page (Goes to the User Profile " + "page where users can view personal profile information). " + COMMON_POSTTAGMETADATA_DESC);
      }
    internal TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      AActivitySpace owner = (AActivitySpace) TaskAPIUICommon.GetEnvTypeObject(env);
      IPTSession session = (IPTSession) env.GetUserSession();
      IPTURL url = TaskAPIUICommunity.CreateUserProfilePageCommonOpenerURL(owner,
       session.GetSessionInfo().GetCurrentUserID(), session.GetSessionInfo().GetCurrentUserName(),
       owner.GetString(1308, "ptmsgs_portalbrowsingmsgs"));
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MyProfileDataTag();
    }
  }
}