/*
 * Created on Jan 31, 2005
 */
 
using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MyAccount PTURL DO Data Tag
  /// </summary>
  public class RulesDebugDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static RulesDebugDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("rulesdebugdata", COMMON_PRETAGMETADATA_DESC + "URL to Rules Debug Pop up Page where users can view the messages sent by the experience definition rules engine. " + COMMON_POSTTAGMETADATA_DESC);
      }
    internal TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      AActivitySpace owner = TaskAPIUICommon.GetEnvTypeObject(env);
      FullURL url = null;
      if (RulesDebugMSGAS.GetIsRulesDebugEnabled(TaskAPIUICommon.GetEnvTypeObject(GetEnvironment())))
      {
        String strText = owner.GetString(2969, "ptmsgs_portaladminmsgs");
        ASURL urlDebugPopUp = new ASURL(owner);
        urlDebugPopUp.SetLinkGetSpaceIfCached(RulesDebugMSGAS.STR_MVC_CLASS_NAME,
         owner);
        urlDebugPopUp.SetDisplayPage(RulesDebugMSGDP.STR_MVC_CLASS_NAME);
        String strRulesDebugURL = urlDebugPopUp.GetURLAsString();
        url = new FullURL(strText, strRulesDebugURL);
      }
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new RulesDebugDataTag();
    }
  }
}