/*
 * Created on Jan 20, 2005
 */
 
using System;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the UnsubscribeCommunities TagPTURL DO Data Tag
  /// </summary>
  public class UnsubscribeCommunitiesActionDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static UnsubscribeCommunitiesActionDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("unsubscribecommunitiesdata", COMMON_PRETAGMETADATA_DESC + "URL to Unsubscribe from Communities Editor (Editor " + "where a user can remove Communities from their My Community list). " + COMMON_POSTTAGMETADATA_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUICommunity.GetURLForUnsubscribeCommunitiesEditor(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new UnsubscribeCommunitiesActionDataTag();
    }
  }
}