/*
 * Created on Feb 1, 2005
 */
package com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the Administration Portal PTURL DO Data Tag
 * 
 */
public class AdministrationDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("administrationdata",
			"Sets PTURL DO data on the PORTLET REQUEST scope with " +
			"URL to the Administrative Portal (The URL is only returned if a " +
			"user has sufficient access to the Administrative Portal). " +
			COMMON_POSTTAGMETADATA_DESC);

	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		
		IPTURL url = TaskAPIUIAdministration.GetURLForAdministrationPortal(TaskAPIUICommon.GetEnvTypeObject(env));
		
		SetPTURLDataEntry(url);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new AdministrationDataTag();
	}
}
