/*
 * Created on Jan 31, 2005
 */
package  com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the MandatoryLinks PTURL DO Data Tag
 * 
 * @author robertz
 */
public class MandatoryLinksDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("mandatorylinksdata",
			COMMON_PRETAGMETADATA_DESC +
			"List of URLs to current user's Experience Definition Mandatory Links " +
			"(Only URLs to objects a user has access are included) " +
			COMMON_POSTTAGMETADATA_DESC);
	}
		
	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		
		XPArrayList arURLs = TaskAPIUISubPortal.GetSubPortalMandatoryLinksAsURLs(TaskAPIUICommon.GetEnvTypeObject(env));
		
		SetPTURLDataCollection(arURLs);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new MandatoryLinksDataTag();
	}
}
