/*
 * Created on Mar 30, 2005
 */
package com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;

/**
 * This class provides the meta data for the PT Data tag library, including description and usage of the tags
 * in this tag library.
 * 
 */
public class PTDataTagLibraryData implements ITagLibraryMetaData
{
	public static final String DATATYPE_DESC = 
		"<![CDATA[<p>]]>"+
			"Two of these types are intrinsic to the tag framework, the string data and the IDataObject (DO) data. " +
			"These two types are used by the tag framework to enable text replacement operations with the $ operator."+
			"<![CDATA[<ol>]]>"+
			"<![CDATA[<li>]]>The String data type is the most basic type. As the name suggests, the data consists of a text string. " +
			"These strings can be read from Tag scopes by display tags. They can also be used with the $ operator " +
			"prepended to the data tag ID in the HTML document or in tag attributes, for example, <![CDATA[<br>]]><![CDATA[<br>]]><![CDATA[<code>]]>myattribute=\"$mytag\"<![CDATA[</code>]]><![CDATA[<p>]]>"+
			"<![CDATA[<li>]]>The DO data type sets a container with name/value pairs on tag scopes. It is useful for collections of data, " +
			"for example storing user information. A user could have a name/value pair for their name, age, address and other " +
			"information. Besides being used by display tags, the name/value pairs in a DO data type are also accessible with the $ operator. " +
			"Similarly to the string data type, the $ character is prepended to the data ID, and then followed by a dot and the " +
			"name of any name/value in the DO data, such as: <![CDATA[<br>]]><![CDATA[<br>]]><![CDATA[<code>]]>myattribute=\"$mytag.myname\"<![CDATA[</code>]]><![CDATA[<p>]]>"+
			"<![CDATA[<li>]]>The third data type, PTURL data, is a type of DO data that only stores URLs and any information related to a URL. "+
			"It contains a set of a name/value pairs, also known as URL components, such as the title of the url, the url itself, uri, "+
			"the image associated with the URL and its height and width. Exactly what information the PTURL stores depends on the type of tag that generates it. " +
			"As a type of DO data type, PTURL data can be used by any DO data compatible display tags. Note that display tags specifically using PTURL data do not " +
			"work with non-PTURL DO data." +
			"<![CDATA[</ol>]]>";

  public static final TagLibraryMetaData LIBRARY = new TagLibraryMetaData
		("ALI Data Tags", 
		  "ptdata",
		  
		  	"This library provides data tags to retrieve and create portal URLs for use in navigation."+
		  	"<![CDATA[<p>]]>"+
			"Data tags provide content for display tags, which format and display the content. " +
			"Data tags do not actually display anything, all they do is to set data on the tag "+
			"scopes, such as the "+Scope.SESSION+" or the "+Scope.PORTLET_REQUEST+" scope. "+
			"The data stored by these tags on the tag scopes are used by display tags. " +
			"For example, the ptnavtags:ptddmenutab tag generates HTML for a DHTML dropdown menu. "+
			"It does not display any content by default. To populate the menu with entries, " +
			"it requires a reference to one or more data tags. "+
			"The way to specify what data tag to use in a display tag is to reference the ID attribute " +
			"that all data tags should define. "+
			"A display tag defines an attribute to specify the data tag ID to use."+
			"<![CDATA[<p>]]>"+
			"There are several types of data tags and display tags defined since not all data tags or " +
			"display tags are compatible with each other. "+
			"The ALI framework tag libraries (core, logic, standard, ui, data and navtags) provide " +
			"three types of data tags."+
			DATATYPE_DESC
			,
		1.0);
}
