package com.bea.alui.taglib.searchpage.test;

import junit.framework.*;

import com.bea.alui.taglib.searchpage.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.mock.tags.*;
import com.plumtree.portaluiinfrastructure.mock.uiinfrastructure.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.portaluiinfrastructure.tags.displaytree.*;
import com.plumtree.portaluiinfrastructure.tags.helper.*;
import com.plumtree.portaluiinfrastructure.tags.manager.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Tests for the searchresultsdata data tag.
 * 
 * @author smahendr
 */
public class SearchResultsDataTagTest extends BaseSearchPageTest
{
	
	@Override
	public void setUp() throws Exception
	{
		super.setUp();
		
		// Create the mock TabLib manager.
   		MockTagLibManager tagLibs = new MockTagLibManager();
   		TagLibManager.setTestInstance(tagLibs);
   		
   		// Add the searchpage.searchresultsdata tag.
   		tagLibs.SetTag(new SearchResultsDataTag(), SearchResultsDataTag.TAG.GetName(), SearchPageTagLibraryData.LIBRARY.GetName());
	}

	/**
	 * This test inserts the search results tag, and makes sure a variable is created with a list of
	 * results, and that the list of results contains the expected values.
	 */
	public void testResultsData()
	{
		/*
		// 1) Initialize the Mock model.
		XPArrayList arrayListResults = new XPArrayList();
		
		// Create a fake portal result.
		MockSearchResult result1 = new MockSearchResult();
		result1.setApp("PTPORTAL");
		result1.setBestBet(false);
		result1.setClassID(18);
		HTMLAnchor clickThroughURL = new HTMLAnchor("resultLink");
		clickThroughURL.SetOnClick("resultOnClick");
		result1.setClickthroughURL(clickThroughURL);
		result1.setContentLastPubUser(null);
		result1.setContentPortletIDs(null);
		result1.setFolderID(-1);
		HTMLImg icon = new HTMLImg("iconSrc", "iconAlt");
		result1.setIcon(icon);
		result1.setKwic("description1");
		XPDateTime currentDate = new XPDateTime();
		result1.setLastModified(currentDate);
		result1.setName("name1");
		HTMLAnchor propertiesURL = new HTMLAnchor("#");
		propertiesURL.SetOnClick("propsOnClick");
		result1.setPropertiesURL(propertiesURL);

		// Add it to the result list
		arrayListResults.Add(result1);
		
		// Initialize the model.
		m_model.SetFirstDisplayableItem(1);
		m_model.SetNumDisplayableItems(1);
		m_model.SetResultsList(arrayListResults);
		
		// 2) Initialize Markup
		String resultsTagId = "results";
		
		XMLFragmentTestHelper searchResultsDataTag =
			new XMLFragmentTestHelper(SearchPageTagLibraryData.LIBRARY.GetName(),
					SearchResultsDataTag.TAG.GetName());
		searchResultsDataTag.AddPTAttribute(SearchResultsDataTag.ATTRIB_ID.GetName(), resultsTagId);
		searchResultsDataTag.AddPTAttribute(SearchResultsDataTag.ATTRIB_SCOPE.GetName(), Scope.HTTP_REQUEST+"");
		
		Object[][] markup = searchResultsDataTag.ToArrayEntireFragment();
		
		// 3) Now process the tag!
		HTMLElement content = DisplayTree.ProcessTagMarkup(m_environment, markup);
		XPHashtable scopeData = TagState.GetHTTPRequestData(m_environment);

		// 4) Get the data and check if we find what we expected.
		XPDateFormat dateFormat = m_model.GetDateFormat(m_environment);

		Object oResults = scopeData.GetElement("."+resultsTagId);
		if(oResults == null)
		{
			XPSystem.Out.WriteLine("Output of processed markup:");
			XPSystem.Out.WriteLine(content.GetDisplayString());
			fail("Did not find expected tag variable with id "+resultsTagId+" set in tag memory");
		}
		
		try {
			XPArrayList listResults = (XPArrayList)((SharedStateVariable)oResults).GetValue();
			Assert.assertEquals(1, listResults.GetSize());
			
			IDataObject resultData = (IDataObject)listResults.GetElement(0);
			// Test out our fake Portal card result.
			Assert.assertEquals(result1.getName(), resultData.GetData(SearchResultsDataTag.NAME));
			Assert.assertEquals(result1.getKwic(), resultData.GetData(SearchResultsDataTag.DESCRIPTION));
			Assert.assertEquals(1 + "", resultData.GetData(SearchResultsDataTag.RANK));
			Assert.assertEquals(result1.getClickthroughURL().GetHRef(), resultData.GetData(SearchResultsDataTag.RESULT_HREF));
			Assert.assertEquals(result1.getClickthroughURL().GetOnClick(), resultData.GetData(SearchResultsDataTag.RESULT_ONCLICK));
			Assert.assertEquals(MockConfigHelper.MOCK_BASE_URL + result1.getIcon().GetSrc(), resultData.GetData(SearchResultsDataTag.ICON));
			Assert.assertEquals(result1.getIcon().GetAlt(), resultData.GetData(SearchResultsDataTag.ICON_ALT_TEXT));
			Assert.assertEquals(dateFormat.Format(result1.getLastModified()), resultData.GetData(SearchResultsDataTag.LAST_MODIFIED));
			Assert.assertEquals(result1.getPropertiesURL().GetHRef(), resultData.GetData(SearchResultsDataTag.PROPERTIES_HREF));
			Assert.assertEquals(result1.getPropertiesURL().GetOnClick(), resultData.GetData(SearchResultsDataTag.PROPERTIES_ONCLICK));
			Assert.assertEquals(result1.isBestBet() ? "true" : "false", resultData.GetData(SearchResultsDataTag.IS_BEST_BET));
			Assert.assertEquals(result1.getFolderID() == 0 ? "true" : "false", resultData.GetData(SearchResultsDataTag.IS_IN_MULTIPLE_FOLDERS));
			Assert.assertEquals(null, resultData.GetData(SearchResultsDataTag.LAST_PUBLISHED_BY));
			Assert.assertEquals(null, resultData.GetData(SearchResultsDataTag.ASSOCIATED_OBJECTS_ONCLICK));

		} catch (XPException e) {
			fail("Found expected tag variable but it was not of the expected type, or some other error occured. See the stacktrace below for the exact issue.");
			e.PrintStackTrace();
		} */
	}
}
