using System;
namespace com.plumtree.debug
{
  /////////////////////////////////////////////////////////////////////////////
  // TraceType (represents enum in PTDebugLib\PTDebugMasks.h)
  /////////////////////////////////////////////////////////////////////////////
  
  /// <summary>
  /// This class is deprecated; it exists only for backward compatibility. 
  /// Please use OpenLogger and OpenLogService in com.plumtree.openlog
  /// package.
  /// </summary>
  /// <deprecated>
  /// Do not use this class. Please use OpenLogger and OpenLogService 
  /// in com.plumtree.openlog package.
  /// </deprecated>
  public class TraceType
  {
    // Severity-based traces //
    // Used to output extra debug information (typically used in an if (PT_DEBUG) block)
    public const int Debug = 1;
    // A trace level for normal operation
    public const int Info = 2;
    // Signals that something out of the normal has occured which is not very severe (like a portlet timeout)
    public const int Warn = 4;
    // An actual error which will cause problems has happened
    public const int Error = 8;
    // Used very rarely -- a critical error which causes the whole system to stop (like not finding a database)
    public const int Fatal = 16;
    // Special case traces //
    // Means the trace is related to entering or leaving a function
    public const int Function = 1 << 5;
    // Means the trace is used to measure performance
    public const int Performance = 1 << 6;
    // Means the trace is used to trace user actions
    public const int Action = 1 << 7;
  }
}