using System;
namespace com.plumtree.uiinfrastructure.activityspace
{
  /// <summary>
  /// This interface is used by the ASManager to return new instances of managed
  /// objects.
  /// </summary>
  /// <author>Don Hayler</author>
  public interface IManagedObject
  {
    
    /// <summary>
    /// This method is used by the ASManager to return new instances of managed
    /// objects.
    /// </summary>
    /// <returns>A new instance of the managed class (i.e. return new Foo();)</returns>
    Object Create();
  }
}