using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using com.plumtree.uiinfrastructure.pagecontrols.framework;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.activityspace
{
  /// <author>
  /// DorisL
  /// interface for page controls
  /// </author>
  public interface IPageControl : IMVCObject,IManagedObject
  {
    
    /// <summary>
    /// This method serves as a getter for component HTML. Sub-classes must
    /// implement this method.
    /// </summary>
    /// <returns>The HTML for the component itself.</returns>
    HTMLElementCollection GetComponentHTML();
    
    /// <summary>
    /// This method returns the string used to uniquely idenify this component
    /// on a page.
    /// </summary>
    /// <returns></returns>
    String GetUniqueInstanceID();
    
    /// <summary>
    /// This abstract method stores the input submitted by the user. It should
    /// be called after a POST or GET. In the case of the date picker, it would
    /// store the date.
    /// </summary>
    /// <param name="_htRequestParameters">
    /// A hashtable containing the request's name-
    /// value pairs.
    /// </param>
    int StoreUserInput(XPHashtable _htRequestParameters);
    
    /// <summary>
    /// Return a ComponentMgr of the type responsisble for this PageControl.
    /// </summary>
    /// <param name="_pageMgr">this PageMgr</param>
    /// <returns>	a ComponentMgr</returns>
    ComponentMgr GetComponentMgr(PageMgr _pageMgr);
    
    /// <summary>
    /// Return the name of the ComponentMgr of the type responsible for this
    /// Page Control.
    /// </summary>
    /// <returns>the name of the ComponentMgr</returns>
    String GetComponentMgrName();
  }
}