using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.activityspace.utils
{
  /// <summary>
  /// This is a helper class for the cache list that stores activity spaces.
  /// </summary>
  /// <author>donh</author>
  public class CacheListItem
  {
    
    /// <summary>
    /// name of the cache item 
    /// </summary>
    public String m_strName;
    
    /// <summary>
    /// the ID of the parent activity space 
    /// </summary>
    public String m_strParentSpaceID;
    
    /// <summary>
    /// true implies this space was opened from a gatewayed page 
    /// </summary>
    public bool m_bIsFromGatewaySpace;
    
    /// <summary>
    /// true implies is a sub space 
    /// </summary>
    public bool m_bIsSubSpace;
    
    /// <summary>
    /// Creates a new CacheListItem object.
    /// </summary>
    /// <param name="strName">cache item name</param>
    /// <param name="bIsSubSpace">true implies is a sub-space</param>
    /// <param name="strParentSpaceID">the ID of the parent space</param>
    public CacheListItem(String strName, bool bIsSubSpace, String strParentSpaceID)
    {
      m_strName = strName;
      m_bIsSubSpace = bIsSubSpace;
      m_strParentSpaceID = strParentSpaceID;
      if (strParentSpaceID != null)
      {
        // All spaces generated from a gatewayed page should have the spaceid
        // set to SPACEID_INVALID and the space name set to STR_GATEWAY.
        m_bIsFromGatewaySpace = ASCache.SPACEID_INVALID.Equals(strParentSpaceID);
        } else
      {
        // Assume that sub-spaces without a valid parent space were generated
        // by a gatewayed page.
        m_bIsFromGatewaySpace = m_bIsSubSpace;
      }
    }
  }
}