/*
 * Created on Mar 13, 2005
 */
 
using System;
namespace com.plumtree.uiinfrastructure.application.notification
{
  /// <summary>
  /// Startup task result codes enumerator.  Relatively self-explanatory.
  /// Name and ID getters were included for notification automatioon. 
  /// </summary>
  /// <author>DavidP</author>
  public class PT_STARTUP_RESULTCODES
  {
    // enumerated types
    public static readonly PT_STARTUP_RESULTCODES OK = new PT_STARTUP_RESULTCODES(0,
     "OK");
    public static readonly PT_STARTUP_RESULTCODES WARN = new PT_STARTUP_RESULTCODES(1,
     "WARN");
    public static readonly PT_STARTUP_RESULTCODES ERROR = new PT_STARTUP_RESULTCODES(2,
     "ERROR");
    public static readonly PT_STARTUP_RESULTCODES FATAL = new PT_STARTUP_RESULTCODES(3,
     "FATAL");
    // private members
    private String m_name = "";
    private int m_id = 0;
    // private constructor
    private PT_STARTUP_RESULTCODES(int id, String name)
    {
      m_id = id;
      m_name = name;
    }
    
    /// <returns>The text name of this return code</returns>
    public virtual String getName()
    {
      return m_name;
    }
    
    /// <returns>The integer ID of this return code</returns>
    public virtual int getID()
    {
      return m_id;
    }
  }
}