/*
 * Created on Mar 13, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.application.notification
{
  /// <summary>
  /// Container for a result code and a status message.
  /// The startup task runner uses these for separate 
  /// notification and exception processing.
  /// </summary>
  /// <author>DavidP</author>
  public class ReturnValue
  {
    private PT_STARTUP_RESULTCODES m_result = null;
    private String m_resultMsg = "";
    private XPException m_exception = null;
    
    /// <summary>
    /// Constructor for container class
    /// </summary>
    /// <param name="code"></param>
    /// <param name="msg"></param>
    public ReturnValue(PT_STARTUP_RESULTCODES code, String msg, XPException e)
    {
      m_result = code;
      m_resultMsg = msg;
      m_exception = e;
    }
    
    /// <returns>message from core startup task itself</returns>
    public virtual String getMsg()
    {
      return m_resultMsg;
    }
    
    /// <returns>result code</returns>
    public virtual PT_STARTUP_RESULTCODES getResultCode()
    {
      return m_result;
    }
    
    /// <returns>exception</returns>
    public virtual XPException getException()
    {
      return m_exception;
    }
  }
}