/*
 * Purpose:	Compensate for XPExceptions' limitations
 * Author: 	D. Phipps May 6, 2005
 */
 
using System;
using com.plumtree.openfoundation.io;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.application.startup.exceptions
{
  /// <summary>
  /// Gets around a limitation of XPException, which doesn't create stack traces.
  /// </summary>
  /// <author>DavidP</author>
  public class StackTracer
  {
    
    /// <summary>
    /// Gets around the fact that XPException has very limited function if you throw a new exception; 
    /// it must chain on a real one.
    /// </summary>
    /// <param name="message"></param>
    public static void ThrowNewXPException(String message)
    {
      throw new XPException(message);
    }
    
    /// <summary>
    /// Gets around the fact that XPEXception has very limited function if you throw a new exception; 
    /// it must chain on a real one.
    /// </summary>
    /// <param name="message"></param>
    public static void ThrowNewXPFileNotFoundException(String message)
    {
      throw new XPFileNotFoundException(message);
    }
    
    /// <summary>
    /// Gets around the fact that XPEXception has very limited function if you throw a new exception; 
    /// it must chain on a real one.
    /// </summary>
    /// <param name="message"></param>
    public static XPException MakeXPException(String message)
    {
      XPException exp = new XPException(message);
      return exp;
    }
  }
}