/*
 * Created on Mar 11, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.application.notification;
using com.plumtree.uiinfrastructure.util;
namespace com.plumtree.uiinfrastructure.application.startup.messages
{
  /// <summary>
  /// Message list management interface.  One such class is coded per
  /// high-level task.
  /// </summary>
  /// <author>DavidP</author>
  public interface IMessage
  {
    
    /// <summary>
    /// Message count.
    /// </summary>
    /// <returns>number of messages in class</returns>
    int getNumMsgs();
    
    /// <summary>
    /// Message element.  Gets the recommendation strings for a specific 
    /// narrow condition with retval, platform, task, in an XPArrayList,
    /// sorted by most accurate first.
    /// </summary>
    /// <param name="id">- the id of the task step</param>
    /// <ReturnValue>- the returnvalue class to inspect to get recommendation</ReturnValue>
    /// <returns>specific string recommendation</returns>
    XPArrayList getMsg(int stepid, Platform platform, ReturnValue ret);
    
    /// <returns>Enumerated list of messages</returns>
    StartupTaskMessage[] getMsgArray();
  }
}