/*
 * Created on Mar 11, 2005
 */
 
using System;
using com.plumtree.uiinfrastructure.application.notification;
using com.plumtree.uiinfrastructure.util;
namespace com.plumtree.uiinfrastructure.application.startup.messages
{
  /// <summary>
  /// Class to record a message and description useful for recommendations to fix problems
  /// </summary>
  /// <author>DavidP</author>
  public class StartupTaskMessage
  {
    private int m_taskstep = 0;
    private Platform m_platform = null;
    private PT_STARTUP_RESULTCODES m_ret = null;
    private String m_errMessage = "";
    private String m_errDescription = "";
    
    /// <summary>
    /// Constructor for the message element.
    /// </summary>
    /// <param name="id"></param>
    /// <param name="msg"></param>
    /// <param name="desc"></param>
    /// <param name="ex"></param>
    public StartupTaskMessage(int stepid, Platform platformid, PT_STARTUP_RESULTCODES ret,
     String msg, String desc)
    {
      m_taskstep = stepid;
      m_platform = platformid;
      m_errMessage = msg;
      m_errDescription = desc;
      m_ret = ret;
    }
    
    /// <returns>Returns the m_errDescription.</returns>
    public virtual String getErrDescription()
    {
      return m_errDescription;
    }
    
    /// <returns>Returns the task step</returns>
    public virtual int getStepID()
    {
      return m_taskstep;
    }
    
    /// <returns>Returns the platform</returns>
    public virtual Platform getPlatform()
    {
      return m_platform;
    }
    
    /// <returns>Returns the m_errMessage.</returns>
    public virtual String getErrMessage()
    {
      return m_errMessage;
    }
    
    /// <returns>Returns the m_errMessage.</returns>
    public virtual PT_STARTUP_RESULTCODES getRetval()
    {
      return m_ret;
    }
    
    /// <summary>
    /// Returns a formatted string with the error message and description.
    /// </summary>
    /// <returns></returns>
    public override String ToString()
    {
      String line = m_errMessage + "\r\n" + "      " + m_errDescription + "\r\n";
      return line;
    }
  }
}