using System;
namespace com.plumtree.uiinfrastructure.application.varpacks
{
  /// <summary>
  /// This class contains constants for the x_config.xml file.
  /// </summary>
  public class ConfigConstants
  {
    
    /// <summary>
    /// The value attribute 
    /// </summary>
    public const String VALUE_ATTRIBUTE = "value";
    /////////////////
    // Authentication
    /////////////////
    
    /// <summary>
    /// The authentication section 
    /// </summary>
    public const String AUTHENTICATION_SECTION = "Authentication";
    
    /// <summary>
    /// The guest access sub-section in authentication
    /// </summary>
    public const String GUEST_ACCESS_SUBSECTION = "AllowGuestAccess";
    
    /// <summary>
    /// The guest access sub-section in authentication
    /// </summary>
    public const String GUEST_ACCESS_STYLE_OVERRIDE = "OverrideGuestAccessStyle";
    
    /// <summary>
    /// The basic auth login token expiration time subsection in authentication (in minutes).
    /// </summary>
    public const String AUTHTOKENEXPIRATION = "AuthTokenExpiration";
    
    /// <summary>
    /// The basic auth SSO override subsection in authentication.
    /// </summary>
    public const String AUTHOVERRIDESSO = "AuthOverrideSSO";
    ////////////////////
    // Personal Settings
    ////////////////////
    
    /// <summary>
    /// The personal settings section 
    /// </summary>
    public const String PERSONAL_SETTINGS_SECTION = "PersonalSettings";
    
    /// <summary>
    /// The Accessibility sub-section in personal settings 
    /// </summary>
    public const String ACCESSIBILITY_SUBSECTION = "Accessibility";
    ///////////
    // Security
    ///////////
    
    /// <summary>
    /// The security section 
    /// </summary>
    public const String SECURITY_SECTION = "Security";
    
    /// <summary>
    /// The security mode sub-section in security 
    /// </summary>
    public const String SECURITY_MODE_SUBSECTION = "SecurityMode";
    ////////////////
    // International
    ////////////////
    
    /// <summary>
    /// The international section 
    /// </summary>
    public const String INTERNATIONAL_SECTION = "International";
    
    /// <summary>
    /// The Locale sub-section in international 
    /// </summary>
    public const String LOCALE_SUBSECTION = "Locale";
    
    /// <summary>
    /// The time zone sub-section in international 
    /// </summary>
    public const String TIMEZONE_SUBSECTION = "TimeZone";
    ///////////////////
    // URLMapping
    ///////////////////
    
    /// <summary>
    /// JF- The URL Mapping section 
    /// </summary>
    public const String URL_MAPPING_SECTION = "URLMapping";
    
    /// <summary>
    /// JF- The URL From the Request sub-section in URL Mapping 
    /// </summary>
    public const String URL_FROM_REQUEST_SUBSECTION = "URLFromRequest";
    
    /// <summary>
    /// JF- The Application URL sub-section in URL Mapping 
    /// </summary>
    public const String APPLICATION_URL_SUBSECTION = "ApplicationURL";
    
    /// <summary>
    /// JF- The Secure Application URL sub-section in URL Mapping 
    /// </summary>
    public const String SECURE_APPLICATION_URL_SUBSECTION = "SecureApplicationURL";
    ////////////
    // MainURLs
    ////////////
    
    /// <summary>
    /// WilliamA- The Main URLs section 
    /// </summary>
    public const String MAIN_URLS_SECTION = "MainURLs";
    
    /// <summary>
    /// JO- The URL that is used for the Portal Server to connect to the Image Server to do JSRegistry work 
    /// </summary>
    public const String IMAGE_SERVER_CONNECTION_URL = "ImageServerConnectionURL";
    
    /// <summary>
    /// DAP- The timeout for testing that same URL during startup 
    /// </summary>
    public const String IMAGE_SERVER_CONNECTION_URL_TIMEOUT = "ImageServerConnectionURLTimeout";
    ///////////////////
    // SystemProperties
    ///////////////////
    
    /// <summary>
    /// The system properties section 
    /// </summary>
    public const String SYSTEM_PROPERTIES_SECTION = "SystemProperties";
    
    /// <summary>
    /// The machine name sub-section in system properties 
    /// </summary>
    public const String MACHINE_NAME_SUBSECTION = "MachineName";
    
    /// <summary>
    /// JF- The Server Name sub-section in system properties 
    /// </summary>
    public const String SERVER_NAME_SUBSECTION = "ServerName";
    
    /// <summary>
    /// The Performance Comments sub-section in system properties 
    /// </summary>
    public const String PERFORMANCE_COMMENTS_SUBSECTION = "PerformanceComments";
    
    /// <summary>
    /// The Performance Comments sub-section in system properties 
    /// </summary>
    public const String LAYOUT_MODE_SUBSECTION = "LayoutMode";
    
    /// <summary>
    /// JF- The HTTP Entry Point sub-section in system properties 
    /// </summary>
    public const String HTTP_ENTRY_POINT_SUBSECTION = "HTTPEntryPoint";
    
    /// <summary>
    /// JF- The HTTP Port sub-section in system properties 
    /// </summary>
    public const String HTTP_PORT_SUBSECTION = "HTTPPort";
    
    /// <summary>
    /// JF- The HTTP Secure Port sub-section in system properties 
    /// </summary>
    public const String HTTP_SECURE_PORT_SUBSECTION = "HTTPSecurePort";
    
    /// <summary>
    /// JF- The Virtual Directory Path sub-section in system properties 
    /// </summary>
    public const String VIRTUAL_DIRECTORY_PATH_SUBSECTION = "VirtualDirectoryPath";
    
    /// <summary>
    /// The maximum queue length for requests for a single session.  Default 10. 
    /// </summary>
    public const String MAX_REQUEST_QUEUE_LENGTH_SUBSECTION = "MaxRequestQueueLength";
    
    /// <summary>
    /// JF- The  sub-section in system properties 
    /// </summary>
    public const String _SUBSECTION = "";
    
    /// <summary>
    /// JYS- The SSO Entry Point 
    /// </summary>
    public const String SSO_SERVLET_NAME_SUBSECTION = "SSOServletName";
    ////////////////////
    // Cached Settings
    ////////////////////
    
    /// <summary>
    /// WilliamA- The cached settings section 
    /// </summary>
    public const String CACHED_SETTINGS_SECTION = "CachedSettings";
  }
}