using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.approval
{
  /// <author>Ben Geislinger</author>
  public abstract class AInstanceDescriptor
  {
    protected static int iInstanceID = 0;
    protected AActivitySpace mySpace = null;
    internal HTMLElement myPath;
    private AItemDescriptor myItem;
    private String sComment = "";
    private String sID;
    private String sItemID;
    private bool bApprove = false;
    private bool bHold = true;
    private bool bReject = false;
    private int m_PTFolderID = 0;
    
    /// <summary>
    /// Creates a new AInstanceDescriptor object.
    /// </summary>
    /// <param name="item"></param>
    /// <param name="ePath"></param>
    protected AInstanceDescriptor(AItemDescriptor item, HTMLElement ePath,
     ApprovalItemType type, AActivitySpace space)
    {
      myItem = item;
      myPath = ePath;
      mySpace = space;
      sID = type.GetName() + "_IN_" + XPConvert.ToString(iInstanceID);
      sItemID = item.GetID();
      iInstanceID++;
    }
    public abstract void Execute();
    public virtual int GetPTFolderID()
    {
      return m_PTFolderID;
    }
    public virtual void SetPTFolderID(int ID)
    {
      m_PTFolderID = ID;
    }
    public virtual void Approve()
    {
      bApprove = true;
      bReject = false;
      bHold = false;
    }
    public virtual bool GetApprove()
    {
      return bApprove;
    }
    
    /// <returns></returns>
    public virtual String GetComment()
    {
      return sComment;
    }
    public virtual bool GetHold()
    {
      return bHold;
    }
    
    /// <returns></returns>
    public virtual String GetID()
    {
      return sID;
    }
    
    /// <returns></returns>
    public virtual HTMLElement GetPath()
    {
      return myPath;
    }
    public virtual bool GetReject()
    {
      return bReject;
    }
    public virtual void Hold()
    {
      bApprove = false;
      bReject = false;
      bHold = true;
    }
    public virtual void Reject()
    {
      bApprove = false;
      bReject = true;
      bHold = false;
    }
    
    /// <param name="s"></param>
    public virtual void SetComment(String s)
    {
      sComment = s;
    }
  }
}