using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.approval
{
  /// <author>$author$</author>
  public interface IApprovalModelRO : IEditorModelRO
  {
    
    /// <returns></returns>
    bool AddColumnsHeaderForEachItem();
    
    /// <returns></returns>
    bool DisplayDescriptionImmediatelyUnderTitle();
    String GetNoItemsDescription();
    bool DisplayItemTypeHeaderAboveActionbar();
    
    /// <returns></returns>
    bool GetDisplaySelectAllButton();
    
    /// <returns></returns>
    bool GetAddComment();
    
    /// <returns></returns>
    bool GetAllowClearingOfApprovalRequests();
    
    /// <param name="item"></param>
    /// <returns></returns>
    bool GetAllowClearingOfItem(AItemDescriptor item);
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetCurrentPageIndex(ApprovalItemType type);
    //    public abstract ApprovalItemType GetCurrentType();
    
    /// <returns></returns>
    ApprovalItemType GetDefaultItemType();
    
    /// <returns></returns>
    bool GetDisableRadioSelection();
    
    /// <returns></returns>
    bool GetDisplayHeadersForItemTypesWithNoItems();
    
    /// <param name="type"></param>
    /// <returns></returns>
    bool GetDisplayInstances(ApprovalItemType type);
    
    /// <returns></returns>
    bool GetDisplayStatusColumn();
    
    /// <param name="type"></param>
    /// <returns></returns>
    bool GetDisplayTypeHeader(ApprovalItemType type);
    
    /// <returns></returns>
    bool DoSortSubmittedBy();
    
    /// <param name="type"></param>
    /// <returns></returns>
    String GetEmptyTypeSectionSubTitle(ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetHighItemIndexForCurrentPage(ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetHighItemIndexForGivenPage(int i, ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    IXPEnumerator GetItemDescriptors(ApprovalItemType type);
    
    /// <returns></returns>
    String GetItemID();
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetLowItemIndexForCurrentPage(ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetLowItemIndexForGivenPage(int i, ApprovalItemType type);
    
    /// <returns></returns>
    String GetSubTitle();
    
    /// <returns></returns>
    XPArrayList GetSupportedItemTypes();
    
    /// <returns></returns>
    String GetTitle();
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetTypeCount(ApprovalItemType type);
    
    /// <returns></returns>
    bool IsDateSortable();
    
    /// <returns></returns>
    bool IsDescriptionEditable();
    
    /// <returns></returns>
    bool IsNameSortable();
    
    /// <returns></returns>
    bool IsSubmittedBySortable();
    
    /// <returns></returns>
    bool IsTitleEditable();
    
    /// <param name="type"></param>
    /// <returns></returns>
    int GetNumPagesAvailable(ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    bool IsNextPageAvailable(ApprovalItemType type);
    
    /// <param name="type"></param>
    /// <returns></returns>
    bool IsPreviousPageAvailable(ApprovalItemType type);
    
    /// <returns></returns>
    bool DisplayItemComment();
    
    /// <returns></returns>
    bool DisplayViewItems();
  }
}