using System;
namespace com.plumtree.uiinfrastructure.arraywrapper
{
  /// <summary>
  /// This interface is implemented by PTGrowableSortedArrayWrapper.
  /// It contains the read-only methods of PTGrowableSortedArrayWrapper.
  /// Frameworks using the PTGrowableSortedArrayWrapper class
  /// should only give access to this interface to their Views.
  /// </summary>
  /// <author>JulieF</author>
  public interface IPTGrowableSortedArrayWrapperRO
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.arraywrapper.PTSortedArrayWrapper#GetCount()"></seealso>
    int GetCount();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.arraywrapper.PTSortedArrayWrapper#GetItems()"></seealso>
    Object GetItem(int iRow, int iPropID);
    
    /// <seealso cref="com.plumtree.uiinfrastructure.arraywrapper.PTSortedArrayWrapper#GetSort()"></seealso>
    int[][] GetSort();
  }
}