using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.openlog;
using com.plumtree.openfoundation.util;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.devices
{
  /// <author>
  /// SudhaS
  /// This display page creates a basic WML page.
  /// </author>
  public abstract class ADevicesDP_WML : IDisplayPage
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.devices.ADevicesDP_WML");
    protected AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#Display(IWebData)"></seealso>
    public virtual void Display(IWebData webData)
    {
      XPStringBuilder sb;
      sb = new XPStringBuilder();
      if (XPStringUtility.Compare(m_asOwner.GetCurrentPage().GetName(), "PortletDevices_WML") != 0)
      {
        sb.Append("<?xml version=\"1.0\"?>\n");
        sb.Append("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\"  \"http://www.wapforum.org/DTD/wml_1.1.xml\">\n");
        sb.Append("<wml> \n");
        sb.Append("<head>\n");
        sb.Append("\t\t<meta http-equiv=\"Cache-Control\" content=\"max-age=0\" forua=\"true\" \n/>");
        sb.Append("</head>\n");
      }
      try
      {
        //String strTemp = PageDisplay();
        sb.Append(PageDisplay());
      }
      catch (HTMLException e)
      {
        log.Error(e, "Could not create WML page.");
      }
      if (XPStringUtility.Compare(m_asOwner.GetCurrentPage().GetName(), "PortletDevices_WML") != 0)
      {
        sb.Append("</wml>");
      }
      webData.SetData(sb.ToString());
      webData.SetHeader(HTTPHeaderConstants.CONTENT_TYPE, "text/vnd.wap.wml;charset=UTF-8");
      }
    
    /// <returns></returns>
    public abstract String GetName();
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#GetOwner()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <returns></returns>
    public abstract String PageDisplay();
  }
}