/*
 * Purpose:
 * Author: 	D. Phipps Feb 24, 2005
 */
 
using System;
using com.plumtree.uiinfrastructure.diagnostic.testinterface;
namespace com.plumtree.uiinfrastructure.diagnostic
{
  /// <summary>
  /// Handles progress tracking for all tests. Each object has a single tasks' detail.
  /// </summary>
  /// <author>DavidP</author>
  public class ProgressManager
  {
    private IndividualTestProgressTracker[] m_progress = null;
    public ProgressManager(int numTests, bool verbose)
    {
      m_progress = new IndividualTestProgressTracker[numTests + 1];
      for (int loop = 0;loop < numTests;++loop)
      {
        m_progress[loop] = new IndividualTestProgressTracker();
        m_progress[loop].setManager(this);
        m_progress[loop].init(loop, numTests, verbose);
      }
    }
    public virtual IProgressTracker getTracker(int index)
    {
      return (IProgressTracker) m_progress[index];
    }
  }
}