using System;
// Framework Imports
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.editor
{
  /// <summary>
  /// This is the interface for the read-only Model. This interface is implemented
  /// by EditorModel. Any read-only Model interface should extend this one.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface IEditorModelRO : IModelRO
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorModel#GetEditorType()"></seealso>
    int GetEditorType();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorModel#GetHideLeftNav()"></seealso>
    bool GetHideLeftNav();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorModel#GetIsEditorReadOnly()"></seealso>
    bool GetIsEditorReadOnly();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorModel#GetEnableApplyButton()"></seealso>
    bool GetEnableApplyButton();
  }
}