using System;
using com.plumtree.uiinfrastructure.activityspace;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.errordisplay
{
  /// <summary>
  /// This control provides control functionality for views and models
  /// responsible for displaying error messages.
  /// </summary>
  /// <author>BenG</author>
  public class ErrorControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.errordisplay.ErrorControl");
    // MVC Control Object Name
    public const String STR_MVC_CLASS_NAME = "ErrorControl";
    // TODOCR JF 12/10/02 - What is this?
    public const String PARAM_CLEAR_ERROR = "clearerror";
    protected AErrorModel m_model;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      log.Debug("Execute()");
      String[] strError = (String[]) arguments.GetElement(PARAM_CLEAR_ERROR);
      if ((strError != null) && (strError[0] != null))
      {
        log.Debug("About to clear error: " + strError[0]);
        m_model.ClearError(strError[0]);
      }
      Redirect myRedirect = null;
      return myRedirect;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ErrorControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#Init(IModelRW)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_model = (AErrorModel) model;
    }
  }
}