using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.errordisplay
{
  /// <summary>
  /// This interface is designed to allow developers to provide their own
  /// implementations of whether or not a user can see admin errors.
  /// </summary>
  public interface IAdminUIErrorHelper
  {
    
    /// <summary>
    /// Call this method to obtain a boolean value indicating whether or not
    /// the current user should see errors intended for administrators.
    /// <br /><br />
    /// </summary>
    /// <param name="Object">session</param>
    /// <returns>boolean value</returns>
    bool GetDisplayAdminErrors(Object session);
    
    /// <summary>
    /// Call this method to obtain a boolean value indicating whether or not
    /// the current user should see errors intended for administrators.
    /// <br /><br />
    /// </summary>
    /// <param name="AActivitySpace"></param>
    /// <returns>boolean value</returns>
    bool GetDisplayAdminErrors(AActivitySpace space);
  }
}