using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.errordisplay
{
  /// <author>
  /// BenG
  /// read-only interface to the ErrorModel classes.
  /// </author>
  public interface IErrorModelRO : IModelRO
  {
    
    /// <summary>
    /// Call to determine if this view should dispaly errors requiring a separate
    /// display page.
    /// <br /><br />
    /// </summary>
    /// <returns>boolean value.</returns>
    bool GetDisplaySeparatePageErrors();
    
    /// <summary>
    /// Call to obtain an enumeration of those UIError objects appropriate
    /// for viewing by the current user.
    /// <br /><br />
    /// </summary>
    /// <returns>IXPEnumerator of PTErrors.</returns>
    IXPEnumerator GetErrors();
    
    /// <summary>
    /// Call this method to determine whether or not this view should display
    /// only those errors associated with the current activity space.
    /// <br /><br />
    /// </summary>
    /// <returns>boolean value</returns>
    bool GetErrorsAssociatedWithAnAS();
  }
}