using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.errordisplay
{
  /// <author>
  /// Ben Geislinger
  /// This model is for use with the MVC responsible for displaying those
  /// errors requiring their own display page.
  /// </author>
  public class SinglePageErrorModel : ErrorModel
  {
    public const String STR_MVC_CLASS_NAME = "SinglePageErrorModel";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SinglePageErrorModel();
    }
    
    /// <summary>
    /// Returns true.
    /// </summary>
    /// <returns>boolean true</returns>
    public override bool GetDisplaySeparatePageErrors()
    {
      return true;
    }
    
    /// <summary>
    /// Returns false.  This MVC must retrieve all errors regardless of the
    /// activity space with which they're associated.
    /// </summary>
    /// <returns>boolean false</returns>
    public override bool GetErrorsAssociatedWithAnAS()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IModel#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits the Model with the Activity Space.
    /// </summary>
    /// <param name="parent"></param>
    public override void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}