using System;
using XPSortedDictionary=com.plumtree.openfoundation.util.XPSortedDictionary;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.form.pagination;
// Framework Imports
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.uiinfrastructure.expandablelist
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface IExpListModelRO : IPaginationModelRO
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddIcon()"></seealso>
    PTImageType GetAddIcon();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddIconAlt()"></seealso>
    String GetAddIconAlt();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddLabel()"></seealso>
    String GetAddLabel();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAlertMessageForEmptyList()"></seealso>
    String GetAlertMessageForEmptyList();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetArrExpListColInfo()"></seealso>
    Object[][] GetArrExpListColInfo();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetDeleteIcon()"></seealso>
    PTImageType GetDeleteIcon();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetDeleteIconAlt()"></seealso>
    String GetDeleteIconAlt();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEmptyListInstructions()"></seealso>
    String GetEmptyListInstructions();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEmptyListMainMessage()"></seealso>
    String GetEmptyListMainMessage();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEnableMoveRowActions()"></seealso>
    bool GetEnableMoveRowActions();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetListAccessFlag()"></seealso>
    bool GetIsListReadOnly();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetMainColumnSort()"></seealso>
    int GetMainColumnSort();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetMainColumnSortDirection()"></seealso>
    int GetMainColumnSortDirection();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetReadOnlyItems()"></seealso>
    IPTGrowableSortedArrayWrapperRO GetReadOnlyItems();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetSectionTitle()"></seealso>
    String GetSectionTitle();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetUniqueInt()"></seealso>
    int GetUniqueInt(int _nValue);
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetUniqueInputName()"></seealso>
    String GetUniqueString(String _sName);
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsAddButtonDisabled()"></seealso>
    bool IsAddButtonDisabled();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsCheckBoxesDisabled()"></seealso>
    bool IsCheckBoxesDisabled();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetTableIntructions()"></seealso>
    String GetTableInstructions();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetWrapColumnHeaders()"></seealso>
    bool GetWrapColumnHeaders();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetWrapColumnHeaders()"></seealso>
    String GetDelRowConfirmMsg();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetListKey()"></seealso>
    int GetListKey();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetModelStorageName()"></seealso>
    String GetModelStorageName();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsPaginationEnabled()"></seealso>
    bool IsPaginationEnabled();
    
    /// <returns></returns>
    XPSortedDictionary GetUnusedProperties();
  }
}