using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.filedownload
{
  /// <author>adolfoc</author>
  public class FileDownloadModel : IModel
  {
    public const String STR_MVC_CLASS_NAME = "FileDownloadModel";
    private AActivitySpace m_asOwner = null;
    private String m_strContentTypeToDownload = "";
    private String m_strSessionKeyToDownload = "";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new FileDownloadModel();
    }
    
    /// <summary>
    /// Returns the contentTypeToDownload.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetContentTypeToDownload()
    {
      return m_strContentTypeToDownload;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the sessionKeyToDownload.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetSessionKeyToDownload()
    {
      return m_strSessionKeyToDownload;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <summary>
    /// Sets the contentTypeToDownload.
    /// </summary>
    /// <param name="contentTypeToDownload">The contentTypeToDownload to set</param>
    public virtual void SetContentTypeToDownload(String contentTypeToDownload)
    {
      m_strContentTypeToDownload = contentTypeToDownload;
    }
    
    /// <summary>
    /// Sets the sessionKeyToDownload.
    /// </summary>
    /// <param name="sessionKeyToDownload">The sessionKeyToDownload to set</param>
    public virtual void SetSessionKeyToDownload(String sessionKeyToDownload)
    {
      m_strSessionKeyToDownload = sessionKeyToDownload;
    }
  }
}