using System;
namespace com.plumtree.uiinfrastructure.form
{
  /// <summary>
  /// This class implements the HTML to print out the Finish and Cancel
  /// at the top of the form. This View is printed out by AFormDP.  To
  /// turn this header on ... go to AFormDP::SetShowFormHeader()
  /// This is the normal page header.
  /// </summary>
  /// <author>Don Hayler</author>
  public class FormHeaderView : AFormHeaderView
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "FormHeader";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new FormHeaderView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}