using System;
using com.plumtree.uiinfrastructure.constants;
namespace com.plumtree.uiinfrastructure.form
{
  /// <summary>
  /// This class implements the HTML to print out the OK and Cancel
  /// at the top of the form. This View is printed out by AFormDP.  To
  /// turn this header on ... go to AFormDP::SetShowFormHeader()
  /// This is the medium popup header.
  /// </summary>
  /// <author>DonH</author>
  public class MediumFormHeaderView : AFormHeaderView
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MediumFormHeader";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MediumFormHeaderView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormHeaderView#GetFinishButtonText()"></seealso>
    protected override String GetFinishButtonText()
    {
      // "OK"
      return m_asOwner.GetString(66, ResourceConstants.INFRASTRUCTURE);
    }
  }
}