using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.form.pagination
{
  /// <summary>
  /// This interface allows the PaginationControl to set which objects the
  /// user would like displayed.
  /// </summary>
  /// <author>Don Hayler</author>
  public interface IPaginationModel : IModel,IPaginationModelRO
  {
    
    /// <summary>
    /// This is used by the PaginationControl to set which objects should
    /// be displayed.
    /// </summary>
    /// <param name="nPaginationID">
    /// Unique ID of objects to paginate (usually class
    /// id) when there are multiple pagination sections per page.
    /// </param>
    /// <param name="nPaginationLowerBound">The starting count for objects to display</param>
    /// <param name="nPaginationUpperBound">The ending count for objects to display.</param>
    void SetPagination(int nPaginationID, int nPaginationLowerBound, int nPaginationUpperBound);
    }
}