using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.form.sort
{
  /// <summary>
  /// This model interface needs to be implemented to use
  /// the sort framework.
  /// </summary>
  /// <author>Don Hayler</author>
  public interface ISortModel : ISortModelRO,IModel
  {
    
    /// <summary>
    /// Set the sort to use.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.arraywrapper.PTSortedArrayWrapper"></seealso>
    /// <param name="nSortID">the ID of the objects to sort on.</param>
    /// <param name="nSortHeader">the index of the header to sort (starting with 0).</param>
    /// <param name="nSortDirection">
    /// PTSortedArrayWrapper.PTSAW_SORT_ASCENDING or
    /// PTSortedArrayWrapper.PTSAW_SORT_DESCENDING.
    /// </param>
    void SetSort(int nSortID, int nSortHeader, int nSortDirection);
  }
}