using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.form.sort
{
  /// <summary>
  /// This model interface needs to be implemented to use
  /// the sort framework.
  /// </summary>
  /// <author>Don Hayler</author>
  public interface ISortModelRO : IModelRO
  {
    
    /// <summary>
    /// Get the sort direction for the currently sorted header column.
    /// This should return either PTSortedArrayWrapper.PTSAW_SORT_ASCENDING
    /// or PTSortedArrayWrapper.PTSAW_SORT_DESCENDING.
    /// This method only needs to return useful information if GetSortable()
    /// returns true.
    /// </summary>
    /// <returns>int the sort direction from PTSortedArrayWrapper.</returns>
    int GetSortDirection();
    
    /// <summary>
    /// Get the column id of the header that is currently sorted (starting with 0).
    /// This method only needs to return useful information if GetSortable()
    /// returns true.
    /// </summary>
    /// <returns>int the column id of the currently sorted header column.</returns>
    int GetSortedHeader();
  }
}