using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.help
{
  /// <author>
  /// donh
  /// This Control retrieves the help URL from the query string.
  /// </author>
  public class HelpControl : IControl
  {
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HelpControl";
    
    /// <summary>
    /// Query string argument of the help topic to display. 
    /// </summary>
    public const String STR_HELP_TOPIC = "HelpTopic";
    
    /// <summary>
    /// Query string argument of the previous URL. 
    /// </summary>
    public const String STR_PREVIOUS_URL = "PrevURL";
    protected HelpFrameAS m_asOwner;
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] strTopic = (String[]) arguments.GetElement(STR_HELP_TOPIC);
      if (null != strTopic)
      {
        m_asOwner.m_strHelpTopic = strTopic[0];
      }
      String[] strURL = (String[]) arguments.GetElement(STR_PREVIOUS_URL);
      if ((null != strURL) && (null != strURL[0]))
      {
        m_asOwner.m_strPreviousRequestURL = XPHttpUtility.UrlDecode(strURL[0],
         LinkConstants.UTF_8_ENCODING);
      }
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public virtual void Init(IModel model, AActivitySpace parent)
    {
      m_asOwner = (HelpFrameAS) parent;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public virtual Object Create()
    {
      return new HelpControl();
    }
  }
}