using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.help
{
  /// <author>
  /// donh
  /// This Activity Space provides a frameset with a "back" navigation
  /// link at the bottom for 508 users.
  /// </author>
  public class HelpFrameAS : AActivitySpace
  {
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HelpFrame";
    public String m_strPreviousRequestURL = null;
    public String m_strHelpTopic = null;
    
    /// <summary>
    /// Initialize the Activity Space.
    /// </summary>
    public override void Init()
    {
      base.Init();
      RegisterControl(HelpControl.STR_MVC_CLASS_NAME, null);
      RegisterPage(new HelpFrameSetDP());
      RegisterPage(new HelpBackFrame());
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
     */
     
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public override Object Create()
    {
      return new HelpFrameAS();
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}