using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.openfoundation.util;
namespace com.plumtree.uiinfrastructure.help
{
  /// <author>
  /// donh
  /// This Display Page provides a frameset with a "back" navigation
  /// link at the bottom for 508 users.
  /// </author>
  public class HelpFrameSetDP : FrameSetDP
  {
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HelpFrameSet";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()
     */
     
    public override String GetFrameSetTitle()
    {
      return m_asOwner.GetString(152, "ptmsgs_infrastructure");
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
     */
     
    public override ASURL GetFrameURLTop()
    {
      // Returning null means to use GetFrameURLStringTop().
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
     */
     
    public override String GetFrameURLStringTop()
    {
      String strHelpTopic = ((HelpFrameAS) m_asOwner).m_strHelpTopic;
      if ((!XPStringUtility.EndsWith(strHelpTopic, ".htm")) || (!XPStringUtility.EndsWith(strHelpTopic,
       ".html")))
      {
        strHelpTopic = strHelpTopic + ".htm";
      }
      String strHelpURL = HTMLConstructHelpers.Get508HelpBaseUrl(m_asOwner) + strHelpTopic;
      return strHelpURL;
    }
    
    /// <summary>
    /// Set Frame Scroll Top
    /// </summary>
    /// <returns>boolean true implies scrolling</returns>
    public override bool GetFrameScrollTop()
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()
     */
     
    public override ASURL GetFrameURLBody()
    {
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(HelpBackFrame.STR_MVC_CLASS_NAME);
      return result;
    }
    
    /// <summary>
    /// Set Frame Name Top
    /// The frame name and title are used by 508 users.
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameNameTop()
    {
      return m_asOwner.GetString(152, "ptmsgs_infrastructure");
    }
    
    /// <summary>
    /// Set Frame Name Body
    /// The frame name and title are used by 508 users.
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameNameBody()
    {
      return m_asOwner.GetString(151, "ptmsgs_infrastructure");
    }
    
    /// <summary>
    /// Set Frame Title Top
    /// The frame name and title are used by 508 users.
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameTitleTop()
    {
      return m_asOwner.GetString(152, "ptmsgs_infrastructure");
    }
    
    /// <summary>
    /// Set Frame Title Body
    /// The frame name and title are used by 508 users.
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameTitleBody()
    {
      return m_asOwner.GetString(151, "ptmsgs_infrastructure");
    }
    /*	public HTMLElementCollection GetNoFrames()
     {
     HTMLElementCollection result = new HTMLElementCollection();
     
     result.AddInnerHTMLString("Your Browser Does Not Support Frames. Here is the ");
     
     String strHelpTopic = ((HelpFrameAS) m_asOwner).m_strHelpTopic;
     
     if ((!strHelpTopic.endsWith(".htm")) || (!strHelpTopic.endsWith(".html")))
     {
     strHelpTopic = strHelpTopic + ".htm";
     }
     
     String strHelpURL =  HTMLConstructHelpers.Get508HelpBaseUrl(m_asOwner)
     + strHelpTopic;
     
     
     HTMLAnchor helpAnchor = new HTMLAnchor("#");
     helpAnchor.SetHRef(strHelpURL);
     helpAnchor.AddInnerHTMLString("non-frame based version of the help page.");
     helpAnchor.SetTitle("Help page");
     
     result.AddInnerHTMLElement(helpAnchor);
     
     return result;
     }
     */
     
    
    /// <summary>
    /// Set FrameSet Attributes
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameSetAttributes()
    {
      return "*,50px";
    }
  }
}