using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.htmlconstructs
{
  /// <author>beng</author>
  public class UIListItem : PTListItem
  {
    //	private String _ui_new = "new!";
    //	private String _ui_updated = "updated!";
    private AActivitySpace myASpace = null;
    public UIListItem(String title, String titleHRef, AActivitySpace aSpace) : base(title,
     titleHRef)
    {
      myASpace = aSpace;
    }
    
    /// <summary>
    /// Call this method to construct a new PTListItem. <br /><br />
    /// <br /><br />
    /// Use this constructor if you wish for the title of this item to be just
    /// a String, as opposed to an anchor.
    /// </summary>
    /// <param name="title">Pass a String that is the title of this item.</param>
    public UIListItem(String title, AActivitySpace aSpace) : base(title)
    {
      myASpace = aSpace;
    }
    
    /// <summary>
    /// Call this method to construct a new PTListItem. <br /><br />
    /// </summary>
    /// <param name="a">Pass the HTMLAnchor that will appear as the title of this item.</param>
    public UIListItem(HTMLAnchor a, AActivitySpace aSpace) : base(a)
    {
      myASpace = aSpace;
    }
    protected override HTMLElement GetNewIndicator()
    {
      //	overrides PTListItem.GetNewIndicator.  This method is capable of
      //	using localized strings.
      HTMLSpan tempSpan = new HTMLSpan();
      tempSpan.SetStyleClass(PTStyleClass.LIST_NEW_TEXT);
      tempSpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      tempSpan.AddInnerHTMLEncodedString(myASpace.GetString(1577, ResourceConstants.PORTALBROWSINGMSGS));
      return tempSpan;
    }
    protected override HTMLElement GetUpdatedIndicator()
    {
      //	overrides PTListItem.GetUpdatedIndicator  This method is capable of
      //	using localized strings.
      HTMLSpan tempSpan = new HTMLSpan();
      tempSpan.SetStyleClass(PTStyleClass.LIST_UPDATED_TEXT);
      tempSpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      tempSpan.AddInnerHTMLEncodedString(myASpace.GetString(1578, ResourceConstants.PORTALBROWSINGMSGS));
      return tempSpan;
    }
  }
}