using System;
using com.plumtree.openfoundation.web;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.uiinfrastructure.interpreter
{
  /// <summary>
  /// This inteface will be implemented by a class in the portaluiinfrastucture
  /// as a hook to call methods unavailable to uiinfrastructure like executing
  /// the Expression Engine
  /// </summary>
  /// <author>dustina</author>
  public interface IExpressionEvaluator
  {
    
    /// <summary>
    /// Hook function so that the Expression Engine can be executed
    /// in the uiinfrasrtucture
    /// </summary>
    void EvaluateExpressionForLogInDestination(AActivitySpace asCurrentSpace,
     IApplication application, IXPRequest xpRequest, Object ptUserSession);
    
    /// <summary>
    /// Hook function so that the Expression Engine can be executed
    /// in the uiinfrasrtucture
    /// </summary>
    void EvaluateExpressionForSubportalAction(AActivitySpace asCurrentSpace,
     IApplication application, IXPRequest xpRequest, Object ptUserSession);
    }
}