using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.interpreter;
namespace com.plumtree.uiinfrastructure.login
{
  /// <summary>
  /// This interface defines the extensible SSO helper code for custom
  /// SSO implementations.
  /// </summary>
  /// <author>
  /// mikej
  /// Created on Mar 13, 2003
  /// </author>
  public interface ISSOHelper
  {
    
    /// <summary>
    /// Returns true if SSO is enabled at the portal level.
    /// This does not take into account subportal settings
    /// and should only be used as a default setting if the
    /// subportal does not specify if SSO is enabled or disabled.
    /// To access the subportal SSO setting, use SSOAuthenticator.UseThisAuth().
    /// </summary>
    /// <returns></returns>
    bool IsSSOEnabled();
    
    /// <param name="tempData"></param>
    /// <param name="sQueryString"></param>
    /// <returns></returns>
    Redirect DoLoginRedirect(RequestData tempData, String sQueryString);
    
    /// <param name="tempData"></param>
    /// <returns></returns>
    bool DoLogoutRedirect(RequestData tempData);
  }
}