using System;
using com.plumtree.openlog;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.opener
{
  /// <summary>
  /// This AActivitySpace enables client programmers to easily and generically
  /// open objects in the Plumtree system.
  /// </summary>
  /// <author>John Osborne</author>
  /// <author>Ricky Wong</author>
  public class BaseOpenerAS : AActivitySpace
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.opener.BaseOpenerAS");
    public const String STR_MVC_CLASS_NAME = "Opener";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
     */
     
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public override Object Create()
    {
      return new BaseOpenerAS();
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      return BaseOpenerAS.STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()
     */
     
    public override void Init()
    {
      base.Init();
      // register and make our control the default one.
      RegisterControl(BaseOpenerControl.STR_MVC_CLASS_NAME, null);
      RegisterControl(BaseOpenerControl.STR_MVC_CLASS_NAME, "", null);
    }
  }
}