using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.opener
{
  /// <summary>
  /// Interface that needs to be implemented when creating an
  /// OpenerPlugin.  Plugins are run at the beginning of the 
  /// Common Opener processing, allowing one to interpret the
  /// Querystring arguments and act accordingly.
  /// </summary>
  /// <author>RickyW</author>
  public interface IOpenerPlugins
  {
    
    /// <param name="_redirectData">Object that encapsulates the current destination.</param>
    /// <param name="_asCurrentSpace">The activity space provides access to more information.</param>
    /// <param name="_userSession">Quick reference to the often used session.</param>
    /// <returns>RedirectData object that encapsulates the new destination.</returns>
    RedirectData ProcessPlugIn(RedirectData _redirectData, AActivitySpace _asCurrentSpace,
     Object _userSession);
  }
}