using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.opener;
namespace com.plumtree.uiinfrastructure.opener.types
{
  /// <summary>
  /// TODO Add Description.
  /// </summary>
  public abstract class AUIClassTypeDesc : IUIClassTypeDesc
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.opener.types.AUIClassTypeDesc");
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IUIClassTypeDesc#GetClassName()
     */
     
    public abstract String GetClassName();
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetClassKey()
     */
     
    public virtual String GetClassKey()
    {
      return GetClassName();
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetClassType()
     */
     
    public virtual ClassTypeEnum GetClassType()
    {
      return ClassTypeEnum.UICLASSTYPE;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetDefaultOpenerMode()
     */
     
    public virtual int GetDefaultOpenerMode()
    {
      // UI ClassTypes really only open one way.
      return IOpenerConstants.OPENER_MODE_VIEW;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, null)
     */
     
    public abstract Redirect GetRedirectViewObject(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession);
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectCreateNew(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public virtual Redirect GetRedirectCreateNew(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // UI ClassTypes really only open one way.
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObjectMetaData(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public virtual Redirect GetRedirectViewObjectMetaData(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // UI ClassTypes really only open one way.
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectSearchBrowse(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public virtual Redirect GetRedirectSearchBrowse(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // UI ClassTypes really only open one way.
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectSearchEdit(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public virtual Redirect GetRedirectSearchEdit(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // UI ClassTypes really only open one way.
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetRedirectOpenObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public virtual Redirect GetRedirectOpenObject(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // UI ClassTypes really only open one way.
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
  }
}