using System;
using com.plumtree.openlog;
namespace com.plumtree.uiinfrastructure.opener.types
{
  public class ClassTypeEnum
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.opener.types.ClassTypeEnum");
    private int m_classTypeID;
    public static readonly ClassTypeEnum PTCLASSTYPE = new ClassTypeEnum(0);
    public static readonly ClassTypeEnum UICLASSTYPE = new ClassTypeEnum(1);
    public static readonly ClassTypeEnum[] m_classTypeEnums = {PTCLASSTYPE,
     UICLASSTYPE};
    // TODO: move to a sub class
    
    /// <summary>
    /// Private constructor.
    /// </summary>
    private ClassTypeEnum(int classTypeID)
    {
      m_classTypeID = classTypeID;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
     
    public override String ToString()
    {
      String classType = "UNDEFINED";
      switch (m_classTypeID){
      case 0:
      classType = "PTCLASSTYPE";
      break;
      case 1:
      classType = "UICLASSTYPE";
      break;
      }
      return classType;
    }
    
    /// <summary>
    /// Retrieves the int ID for this class type.
    /// </summary>
    /// <returns>int ID for this class type.</returns>
    public virtual int GetID()
    {
      return m_classTypeID;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
     
    public sealed override bool Equals(Object o)
    {
      bool retval = false;
      try
      {
        retval = (((ClassTypeEnum) o).GetID() == m_classTypeID);
      }
      catch (Exception e)
      {
        log.Error(e, "Invalid comparison");
      }
      return retval;
    }
  }
}