using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.uiinfrastructure.opener.types
{
  /// <summary>
  /// This interface describes the Opener Type Manager.
  /// </summary>
  public interface IClassTypeManager
  {
    
    /// <summary>
    /// Returns the default opener mode for this class type.
    /// </summary>
    /// <param name="__strClassKey"></param>
    /// <returns>The default opener mode for this class type. </returns>
    int GetDefaultOpenerMode(String _strClassKey);
    
    /// <summary>
    /// Returns the Opener redirect for this class type.
    /// </summary>
    /// <param name="_strClassKey"></param>
    /// <param name="_nOpenerMode"></param>
    /// <param name="_htArguments"></param>
    /// <param name="_asParent"></param>
    /// <param name="_userSession"></param>
    /// <returns>The redirect for this request.</returns>
    Redirect GetOpenerRedirect(String _strClassKey, int _nOpenerMode, XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession);
  }
}