using System;
namespace com.plumtree.uiinfrastructure.opener.types
{
  /// <summary>
  /// Interface for UIClassTypeDesc.  
  /// </summary>
  /// <author>Ricky Wong</author>
  public interface IUIClassTypeDesc : IClassTypeDesc
  {
    
    /// <summary>
    /// Returns the class name of the class type. This is a unique string that 
    /// identifies this class.  When the Opener sees "open=XYZ" where "XYZ" is 
    /// not an integer, it will invoke the ClassTypeDesc with the matching class
    /// name.  Note that class name should not be an integer representation, i.e.
    /// "512", because it will collide with PT_CLASSIDS.
    /// </summary>
    /// <returns>The class name of the class type.</returns>
    String GetClassName();
  }
}