using System;
namespace com.plumtree.uiinfrastructure.pagecontrols.framework
{
  /// <summary>
  /// This abstract class defines some basic elements that all Validators share.
  /// A Validator is an object used by Page Controls to validate their input against 
  /// its internal criteria that standardizes Page Control Validation. Each Validator
  /// has a Validate method for server side validation and has a GetJSValidationCode
  /// & GetJSFunction method for client side validation.
  /// </summary>
  /// <author>caiusv</author>
  public abstract class AValidator
  {
    
    /// <summary>
    /// error message associated with this validator 
    /// </summary>
    public String m_sErrorMessage;
    
    /// <summary>
    /// Returns the error message
    /// </summary>
    /// <returns>the m_sErrorMessage</returns>
    public virtual String GetErrorMessage()
    {
      return m_sErrorMessage;
    }
    
    /// <summary>
    /// Sets the error message
    /// </summary>
    /// <param name="errorMessage">the error message</param>
    public virtual void SetErrorMessage(String errorMessage)
    {
      m_sErrorMessage = errorMessage;
    }
  }
}