using System;
namespace com.plumtree.uiinfrastructure.pagecontrols.framework
{
  /// <summary>
  /// Differnt products may want to manage version numbers for their JS components
  /// in different ways. This interface allows them to manager JS component
  /// versioning themselves, without making the page-controls framework dependent
  /// on any particular system of JS component version management. Note: if you
  /// are confused about JS Components and versioning of these, please consult
  /// the documentation for the JSRegistry project.
  /// </summary>
  /// <author>JohnO</author>
  public interface IJSComponentVersionMgr
  {
    
    /// <summary>
    /// Given a JS Component name like "jsdatepicker", this method will return a
    /// version number (like 74565). If no version number can be found, it
    /// should return -1.
    /// </summary>
    /// <param name="_strJSComponentName">
    /// The name of the component for which one wants
    /// the version number.
    /// </param>
    /// <returns></returns>
    int GetJSComponentVersionNumber(String _strJSComponentName);
  }
}
// TODO: Make sure that clients are returning -1 if not found...
