using System;
using com.plumtree.openlog;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.pagecontrols.framework;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols
{
  /// <author>CaiusV</author>
  public class HTMLHidden : AHTMLComponent,IPageControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols.HTMLHidden");
    private const String STR_HTML_INPUT_BASE_NAME = "in_hi_pc";
    public const String STR_MVC_CLASS_NAME = "HTMLHidden";
    
    /// <summary>
    /// Creates a new HTMLHidden object
    /// </summary>
    public HTMLHidden()
    {
    }
    
    /// <summary>
    /// JF- Initializes a new AHTMLComponent object.
    /// </summary>
    /// <param name="_ptComponentMgr">The component manager for this component.</param>
    /// <param name="_strUniqueInstanceID">The unique ID for this component.</param>
    public override void Init(PageMgr _ptPageMgr, String _strUniqueInstanceID)
    {
      base.Init(_ptPageMgr, _strUniqueInstanceID);
    }
    
    /// <summary>
    /// Returns the base name of this HTML Component.
    /// </summary>
    /// <returns>String</returns>
    protected override String GetHTMLComponentBaseName()
    {
      return STR_HTML_INPUT_BASE_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for this component.
    /// </summary>
    /// <returns></returns>
    public override HTMLElementCollection GetComponentHTML()
    {
      HTMLElementCollection retValue = new HTMLElementCollection();
      HTMLInput htmlHidden = new HTMLInput(HTMLInputTypes.HIDDEN_TYPE, GetHTMLComponentName(),
       "");
      htmlHidden.SetValue(GetHTMLComponentValue());
      retValue.AddInnerHTMLElement(htmlHidden);
      return retValue;
    }
    
    /// <summary>
    /// This method is used by the ASManager to return new instances of managed
    /// objects.
    /// </summary>
    /// <returns>A new instance of the managed class (i.e. return new Foo();)</returns>
    public override Object Create()
    {
      return new HTMLHidden();
    }
    
    /// <summary>
    /// Return the name of the MVC object.
    /// </summary>
    /// <returns>the name of the object.</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}