using System;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.pagecontrols.framework;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols
{
  /// <author>JohnO</author>
  public class HTMLTextBox : AHTMLComponent,IPageControl
  {
    
    /// <summary>
    /// for logging 
    /// </summary>
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
     "com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols.HTMLTextBox");
    private const String STR_HTML_INPUT_BASE_NAME = "in_tx_pc";
    public const String STR_MVC_CLASS_NAME = "HTMLTextBox";
    
    /// <summary>
    /// the HTMLInput object this wraps 
    /// </summary>
    public HTMLInput m_ptHTMLInput;
    
    /// <summary>
    /// JF- Initializes a new AHTMLComponent object.
    /// </summary>
    /// <param name="_ptComponentMgr">The component manager for this component.</param>
    /// <param name="_strUniqueInstanceID">The unique ID for this component.</param>
    public override void Init(PageMgr _ptPageMgr, String _strUniqueInstanceID)
    {
      base.Init(_ptPageMgr, _strUniqueInstanceID);
      m_ptHTMLInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, GetHTMLComponentName(),
       "");
    }
    
    /// <summary>
    /// Creates a new HTMLTextBox object
    /// </summary>
    public HTMLTextBox()
    {
    }
    
    /// <summary>
    /// Returns the base name of this HTML Component.
    /// </summary>
    /// <returns>String</returns>
    protected override String GetHTMLComponentBaseName()
    {
      return STR_HTML_INPUT_BASE_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for this component.
    /// </summary>
    /// <returns></returns>
    public override HTMLElementCollection GetComponentHTML()
    {
      HTMLElementCollection retValue = new HTMLElementCollection();
      m_ptHTMLInput = SetParameters(m_ptHTMLInput);
      retValue.AddInnerHTMLElement(m_ptHTMLInput);
      return retValue;
    }
    
    /// <summary>
    /// This method is used by the ASManager to return new instances of managed
    /// objects.
    /// </summary>
    /// <returns>A new instance of the managed class (i.e. return new Foo();)</returns>
    public override Object Create()
    {
      return new HTMLTextBox();
    }
    
    /// <summary>
    /// Return the name of the MVC object.
    /// </summary>
    /// <returns>the name of the object.</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}