using System;
using com.plumtree.uiinfrastructure.pagecontrols.framework;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker;
using com.plumtree.xpshared.jsutil;
namespace com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker
{
  /// <summary>
  /// JSDateTimePickerMgr is the ComponentMgr for JSDateTimePickerMgr and doesn't
  /// currently do anything not handled by the JSDatePickerMgr which this class
  /// extends.
  /// </summary>
  /// <author>John Osborne</author>
  public class JSDateTimePickerMgr : JSDatePickerMgr
  {
    public const String STR_CLASS_NAME = "JSDateTimePickerMgr";
    
    /// <summary>
    /// Creates a new JSDateTimePickerMgr object.
    /// </summary>
    /// <param name="_ptJSRegistry">The JS Registry is needed to get the JS includes</param>
    /// <param name="_ptJSCompVerMgr">
    /// The component version manager interface allows us
    /// to the version of this control that is registered with the
    /// product as a whole
    /// </param>
    /// <param name="_ptPageMgr">
    /// The locale that should be used by the datepickers
    /// under the control of this manager
    /// </param>
    public JSDateTimePickerMgr(JSRegistry _ptJSRegistry, IJSComponentVersionMgr _ptJSCompVerMgr,
     PageMgr _ptPageMgr) : base(_ptJSRegistry, _ptJSCompVerMgr, _ptPageMgr)
    {
    }
  }
}