using System;
namespace com.plumtree.uiinfrastructure.pagination
{
  /// <author>
  /// CraigS
  /// General interface for pagination.
  /// </author>
  public interface IPagination
  {
    
    /// <summary>
    /// Go to another page.
    /// </summary>
    /// <param name="sortOrder">Sort order in which firstItemOnPage should be interpreted</param>
    /// <param name="firstItemOnPage">First item to appear on page (1-based)</param>
    /// <param name="pageSize">Desired number of items on page</param>
    /// <param name="additionalInfo">Additional application-specific info, if needed</param>
    void GoToPage(String sortOrder, int firstItemOnPage, int pageSize, Object additionalInfo);
    }
}