using System;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.tree
{
  /// <author>Don Hayler</author>
  public interface ITreeIterator
  {
    
    /// <returns></returns>
    int GetCurrentClassID();
    
    /// <returns></returns>
    bool GetCurrentForceSelectable();
    
    /// <summary>
    /// This method returns an image for the current node.  This will
    /// automatically handle open and closed images.  The alt tag
    /// should already be set on this image.
    /// </summary>
    /// <returns>HTMLImg the current image element</returns>
    HTMLImg GetCurrentImage();
    
    /// <summary>
    /// Returns the encoded and truncated name.
    /// </summary>
    /// <returns></returns>
    String GetCurrentEncodedName();
    
    /// <returns></returns>
    int GetCurrentObjectID();
    
    /// <returns></returns>
    bool GetCurrentSelected();
    
    /// <returns></returns>
    int GetCurrentTreeNodeID();
  }
}