using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.uiinfrastructure.tree
{
  /// <summary>
  /// This page displays the main section of the tree, including the
  /// sub-title bar.
  /// </summary>
  /// <author>Don Hayler</author>
  public class TreeDP : AFormDP
  {
    
    /// <summary>
    /// name of the tree DP 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "Tree";
    
    /// <summary>
    /// storage name for tree bar view 
    /// </summary>
    public const String TREE_BAR_STORAGE_NAME = "TreeBar";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      // This page is displayed in a frame, so doesn't need a title.
      return "";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Add the tree bar named anchor so we can link back to here.
      HTMLAnchor myAnchor = new HTMLAnchor("");
      myAnchor.SetName(ATreeAS.TREE_BAR_ANCHOR);
      result.AddInnerHTMLElement(myAnchor);
      result.AddInnerHTMLElement(m_asOwner.GetView(TREE_BAR_STORAGE_NAME).Display());
      result.AddInnerHTMLElement(m_asOwner.GetView(TreeView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()">
    /// This is a helper method that all classes that inherit from AFormDP can override
    /// if they like.  The method provides a hook into the head so that DP's can add javascript.
    /// Simply override and return and HTMLScript.  Also, it is best to return the results of the
    /// DisplayJavaScript functions from the appropriate views.
    /// </seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(TreeView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
  }
}