using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.uiinfrastructure.tree
{
  /// <summary>
  /// The main frameset for the tree.  Contains the top frame with buttons,
  /// bottom frame with selected items, and scrolling body frame for the tree.
  /// </summary>
  /// <author>Don Hayler</author>
  public class TreeFrameDP : FrameSetDP
  {
    
    /// <summary>
    /// Frameset object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "TreeFrame";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBody()"></seealso>
    public override bool GetFrameScrollBody()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()"></seealso>
    public override String GetFrameSetAttributes()
    {
      return "35px,50%";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()"></seealso>
    public override String GetFrameSetTitle()
    {
      ITreeModelRO myModel = (ITreeModelRO) m_asOwner.GetModel(ATreeAS.TREEMODEL);
      return myModel.GetTitle();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      // Display the tree itself
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(TreeDP.STR_MVC_CLASS_NAME);
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()"></seealso>
    public override ASURL GetFrameURLTop()
    {
      // Display the form header
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(TreeHeaderDP.STR_MVC_CLASS_NAME);
      return result;
    }
  }
}