using System;
namespace com.plumtree.xpshared.htmlconstructs
{
  /// <author>
  /// beng  This class is used to provide an identifier for a specific
  /// html element  within a factory produced construct. <br />
  /// <br />
  /// For example, all banner constructs have an internal html element
  /// that contains the title of the banner.  This html element might be
  /// of type HTMLSpan, HTMLTableCell, etc, but it will always have the
  /// same ElementName. <br /><br />
  /// </author>
  public class ElementName
  {
    internal String sName;
    //   package-private
    
    /// <summary>
    /// Creates a new ElementName object.
    /// </summary>
    /// <param name="s">String name of this ElementName.</param>
    public ElementName(String s)
    {
      sName = s;
    }
    
    /// <summary>
    /// Get the String name of this ElementName
    /// </summary>
    /// <returns>String name</returns>
    public virtual String GetName()
    {
      return sName;
    }
  }
}