using System;
namespace com.plumtree.xpshared.htmlelements
{
  /// <summary>
  /// Title:        HTMLListTypes Description: Copyright:    Copyright (c) 2002
  /// Company:      Plumtree Software
  /// </summary>
  /// <version>1.0</version>
  /// <author>Chris Bucchere</author>
  public class HTMLListTypes
  {
    public const int GLOSSARY_LIST = 0;
    public const int ORDERED_LIST = 1;
    public const int UNORDERED_LIST = 2;
    public const int LINEBREAKS_ONLY = 3;
    
    /// <param name="listType"></param>
    /// <returns></returns>
    public static String GetListClosingTag(int listType)
    {
      switch (listType){
      case HTMLListTypes.GLOSSARY_LIST:
      return "</dl>";
      goto case HTMLListTypes.ORDERED_LIST;
      case HTMLListTypes.ORDERED_LIST:
      return "</ol>";
      goto case HTMLListTypes.UNORDERED_LIST;
      case HTMLListTypes.UNORDERED_LIST:
      return "</ul>";
      goto case HTMLListTypes.LINEBREAKS_ONLY;
      case HTMLListTypes.LINEBREAKS_ONLY:
      return "";
      goto default;
      default:
      return "";
      break;
      }
    }
    
    /// <param name="listType"></param>
    /// <param name="isDefinition"></param>
    /// <returns></returns>
    public static String GetListItemClosingTag(int listType, bool isDefinition)
    {
      switch (listType){
      case HTMLListTypes.GLOSSARY_LIST:
      if (isDefinition)
      {
        return "</dd>";
      } else
      {
        return "</dt>";
      }
      goto case HTMLListTypes.ORDERED_LIST;
      case HTMLListTypes.ORDERED_LIST:
      return "</li>";
      goto case HTMLListTypes.UNORDERED_LIST;
      case HTMLListTypes.UNORDERED_LIST:
      return "</li>";
      goto case HTMLListTypes.LINEBREAKS_ONLY;
      case HTMLListTypes.LINEBREAKS_ONLY:
      return "<br />";
      goto default;
      default:
      return "";
      break;
      }
    }
    
    /// <param name="listType"></param>
    /// <param name="isDefinition"></param>
    /// <returns></returns>
    public static String GetListItemOpeningTag(int listType, bool isDefinition)
    {
      switch (listType){
      case HTMLListTypes.GLOSSARY_LIST:
      if (isDefinition)
      {
        return "<dd ";
      } else
      {
        return "<dt ";
      }
      goto case HTMLListTypes.ORDERED_LIST;
      case HTMLListTypes.ORDERED_LIST:
      return "<li ";
      goto case HTMLListTypes.UNORDERED_LIST;
      case HTMLListTypes.UNORDERED_LIST:
      return "<li ";
      goto case HTMLListTypes.LINEBREAKS_ONLY;
      case HTMLListTypes.LINEBREAKS_ONLY:
      return "";
      goto default;
      default:
      return "";
      break;
      }
    }
    
    /// <param name="listType"></param>
    /// <returns></returns>
    public static String GetListOpeningTag(int listType)
    {
      switch (listType){
      case HTMLListTypes.GLOSSARY_LIST:
      return "<dl ";
      goto case HTMLListTypes.ORDERED_LIST;
      case HTMLListTypes.ORDERED_LIST:
      return "<ol ";
      goto case HTMLListTypes.UNORDERED_LIST;
      case HTMLListTypes.UNORDERED_LIST:
      return "<ul ";
      goto case HTMLListTypes.LINEBREAKS_ONLY;
      case HTMLListTypes.LINEBREAKS_ONLY:
      return "";
      goto default;
      default:
      return "";
      break;
      }
    }
  }
}