using System;
//import com.plumtree.openfoundation.logging.*;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
namespace com.plumtree.xpshared.htmlelements
{
  /// <version>$Revision: #1 $</version>
  /// <author>$author$</author>
  public class HTMLScriptCollection : HTMLElement
  {
    internal static int iNextID = 0;
    
    /// <summary>
    /// Creates a new HTMLScriptCollection object.
    /// </summary>
    public HTMLScriptCollection()
    {
    }
    ///////////////////////////////////////////////
    //   The following method are overriden for HTMLElement, because they are
    //   meaningless for this class.
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetName(String s)
    {
      throw new HTMLException("You may not call SetName on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetOnClick(String s)
    {
      throw new HTMLException("You may not call SetOnClick on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetOnKeyDown(String s)
    {
      throw new HTMLException("You may not call SetOnKeyDown on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetOnKeyPress(String s)
    {
      throw new HTMLException("You may not call SetOnKeyPress on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetOnMouseOut(String s)
    {
      throw new HTMLException("You may not call SetOnMouseOut on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetOnMouseOver(String s)
    {
      throw new HTMLException("You may not call SetOnMouseOver on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public sealed override void SetStyle(String s)
    {
      throw new HTMLException("You may not call SetStyle on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public override void SetStyleClass(StyleClass s)
    {
      throw new HTMLException("You may not call SetStyleClass on an HTMLScriptCollection.");
      }
    
    /// <summary>
    /// HTMLElement.addInnerHTMLElement rewritten.
    /// </summary>
    /// <param name="e">Pass an HTMLScript or an HTMLScriptCollection object.</param>
    /// <throws>
    /// HTMLException Throws an exception if the parameter is not
    /// correct.
    /// </throws>
    public override void AddInnerHTMLElement(HTMLElement e)
    {
      //        if (!((e instanceof HTMLScript) || (e instanceof HTMLScriptCollection)))
      //        {
      //            throw new HTMLException("You may only nest HTMLScript or HTMLScriptCollection elements within an HTMLScriptCollection.");
      //        }
      base.AddInnerHTMLElement(e);
    }
    
    /// <summary>
    /// This method rewritten to prevent usage.
    /// </summary>
    /// <param name="s">String</param>
    /// <throws>HTMLException Throws an HTMLException</throws>
    public override void AddInnerHTMLString(String s)
    {
    }
    //throw new HTMLException("You may only nest elements within an HTMLScriptCollection: String " + s);
    // override HTMLElement.InternalWrite.  this version doesn't do any of
    //   the tag generation stuff, it only writes comments and nested html.
    
    /// <summary>
    /// HTMLElement.InternalWrite rewritten.
    /// </summary>
    /// <param name="bFormat">
    /// Pass a boolean indicating whether or not to format the
    /// output.
    /// </param>
    /// <param name="sbLocal">
    /// Pass an XPStringBuilder to which you wish the String
    /// appended.  Pass null if you do not wish the string appended to
    /// an XPStringBuilder.
    /// </param>
    /// <param name="response">
    /// Pass an IXPResponse to which you wish the String written.
    /// Pass null if you do not wish the string written to an
    /// IXPResponse.
    /// </param>
    /// <throws>HTMLException</throws>
    protected override void InternalWrite(bool bFormat, XPStringBuilder sbLocal,
     IXPResponse response)
    {
      bool bMethodFormat = bFormat;
      if (bForceFormattingOff)
      {
        bMethodFormat = false;
      }
      String sComment = GetPreComment();
      if ((sComment != null) && bPrintComments)
      {
        if (bMethodFormat)
        {
          appendTabs(sbLocal, response);
        }
        WriteNugget(BEGIN_COMMENT, sbLocal, response);
        WriteNugget(sComment, sbLocal, response);
        WriteNugget(END_COMMENT, sbLocal, response);
        if (bMethodFormat)
        {
          WriteNugget(sNewLine, sbLocal, response);
        }
      }
      GetInnerHTML(sbLocal, response, bMethodFormat);
      sComment = GetPostComment();
      if ((sComment != null) && bPrintComments)
      {
        if (bMethodFormat)
        {
          appendTabs(sbLocal, response);
        }
        WriteNugget(BEGIN_COMMENT, sbLocal, response);
        WriteNugget(sComment, sbLocal, response);
        WriteNugget(END_COMMENT, sbLocal, response);
        if (bMethodFormat)
        {
          WriteNugget(sNewLine, sbLocal, response);
        }
      }
    }
    
    /// <summary>
    /// This method generates the beginning of the opening tag.  The abstract
    /// HTMLElement superclass will provide the remainder of the opening tag,
    /// repleate with attributes common to all html elements, such as name, and
    /// id, and class.
    /// </summary>
    /// <param name="bFormat">boolean indicating whether or not to format.</param>
    /// <param name="sb">XPStringBuilder</param>
    /// <param name="response">IXPResponse</param>
    protected override void AppendBeginningOfOpeningTag(bool bFormat, XPStringBuilder sb,
     IXPResponse response)
    {
    }
    //   do nothing
    
    /// <summary>
    /// This method generates the closing tag of this html element.  If the
    /// providesClosingTag method returns false, then this method will never be
    /// called.
    /// </summary>
    /// <param name="bFormat">boolean indicating whether or not to format.</param>
    /// <param name="sb">XPStringBuilder</param>
    /// <param name="reponse">IXPResponse</param>
    protected override void AppendClosingTag(bool bFormat, XPStringBuilder sb,
     IXPResponse reponse)
    {
    }
    //   do nothing
    
    /// <summary>
    /// Indicates whether or not this HTML element provides a closing tag. Some
    /// elements only provide opening tags, such as the &lt;br&gt; element.
    /// </summary>
    /// <returns>boolean true.</returns>
    protected override bool ProvidesClosingTag()
    {
      return false;
    }
    ////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////
    
    /// <summary>
    /// Get the next id value.  This is used by the GetClone method to ensure
    /// that cloned object have new ID attribute values.
    /// </summary>
    /// <returns>A valid id string.</returns>
    internal override String GetNextID()
    {
      String s = "htmlscriptcollection" + iNextID;
      iNextID++;
      return s;
    }
  }
}