package com.plumtree.uiinfrastructure.activityspace.utils;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This is a helper class for the cache list that stores activity spaces.
 * 
 * @author donh
 */
public class CacheListItem
{
	/** name of the cache item */
	public String m_strName;

	/** the ID of the parent activity space */
	public String m_strParentSpaceID;

	/** true implies this space was opened from a gatewayed page */
	public boolean m_bIsFromGatewaySpace;

	/** true implies is a sub space */
	public boolean m_bIsSubSpace;

	/**
	 * Creates a new CacheListItem object.
	 *
	 * @param strName cache item name
	 * @param bIsSubSpace true implies is a sub-space
	 * @param strParentSpaceID the ID of the parent space
	 */
	public CacheListItem(String strName, boolean bIsSubSpace,
		String strParentSpaceID)
	{
		m_strName			   = strName;
		m_bIsSubSpace		   = bIsSubSpace;
		m_strParentSpaceID     = strParentSpaceID;


		if (strParentSpaceID != null)
		{
			// All spaces generated from a gatewayed page should have the spaceid
			// set to SPACEID_INVALID and the space name set to STR_GATEWAY.
			m_bIsFromGatewaySpace = ASCache.SPACEID_INVALID.equals(strParentSpaceID);
		} 
		else
		{
			// Assume that sub-spaces without a valid parent space were generated
			// by a gatewayed page.
			m_bIsFromGatewaySpace = m_bIsSubSpace;
		}
	}
}

