/*
 * Created on Mar 13, 2005
 */
package com.plumtree.uiinfrastructure.application.notification;

/**
 * Startup task result codes enumerator.  Relatively self-explanatory.
 * Name and ID getters were included for notification automatioon. 
 * 
 * @author DavidP
 */
public class PT_STARTUP_RESULTCODES
{    
    // enumerated types
    public static final PT_STARTUP_RESULTCODES OK = new PT_STARTUP_RESULTCODES( 0, "OK" ); 
    public static final PT_STARTUP_RESULTCODES WARN = new PT_STARTUP_RESULTCODES( 1, "WARN" );
    public static final PT_STARTUP_RESULTCODES ERROR = new PT_STARTUP_RESULTCODES( 2, "ERROR" );
    public static final PT_STARTUP_RESULTCODES FATAL = new PT_STARTUP_RESULTCODES( 3, "FATAL" );
    
    // private members
    private String m_name = "";
    private int m_id = 0;
    
    // private constructor
    private PT_STARTUP_RESULTCODES(int id, String name)
    {
        m_id = id;
        m_name = name;
    }
    
    /**
     * @return The text name of this return code
     */
    public String getName()
    {
        return m_name;
    }
    
    /**
     * @return The integer ID of this return code
     */
    public int getID()
    {
        return m_id;
    }
}
