/*
 * Created on Mar 13, 2005
 */
package com.plumtree.uiinfrastructure.application.notification;

import com.plumtree.openfoundation.util.*;

/**
 * Container for a result code and a status message.
 * The startup task runner uses these for separate 
 * notification and exception processing.
 * 
 * @author DavidP
 */
public class ReturnValue
{
    private PT_STARTUP_RESULTCODES m_result = null;
    private String m_resultMsg = "";
    private XPException m_exception = null;
    
    /**
     * Constructor for container class
     * @param code
     * @param msg
     */
    public ReturnValue( PT_STARTUP_RESULTCODES code, String msg, XPException e )
    {
        m_result = code;
        m_resultMsg = msg;
        m_exception = e;
    }
    
    /**
     * @return message from core startup task itself
     */
    public String getMsg()
    {
        return m_resultMsg;
    }
    
    /**
     * @return result code
     */
    public PT_STARTUP_RESULTCODES getResultCode()
    {
        return m_result;
    }
    
    /**
     * @return exception
     */
    public XPException getException()
    {
        return m_exception;
    }
}
