/*
 * Purpose:	Compensate for XPExceptions' limitations
 * Author: 	D. Phipps May 6, 2005
 */
package com.plumtree.uiinfrastructure.application.startup.exceptions;

import com.plumtree.openfoundation.io.*;
import com.plumtree.openfoundation.util.*;

/**
 * Gets around a limitation of XPException, which doesn't create stack traces.
 * @author DavidP
 */
public class StackTracer
{   
    /**
     * Gets around the fact that XPException has very limited function if you throw a new exception; 
     * it must chain on a real one.
     * @param message
     */
    static public void ThrowNewXPException(String message)
    {
        throw new XPException( message );
    }
    
    /**
     * Gets around the fact that XPEXception has very limited function if you throw a new exception; 
     * it must chain on a real one.
     * @param message
     */
    static public void ThrowNewXPFileNotFoundException(String message)
    {
        throw new XPFileNotFoundException( message );
    }
    
    
    /**
     * Gets around the fact that XPEXception has very limited function if you throw a new exception; 
     * it must chain on a real one.
     * @param message
     */
    static public XPException MakeXPException(String message)
    {
        XPException exp  = new XPException( message );
        
        return exp;
    }
}
