/*
 * Created on Mar 11, 2005
 */
package com.plumtree.uiinfrastructure.application.startup.messages;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.application.notification.*;
import com.plumtree.uiinfrastructure.util.*;


/**
 * Message list management interface.  One such class is coded per
 * high-level task.
 * 
 * @author DavidP
 */
public interface IMessage
{
    /**
     * Message count.
     * @return number of messages in class
     */
    public int getNumMsgs();
    
    /**
     * Message element.  Gets the recommendation strings for a specific 
     * narrow condition with retval, platform, task, in an XPArrayList,
     * sorted by most accurate first.
     * 
     * @param id - the id of the task step
     * @ReturnValue - the returnvalue class to inspect to get recommendation
     * 
     * @return specific string recommendation
     */
    public XPArrayList getMsg( int stepid, Platform platform, ReturnValue ret );
    
    /**
     * @return Enumerated list of messages
     */
    public StartupTaskMessage[] getMsgArray();
}
