/*
 * Created on Mar 11, 2005
 */
package com.plumtree.uiinfrastructure.application.startup.messages;

import com.plumtree.uiinfrastructure.application.notification.*;
import com.plumtree.uiinfrastructure.util.*;

/**
 * Class to record a message and description useful for recommendations to fix problems
 * 
 * @author DavidP
 */
public class StartupTaskMessage 
{
    private int m_taskstep = 0;
    private Platform m_platform = null;
    private PT_STARTUP_RESULTCODES m_ret = null;
	private String m_errMessage = "";
	private String m_errDescription = "";
	
	/**
	 * Constructor for the message element.
	 * 
	 * @param id
	 * @param msg
	 * @param desc
	 * @param ex
	 */
	public StartupTaskMessage( int stepid, Platform platformid, PT_STARTUP_RESULTCODES ret, String msg, String desc)
	{
		m_taskstep = stepid;
		m_platform = platformid;
		m_errMessage = msg;
		m_errDescription = desc;
		m_ret = ret;
	}
	
	/**
	 * @return Returns the m_errDescription.
	 */
	public String getErrDescription() 
	{
		return m_errDescription;
	}
	
	/**
	 * @return Returns the task step
	 */
	public int getStepID() 
	{
		return m_taskstep;
	}
	
	/**
	 * @return Returns the platform
	 */
	public Platform getPlatform() 
	{
		return m_platform;
	}
	
	/**
	 * @return Returns the m_errMessage.
	 */
	public String getErrMessage() 
	{
		return m_errMessage;
	}
	
	/**
	 * @return Returns the m_errMessage.
	 */
	public PT_STARTUP_RESULTCODES getRetval() 
	{
		return m_ret;
	}
	
	/**
	 * Returns a formatted string with the error message and description.
	 * 
	 * @return
	 */
	public String toString()
	{
	    String line = m_errMessage + "\r\n" + "      " + m_errDescription + "\r\n";
	    
	    return line; 
	}
}
