package com.plumtree.uiinfrastructure.application.varpacks;

/**
 * This class contains constants for the x_config.xml file.
 */
public class ConfigConstants
{
	/** The value attribute */
	public static final String VALUE_ATTRIBUTE = "value";

	/////////////////
	// Authentication
	/////////////////

	/** The authentication section */
	public static final String AUTHENTICATION_SECTION = "Authentication";

	/** The guest access sub-section in authentication*/
	public static final String GUEST_ACCESS_SUBSECTION = "AllowGuestAccess";

	/** The guest access sub-section in authentication*/
	public static final String GUEST_ACCESS_STYLE_OVERRIDE = "OverrideGuestAccessStyle";

	/** The basic auth login token expiration time subsection in authentication (in minutes).*/
	public static final String AUTHTOKENEXPIRATION = "AuthTokenExpiration";

	/** The basic auth SSO override subsection in authentication.*/
	public static final String AUTHOVERRIDESSO = "AuthOverrideSSO";

	////////////////////
	// Personal Settings
	////////////////////

	/** The personal settings section */
	public static final String PERSONAL_SETTINGS_SECTION = "PersonalSettings";

	/** The Accessibility sub-section in personal settings */
	public static final String ACCESSIBILITY_SUBSECTION = "Accessibility";

	///////////
	// Security
	///////////

	/** The security section */
	public static final String SECURITY_SECTION = "Security";

	/** The security mode sub-section in security */
	public static final String SECURITY_MODE_SUBSECTION = "SecurityMode";

	////////////////
	// International
	////////////////

	/** The international section */
	public static final String INTERNATIONAL_SECTION = "International";

	/** The Locale sub-section in international */
	public static final String LOCALE_SUBSECTION = "Locale";
	
	/** The time zone sub-section in international */
	public static final String TIMEZONE_SUBSECTION = "TimeZone";
		
	///////////////////
	// URLMapping
	///////////////////
	
	/** JF- The URL Mapping section */
	public static final String URL_MAPPING_SECTION = "URLMapping";

	/** JF- The URL From the Request sub-section in URL Mapping */
	public static final String URL_FROM_REQUEST_SUBSECTION = "URLFromRequest";
	
	/** JF- The Application URL sub-section in URL Mapping */
	public static final String APPLICATION_URL_SUBSECTION = "ApplicationURL";
	
	/** JF- The Secure Application URL sub-section in URL Mapping */
	public static final String SECURE_APPLICATION_URL_SUBSECTION = "SecureApplicationURL";

	////////////
	// MainURLs
	////////////
	
	/** WilliamA- The Main URLs section */
	public static final String MAIN_URLS_SECTION = "MainURLs";
	
	/** JO- The URL that is used for the Portal Server to connect to the Image Server to do JSRegistry work */
	public static final String IMAGE_SERVER_CONNECTION_URL = "ImageServerConnectionURL";
	
	/** DAP- The timeout for testing that same URL during startup */
	public static final String IMAGE_SERVER_CONNECTION_URL_TIMEOUT = "ImageServerConnectionURLTimeout";

	///////////////////
	// SystemProperties
	///////////////////

	/** The system properties section */
	public static final String SYSTEM_PROPERTIES_SECTION = "SystemProperties";

	/** The machine name sub-section in system properties */
	public static final String MACHINE_NAME_SUBSECTION = "MachineName";

	/** JF- The Server Name sub-section in system properties */
	public static final String SERVER_NAME_SUBSECTION = "ServerName";

	/** The Performance Comments sub-section in system properties */
	public static final String PERFORMANCE_COMMENTS_SUBSECTION = "PerformanceComments";

	/** The Performance Comments sub-section in system properties */
	public static final String LAYOUT_MODE_SUBSECTION = "LayoutMode";

	/** JF- The HTTP Entry Point sub-section in system properties */
	public static final String HTTP_ENTRY_POINT_SUBSECTION = "HTTPEntryPoint";

	/** JF- The HTTP Port sub-section in system properties */
	public static final String HTTP_PORT_SUBSECTION = "HTTPPort";

	/** JF- The HTTP Secure Port sub-section in system properties */
	public static final String HTTP_SECURE_PORT_SUBSECTION = "HTTPSecurePort";

	/** JF- The Virtual Directory Path sub-section in system properties */
	public static final String VIRTUAL_DIRECTORY_PATH_SUBSECTION = "VirtualDirectoryPath";

	/** The maximum queue length for requests for a single session.  Default 10. */
	public static final String MAX_REQUEST_QUEUE_LENGTH_SUBSECTION = "MaxRequestQueueLength";

	/** JF- The  sub-section in system properties */
	public static final String _SUBSECTION = "";
	
	/** JYS- The SSO Entry Point */
	public static final String SSO_SERVLET_NAME_SUBSECTION = "SSOServletName";
	
	////////////////////
	// Cached Settings
	////////////////////

	/** WilliamA- The cached settings section */
	public static final String CACHED_SETTINGS_SECTION = "CachedSettings";
}

