package com.plumtree.uiinfrastructure.approval;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author Ben Geislinger
 *
 */
public abstract class AInstanceDescriptor
{
	protected static int iInstanceID = 0;
	protected AActivitySpace mySpace = null;
	HTMLElement myPath;
	private AItemDescriptor myItem;
	private String sComment = "";
	private String sID;
	private String sItemID;
	private boolean bApprove = false;
	private boolean bHold   = true;
	private boolean bReject = false;
	private int m_PTFolderID = 0;

	/**
	 * Creates a new AInstanceDescriptor object.
	 *
	 * @param item
	 * @param ePath
	 */
	protected AInstanceDescriptor(AItemDescriptor item, HTMLElement ePath,
		ApprovalItemType type, AActivitySpace space)
	{
		myItem     = item;

		myPath     = ePath;

		mySpace     = space;

		sID     = type.GetName() + "_IN_" + XPConvert.ToString(iInstanceID);

		sItemID = item.GetID();

		iInstanceID++;
	}

	/**
	 *
	 */
	public abstract void Execute();

	/**
	 *
	 */
	public int GetPTFolderID()
	{
		return m_PTFolderID;
	}
	
	/**
	 *
	 */
	public void SetPTFolderID(int ID)
	{
		m_PTFolderID = ID;
	}
	
	/**
	 *
	 */
	public void Approve()
	{
		bApprove     = true;
		bReject		 = false;
		bHold		 = false;
	}

	/**
	 *
	 */
	public boolean GetApprove()
	{
		return bApprove;
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetComment()
	{
		return sComment;
	}

	/**
	 *
	 */
	public boolean GetHold()
	{
		return bHold;
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetID()
	{
		return sID;
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement GetPath()
	{
		return myPath;
	}

	/**
	 *
	 */
	public boolean GetReject()
	{
		return bReject;
	}

	/**
	 *
	 */
	public void Hold()
	{
		bApprove     = false;
		bReject		 = false;
		bHold		 = true;
	}

	/**
	 *
	 */
	public void Reject()
	{
		bApprove     = false;
		bReject		 = true;
		bHold		 = false;
	}

	/**
	 *
	 *
	 * @param s
	 */
	public void SetComment(String s)
	{
		sComment = s;
	}
}

