package com.plumtree.uiinfrastructure.approval;

import com.plumtree.uiinfrastructure.editor.*;

// Framework Imports
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is class is used to print out together the Views for
 * the Misc Settings page of the Misc Editor.
 *
 * @author Julie Fournier
 */

// ***CHANGE_HERE*** Change the name of the class.
// ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
//       when you are done.
public class CommentDP extends EditorDP
{
	// ***CHANGE_HERE*** Set the class name.
	// COMMENT1- All the DPs in your AS need to have a unique name.

	public static final String STR_MVC_CLASS_NAME = "CommentDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		// JF- This is not used here.
		return "";
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		// ***CHANGE_HERE*** For each View you want to display on that page,
		//       copy the line below and replace Misc2View with your View name.
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				CommentView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		// ***CHANGE_HERE*** If that DP doesn't have any JavaScripts,
		//      you can delete the entire DisplayJavaScriptFromChild() method.
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts
		//      displayed by that DP.
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				CommentView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

