package com.plumtree.uiinfrastructure.devices;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.openlog.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.xpshared.htmlelements.*;



/**
 * @author SudhaS
 *
 * This display page creates a basic WML page.
 */
public abstract class ADevicesDP_WML implements IDisplayPage
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent("UI_Infrastructure"),
		"com.plumtree.uiinfrastructure.devices.ADevicesDP_WML");

	protected AActivitySpace m_asOwner;

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#Display(IWebData)
	 */
	public void Display(IWebData webData)
	{
		XPStringBuilder sb;

		sb = new XPStringBuilder();

		if (XPStringUtility.Compare(m_asOwner.GetCurrentPage().GetName(), "PortletDevices_WML") != 0)
		{
			sb.Append("<?xml version=\"1.0\"?>\n");
			sb.Append(
				"<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\"  \"http://www.wapforum.org/DTD/wml_1.1.xml\">\n");
			sb.Append("<wml> \n");
			sb.Append("<head>\n");
			sb.Append(
				"		<meta http-equiv=\"Cache-Control\" content=\"max-age=0\" forua=\"true\" \n/>");
			sb.Append("</head>\n");
		}

		try
		{
			//String strTemp = PageDisplay();
			sb.Append(PageDisplay());
		}
		catch (HTMLException e)
		{
			
				log.Error(e, "Could not create WML page.");
			
		}

		if (XPStringUtility.Compare(m_asOwner.GetCurrentPage().GetName(), "PortletDevices_WML") != 0)
		{
			sb.Append("</wml>");
		}
	
		webData.SetData(sb.ToString());
		webData.SetHeader(HTTPHeaderConstants.CONTENT_TYPE,
			"text/vnd.wap.wml;charset=UTF-8");
		
	}

	/**
	 *
	 * @return
	 */
	abstract public String GetName();

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * @return
	 */
	abstract public String PageDisplay();
}

