/*
 * Purpose:	
 * Author: 	D. Phipps Feb 24, 2005
 */
package com.plumtree.uiinfrastructure.diagnostic;

import com.plumtree.uiinfrastructure.diagnostic.testinterface.*;

/**
 * Handles progress tracking for all tests. Each object has a single tasks' detail.
 * 
 * @author DavidP
 */
public class ProgressManager
{
    private IndividualTestProgressTracker[] m_progress = null;
    
    public ProgressManager(int numTests,boolean verbose)
    {
        m_progress = new IndividualTestProgressTracker[numTests+1];
        
        for (int loop = 0; loop < numTests; ++loop)
        {	
            m_progress[loop] = new IndividualTestProgressTracker(); 
            m_progress[loop].setManager(this);
            m_progress[loop].init(loop,numTests,verbose);
        }
    }
    
    public IProgressTracker getTracker(int index)
    {
        return (IProgressTracker)m_progress[index];
    }
    
    
}
