package com.plumtree.uiinfrastructure.editor;

// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This is the interface for the read-only Model. This interface is implemented
 * by EditorModel. Any read-only Model interface should extend this one.
 *
 * @author Julie Fournier
 */
public interface IEditorModelRO extends IModelRO
{
	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#GetEditorType()
	 *
	 */
	public int GetEditorType();

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#GetHideLeftNav()
	 *
	 */
	public boolean GetHideLeftNav();

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#GetIsEditorReadOnly()
	 *
	 */
	public boolean GetIsEditorReadOnly();
	
	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#GetEnableApplyButton()
	 *
	 */
	public boolean GetEnableApplyButton();
}

