package com.plumtree.uiinfrastructure.errordisplay;

import com.plumtree.uiinfrastructure.activityspace.*;

// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.openfoundation.util.*;

/**
 *
 * This control provides control functionality for views and models
 * responsible for displaying error messages.
 *
 * @author BenG
 */
public class ErrorControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent("UI_Infrastructure"),
		"com.plumtree.uiinfrastructure.errordisplay.ErrorControl");

	// MVC Control Object Name
	public static final String STR_MVC_CLASS_NAME = "ErrorControl";

	// TODOCR JF 12/10/02 - What is this?

	public static final String PARAM_CLEAR_ERROR = "clearerror";
	protected AErrorModel m_model;

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		
			log.Debug("Execute()");
		

		String[] strError = (String[]) arguments.GetElement(PARAM_CLEAR_ERROR);

		if ((strError != null) && (strError[0] != null))
		{
			
				log.Debug("About to clear error: " + strError[0]);
			

			m_model.ClearError(strError[0]);
		}

		Redirect myRedirect = null;

		return myRedirect;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ErrorControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#Init(IModelRW)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_model = (AErrorModel) model;
	}
}

