package com.plumtree.uiinfrastructure.errordisplay;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface is designed to allow developers to provide their own
 * implementations of whether or not a user can see admin errors.
 */
public interface IAdminUIErrorHelper
{
	/**
	 * Call this method to obtain a boolean value indicating whether or not
	 *     the current user should see errors intended for administrators.
	 * <br><br>
	 * @param Object session
	 * @return boolean value
	 */
	abstract boolean GetDisplayAdminErrors(Object session);

	/**
	 * Call this method to obtain a boolean value indicating whether or not
	 *     the current user should see errors intended for administrators.
	 * <br><br>
	 * @param AActivitySpace
	 * @return boolean value
	 */
	abstract boolean GetDisplayAdminErrors(AActivitySpace space);
}

