package com.plumtree.uiinfrastructure.errordisplay;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.openfoundation.util.*;

/**
 * @author BenG
 *
 * read-only interface to the ErrorModel classes.
 */
public interface IErrorModelRO extends IModelRO
{
	/**
	 * Call to determine if this view should dispaly errors requiring a separate
	 *     display page.
	 * <br><br>
	 *
	 * @return boolean value.
	 */
	public abstract boolean GetDisplaySeparatePageErrors();

	/**
	 * Call to obtain an enumeration of those UIError objects appropriate
	 *     for viewing by the current user.
	 * <br><br>
	 * @return IXPEnumerator of PTErrors.
	 */
	public abstract IXPEnumerator GetErrors();

	/**
	 * Call this method to determine whether or not this view should display
	 *     only those errors associated with the current activity space.
	 * <br><br>
	 * @return boolean value
	 */
	public abstract boolean GetErrorsAssociatedWithAnAS();
}

