package com.plumtree.uiinfrastructure.errordisplay;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author Ben Geislinger
 *
 * This model is for use with the MVC responsible for displaying those
 * errors requiring their own display page.
 */
public class SinglePageErrorModel extends ErrorModel
{
	public static final String STR_MVC_CLASS_NAME = "SinglePageErrorModel";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SinglePageErrorModel();
	}

	/**
	 * Returns true.
	 *
	 * @return boolean true
	 */
	public boolean GetDisplaySeparatePageErrors()
	{
		return true;
	}

	/**
	 * Returns false.  This MVC must retrieve all errors regardless of the
	 *     activity space with which they're associated.
	 *
	 * @return boolean false
	 */
	public boolean GetErrorsAssociatedWithAnAS()
	{
		return false;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IModel#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits the Model with the Activity Space.
	 *
	 * @param parent
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}
}

