package com.plumtree.uiinfrastructure.expandablelist;

import com.plumtree.openfoundation.util.XPSortedDictionary;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.form.pagination.*;

// Framework Imports
import com.plumtree.xpshared.htmlconstructs.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface IExpListModelRO extends IPaginationModelRO
{
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddIcon()
	 *
	 */
	public PTImageType GetAddIcon();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddIconAlt()
	 *
	 */
	public String GetAddIconAlt();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAddLabel()
	 *
	 */
	public String GetAddLabel();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetAlertMessageForEmptyList()
	 *
	 */
	public String GetAlertMessageForEmptyList();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetArrExpListColInfo()
	 *
	 */
	public Object[][] GetArrExpListColInfo();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetDeleteIcon()
	 *
	 */
	public PTImageType GetDeleteIcon();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetDeleteIconAlt()
	 *
	 */
	public String GetDeleteIconAlt();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEmptyListInstructions()
	 *
	 */
	public String GetEmptyListInstructions();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEmptyListMainMessage()
	 *
	 */
	public String GetEmptyListMainMessage();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetEnableMoveRowActions()
	 *
	 */
	public boolean GetEnableMoveRowActions();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetListAccessFlag()
	 *
	 */
	public boolean GetIsListReadOnly();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetMainColumnSort()
	 *
	 */
	public int GetMainColumnSort();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetMainColumnSortDirection()
	 *
	 */
	public int GetMainColumnSortDirection();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetReadOnlyItems()
	 *
	 */
	public IPTGrowableSortedArrayWrapperRO GetReadOnlyItems();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetSectionTitle()
	 *
	 */
	public String GetSectionTitle();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetUniqueInt()
	 *
	 */
	public int GetUniqueInt(int _nValue);

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetUniqueInputName()
	 *
	 */
	public String GetUniqueString(String _sName);

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsAddButtonDisabled()
	 *
	 */
	public boolean IsAddButtonDisabled();

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsCheckBoxesDisabled()
	 *
	 */
	public boolean IsCheckBoxesDisabled();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetTableIntructions()
	 *
	 */
	public String GetTableInstructions();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetWrapColumnHeaders()
	 *
	 */
	public boolean GetWrapColumnHeaders();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetWrapColumnHeaders()
	 *
	 */
	public String GetDelRowConfirmMsg();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetListKey()
	 *
	 */
	public int GetListKey();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#GetModelStorageName()
	 *
	 */
	public String GetModelStorageName();
	
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#IsPaginationEnabled()
	 *
	 */
	public boolean IsPaginationEnabled();
	
	/**
	 * 
	 *
	 * @return 
	 */
	public XPSortedDictionary GetUnusedProperties();
}

