package com.plumtree.uiinfrastructure.form;

import com.plumtree.uiinfrastructure.constants.*;
/**
 * This class implements the HTML to print out the OK and Cancel
 * at the top of the form. This View is printed out by AFormDP.  To
 * turn this header on ... go to AFormDP::SetShowFormHeader()
 * 
 * This is the medium popup header.
 * 
 * @author DonH
 */
public class MediumFormHeaderView extends AFormHeaderView
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "MediumFormHeader";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MediumFormHeaderView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormHeaderView#GetFinishButtonText()
	 */
	protected String GetFinishButtonText()
	{
		return m_asOwner.GetString(66, ResourceConstants.INFRASTRUCTURE); // "OK"
	}
}
