package com.plumtree.uiinfrastructure.form.pagination;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface allows the PaginationControl to set which objects the
 * user would like displayed.
 * 
 * @author Don Hayler
 */
public interface IPaginationModel extends IModel, IPaginationModelRO
{
	/**
	 * This is used by the PaginationControl to set which objects should
	 * be displayed.
	 *
	 * @param nPaginationID Unique ID of objects to paginate (usually class
	 *             id) when there are multiple pagination sections per page.
	 * @param nPaginationLowerBound The starting count for objects to display
	 * @param nPaginationUpperBound The ending count for objects to display.
	 */
	public void SetPagination(int nPaginationID, int nPaginationLowerBound,
		int nPaginationUpperBound);
}

