package com.plumtree.uiinfrastructure.form.pagination;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface provides the information necessary to
 * create the pagination bar.
 * 
 * @author Don Hayler
 */
public interface IPaginationModelRO extends IModelRO
{
	/**
	 * This method returns the current lower count for which objects to display.
	 *
	 * This number is the 'n' in (Displaying n - m of o)
	 *
	 * @return int the current lower count for which objects to display.
	 */
	public int GetCurrentLowerObjectCount();

	/**
	 * This method returns the current upper count for which objects to display.
	 *
	 * This number is the 'm' in (Displaying n - m of o)
	 *
	 * @return int the current upper count for which objects to display.
	 */
	public int GetCurrentUpperObjectCount();

	/**
	 * This method returns the total number of objects available for display.
	 *
	 * This number is the 'o' in (Displaying n - m of o)
	 *
	 * @return int the total number of objects available for display.
	 */
	public int GetNumObjects();
	
	/**
	 * This is the number of objects displayed per page.
	 *
	 * This name is the value of (m - n)
	 *
	 * @return int the total number of objects available for display per page
	 */
	public int GetPaginationSize();
	
}

