package com.plumtree.uiinfrastructure.form.sort;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This model interface needs to be implemented to use
 * the sort framework.
 * 
 * @author Don Hayler
 */
public interface ISortModel extends ISortModelRO, IModel
{
	/**
	 * Set the sort to use.
	 *
	 * @see com.plumtree.uiinfrastructure.arraywrapper.PTSortedArrayWrapper
	 *
	 * @param nSortID the ID of the objects to sort on.
	 * @param nSortHeader the index of the header to sort (starting with 0).
	 * @param nSortDirection PTSortedArrayWrapper.PTSAW_SORT_ASCENDING or
	 *                           PTSortedArrayWrapper.PTSAW_SORT_DESCENDING.
	 */
	public void SetSort(int nSortID, int nSortHeader, int nSortDirection);
}

