package com.plumtree.uiinfrastructure.form.sort;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This model interface needs to be implemented to use
 * the sort framework.
 * 
 * @author Don Hayler
 */
public interface ISortModelRO extends IModelRO
{
	/**
	 * Get the sort direction for the currently sorted header column.
	 *
	 * This should return either PTSortedArrayWrapper.PTSAW_SORT_ASCENDING
	 * or PTSortedArrayWrapper.PTSAW_SORT_DESCENDING.
	 *
	 * This method only needs to return useful information if GetSortable()
	 * returns true.
	 *
	 * @return int the sort direction from PTSortedArrayWrapper.
	 */
	public int GetSortDirection();

	/**
	 * Get the column id of the header that is currently sorted (starting with 0).
	 *
	 * This method only needs to return useful information if GetSortable()
	 * returns true.
	 *
	 * @return int the column id of the currently sorted header column.
	 */
	public int GetSortedHeader();
}

