package com.plumtree.uiinfrastructure.help;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author donh
 *
 * This Control retrieves the help URL from the query string.
 */
public class HelpControl implements IControl
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "HelpControl";

	/** Query string argument of the help topic to display. */
	public static final String STR_HELP_TOPIC = "HelpTopic";

	/** Query string argument of the previous URL. */
	public static final String STR_PREVIOUS_URL = "PrevURL";

	protected HelpFrameAS m_asOwner;

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] strTopic = (String[]) arguments.GetElement(STR_HELP_TOPIC);

		if (null != strTopic)
		{
			m_asOwner.m_strHelpTopic = strTopic[0]; 
		}

		String[] strURL = (String[]) arguments.GetElement(STR_PREVIOUS_URL);

		if ((null != strURL) && (null != strURL[0]))
		{
			m_asOwner.m_strPreviousRequestURL = XPHttpUtility.UrlDecode(strURL[0], LinkConstants.UTF_8_ENCODING); 
		}

		return null;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace parent)
	{
		m_asOwner = (HelpFrameAS) parent;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new HelpControl();
	}
}
