package com.plumtree.uiinfrastructure.help;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author donh
 *
 * This Activity Space provides a frameset with a "back" navigation
 * link at the bottom for 508 users.
 */
public class HelpFrameAS extends AActivitySpace
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "HelpFrame";

	public String m_strPreviousRequestURL = null;
	public String m_strHelpTopic = null;

	/**
	 * Initialize the Activity Space.
	 */
	public void Init()
	{
		super.Init();

		RegisterControl(HelpControl.STR_MVC_CLASS_NAME, null);

		RegisterPage(new HelpFrameSetDP());
		RegisterPage(new HelpBackFrame());
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(
		String strPage,
		String strControl,
		boolean bSameSpace)
	{
		return true;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new HelpFrameAS();
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
