package com.plumtree.uiinfrastructure.help;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;
import com.plumtree.uiinfrastructure.statichelpers.*;

/**
 * @author donh
 *
 * This Display Page provides a frameset with a "back" navigation
 * link at the bottom for 508 users.
 */
public class HelpFrameSetDP extends FrameSetDP
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "HelpFrameSet";

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()
	 */
	public String GetFrameSetTitle()
	{
		return m_asOwner.GetString(152, "ptmsgs_infrastructure");
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		// Returning null means to use GetFrameURLStringTop().
		return null;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
	 */
	public String GetFrameURLStringTop()
	{
		String strHelpTopic = ((HelpFrameAS) m_asOwner).m_strHelpTopic;

		if ((!strHelpTopic.endsWith(".htm")) || (!strHelpTopic.endsWith(".html")))
		{
			strHelpTopic = strHelpTopic + ".htm";
		}

		String strHelpURL =  HTMLConstructHelpers.Get508HelpBaseUrl(m_asOwner)
			+ strHelpTopic;		

		return strHelpURL;
	}

	/**
	 * Set Frame Scroll Top
	 *
	 * @return boolean true implies scrolling
	 */
	public boolean GetFrameScrollTop()
	{
		return true;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{
		ASURL result = new ASURL(m_asOwner);

		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(HelpBackFrame.STR_MVC_CLASS_NAME);

		return result;
	}

	/**
	 * Set Frame Name Top
	 *
	 * The frame name and title are used by 508 users.
	 * 
	 * @return String
	 */
	public String GetFrameNameTop()
	{
		return m_asOwner.GetString(152, "ptmsgs_infrastructure");
	}

	/**
	 * Set Frame Name Body
	 *
	 * The frame name and title are used by 508 users.
	 * 
	 * @return String
	 */
	public String GetFrameNameBody()
	{
		return m_asOwner.GetString(151, "ptmsgs_infrastructure");
	}

	/**
	 * Set Frame Title Top
	 *
	 * The frame name and title are used by 508 users.
	 * 
	 * @return String
	 */
	public String GetFrameTitleTop()
	{
		return m_asOwner.GetString(152, "ptmsgs_infrastructure");
	}

	/**
	 * Set Frame Title Body
	 *
	 * The frame name and title are used by 508 users.
	 * 
	 * @return String
	 */
	public String GetFrameTitleBody()
	{
		return m_asOwner.GetString(151, "ptmsgs_infrastructure");
	}

	/**
	 * Set NOFRAMES Body Element
	 *
	 * The NOFRAMES element is useful for 508 users.
	 * 
	 * @return HTMLElementCollection
	 */
/*	public HTMLElementCollection GetNoFrames()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLString("Your Browser Does Not Support Frames. Here is the ");

		String strHelpTopic = ((HelpFrameAS) m_asOwner).m_strHelpTopic;

		if ((!strHelpTopic.endsWith(".htm")) || (!strHelpTopic.endsWith(".html")))
		{
			strHelpTopic = strHelpTopic + ".htm";
		}

		String strHelpURL =  HTMLConstructHelpers.Get508HelpBaseUrl(m_asOwner)
			+ strHelpTopic;		


		HTMLAnchor helpAnchor = new HTMLAnchor("#");
		helpAnchor.SetHRef(strHelpURL);
		helpAnchor.AddInnerHTMLString("non-frame based version of the help page.");
		helpAnchor.SetTitle("Help page");

		result.AddInnerHTMLElement(helpAnchor);

		return result;
	}
*/

	/**
	 * Set FrameSet Attributes
	 *
	 * @return String
	 */
	public String GetFrameSetAttributes()
	{
		return "*,50px";
	}
}
