package com.plumtree.uiinfrastructure.htmlconstructs;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * @author beng
 *
 */
public class UIListItem extends PTListItem
{

	
//	private String _ui_new = "new!";
//	private String _ui_updated = "updated!";
	private AActivitySpace myASpace = null;

	
	public UIListItem(String title, String titleHRef, AActivitySpace aSpace )
    {
    	super( title, titleHRef );
    	myASpace = aSpace;    	
    }
    

    /**
     * Call this method to construct a new PTListItem. <br><br>
     * <br><br>
     * Use this constructor if you wish for the title of this item to be just
     * 	a String, as opposed to an anchor.
     * 
     * 
     * @param title Pass a String that is the title of this item.
     */    
    public UIListItem( String title, AActivitySpace aSpace )
    {
		super( title );
    	myASpace = aSpace;		
    }
    
    

    /**
     * Call this method to construct a new PTListItem. <br><br>
     * 
     * @param a Pass the HTMLAnchor that will appear as the title of this item.
     */
    public UIListItem(HTMLAnchor a, AActivitySpace aSpace )
    {
		super( a );
		myASpace = aSpace;
    }
        
    
    
	protected HTMLElement GetNewIndicator()
	{
		//	overrides PTListItem.GetNewIndicator.  This method is capable of
		//	using localized strings.
		
		HTMLSpan tempSpan = new HTMLSpan();
		
		tempSpan.SetStyleClass( PTStyleClass.LIST_NEW_TEXT );
		

		tempSpan.AddInnerHTMLString( CommonHTMLStrings.SPACE );
		tempSpan.AddInnerHTMLEncodedString( myASpace.GetString( 1577, ResourceConstants.PORTALBROWSINGMSGS ) );
		
		return tempSpan;
	}
	
	protected HTMLElement GetUpdatedIndicator()
	{
		//	overrides PTListItem.GetUpdatedIndicator  This method is capable of
		//	using localized strings.
				
		
		HTMLSpan tempSpan = new HTMLSpan();
		
		tempSpan.SetStyleClass( PTStyleClass.LIST_UPDATED_TEXT );
		
		tempSpan.AddInnerHTMLString( CommonHTMLStrings.SPACE );		
		tempSpan.AddInnerHTMLEncodedString( myASpace.GetString( 1578, ResourceConstants.PORTALBROWSINGMSGS ) );
		
		return tempSpan;
	}
	    
}

