package com.plumtree.uiinfrastructure.interpreter;

import com.plumtree.openfoundation.web.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * This inteface will be implemented by a class in the portaluiinfrastucture
 * as a hook to call methods unavailable to uiinfrastructure like executing
 * the Expression Engine
 *    
 * @author dustina
 */
public interface IExpressionEvaluator {

	/**
	 * Hook function so that the Expression Engine can be executed
	 * in the uiinfrasrtucture
	 *
	 */
	public void EvaluateExpressionForLogInDestination(AActivitySpace asCurrentSpace, IApplication application, IXPRequest xpRequest, 
			Object ptUserSession);
	
	/**
	 * Hook function so that the Expression Engine can be executed
	 * in the uiinfrasrtucture
	 *
	 */
	public void EvaluateExpressionForSubportalAction(AActivitySpace asCurrentSpace, IApplication application, IXPRequest xpRequest, 
			Object ptUserSession);
}
