package com.plumtree.uiinfrastructure.interpreter.filter;

import com.plumtree.uiinfrastructure.interpreter.*;

/**
 * This is a pass-through filter; both the PreFilter and PostFilter methods
 * have the default implementation that returns a boolean false. This is a
 * utility class to make it easier to implement only one of the filter methods 
 * (either the PreFilter or the PostFilter) without implementing the other 
 * (which by default will be a pass through).
 * 
 * @author WilliamA
 */
public class BaseInterpreterFilter implements IInterpreterFilter {

	/**
	 * A pass-through PreFilter. It always returns false.
	 */
	public boolean PreFilter(RequestData requestData) {
		return false;
	}

    /**
	 * A pass-through PostFilter.  
     */
	public void PostFilter(RequestData requestData) {

	}
}
