package com.plumtree.uiinfrastructure.login;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.interpreter.*;

/**
 * This interface defines the extensible SSO helper code for custom
 * SSO implementations.
 * 
 * @author mikej
 *
 * Created on Mar 13, 2003
 */
public interface ISSOHelper
{
    /**
     * Returns true if SSO is enabled at the portal level.
     * This does not take into account subportal settings
     * and should only be used as a default setting if the
     * subportal does not specify if SSO is enabled or disabled.
     * To access the subportal SSO setting, use SSOAuthenticator.UseThisAuth().
     * @return
     */
    public boolean IsSSOEnabled();

    /**
     *
     * @param tempData
     * @param sQueryString
     *
     * @return
     */
    public Redirect DoLoginRedirect(RequestData tempData, String sQueryString);

    /**
     *
     * @param tempData
     *
     * @return
     */
    public boolean DoLogoutRedirect(RequestData tempData);
}
