package com.plumtree.uiinfrastructure.opener;

import com.plumtree.openlog.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This AActivitySpace enables client programmers to easily and generically
 * open objects in the Plumtree system.
 * 
 * @author John Osborne
 * @author Ricky Wong
 */
public class BaseOpenerAS extends AActivitySpace
{
	private static OpenLogger log = OpenLogService.GetLogger(
	    OpenLogService.GetComponent("UI_Infrastructure"),
		"com.plumtree.uiinfrastructure.opener.BaseOpenerAS");

    public static final String STR_MVC_CLASS_NAME = "Opener";

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
     */
    public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
    {
        return true;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
    public Object Create()
    {
        return new BaseOpenerAS();
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
    public String GetName()
    {
        return BaseOpenerAS.STR_MVC_CLASS_NAME;
    }
    
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()
     */
    public void Init()
    {
        super.Init();

        // register and make our control the default one.
        RegisterControl(BaseOpenerControl.STR_MVC_CLASS_NAME, null);
        RegisterControl(BaseOpenerControl.STR_MVC_CLASS_NAME, "", null);        
    }
}