package com.plumtree.uiinfrastructure.opener;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * Interface that needs to be implemented when creating an
 * OpenerPlugin.  Plugins are run at the beginning of the 
 * Common Opener processing, allowing one to interpret the
 * Querystring arguments and act accordingly.
 * 
 * @author RickyW
 */
public interface IOpenerPlugins
{
	/**
	 * @param _redirectData Object that encapsulates the current destination.
	 * @param _asCurrentSpace The activity space provides access to more information.
	 * @param _userSession Quick reference to the often used session.
	 * 
	 * @return RedirectData object that encapsulates the new destination.
	 */
	public RedirectData ProcessPlugIn(RedirectData _redirectData, AActivitySpace _asCurrentSpace, Object _userSession);
}
