package com.plumtree.uiinfrastructure.opener.types;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.opener.*;

/**
 * 
 * TODO Add Description.
 * 
 */
public abstract class AUIClassTypeDesc implements IUIClassTypeDesc
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent("UI_Infrastructure"),
		"com.plumtree.uiinfrastructure.opener.types.AUIClassTypeDesc");
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IUIClassTypeDesc#GetClassName()
	 */
	public abstract String GetClassName();

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetClassKey()
	 */
	public String GetClassKey()
	{
	    return GetClassName();
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetClassType()
	 */
	public ClassTypeEnum GetClassType()
	{
	    return ClassTypeEnum.UICLASSTYPE;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetDefaultOpenerMode()
	 */
	public int GetDefaultOpenerMode()
	{
	    // UI ClassTypes really only open one way.
	    return IOpenerConstants.OPENER_MODE_VIEW;
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, null)
	 */
	public abstract Redirect GetRedirectViewObject(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession);
	
    /* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectCreateNew(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectCreateNew(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
	    // UI ClassTypes really only open one way.
		return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObjectMetaData(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectViewObjectMetaData(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
	    // UI ClassTypes really only open one way.
		return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectSearchBrowse(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectSearchBrowse(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
	    // UI ClassTypes really only open one way.
		return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectSearchEdit(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectSearchEdit(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
	    // UI ClassTypes really only open one way.
		return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetRedirectOpenObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectOpenObject(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
	    // UI ClassTypes really only open one way.
		return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}	
}