package com.plumtree.uiinfrastructure.opener.types;

import com.plumtree.openlog.*;

public class ClassTypeEnum
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent("UI_Infrastructure"),
			"com.plumtree.uiinfrastructure.opener.types.ClassTypeEnum");
    
    private int m_classTypeID;

	public static final ClassTypeEnum PTCLASSTYPE = new ClassTypeEnum(0);
	public static final ClassTypeEnum UICLASSTYPE = new ClassTypeEnum(1);

	public static final ClassTypeEnum[] m_classTypeEnums = 
	{ 
		// TODO: move to a sub class
		PTCLASSTYPE,
		UICLASSTYPE
	};

	/**
	 * Private constructor.
	 */
	private ClassTypeEnum(int classTypeID)
	{
		m_classTypeID = classTypeID;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		String classType = "UNDEFINED";
		
		switch (m_classTypeID)
		{
			case 0:
				classType ="PTCLASSTYPE";
				break;
			case 1:
				classType ="UICLASSTYPE";
				break;
		}
		
		return classType;
	}
	
	/**
	 * Retrieves the int ID for this class type.
	 * 
	 * @return int ID for this class type.
	 */
	public int GetID()
	{
		return m_classTypeID;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public final boolean equals(Object o)
	{
		boolean retval = false;
		
		try 
		{
			retval = (((ClassTypeEnum)o).GetID() == m_classTypeID);
		}
		catch (Exception e)
		{
		    log.Error(e, "Invalid comparison");
		}
		
		return retval;
	}
}
