package com.plumtree.uiinfrastructure.opener.types;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface describes the Opener Type Manager.
 */
public interface IClassTypeManager
{
	/**
	 * Returns the default opener mode for this class type.
	 *
	 * @param __strClassKey 
	 *
	 * @return The default opener mode for this class type. 
	 */
	public int GetDefaultOpenerMode(String _strClassKey);

	/**
	 * Returns the Opener redirect for this class type.
	 * 
	 * @param _strClassKey
	 * @param _nOpenerMode
	 * @param _htArguments
	 * @param _asParent
	 * @param _userSession
	 * @return The redirect for this request.
	 */
	public Redirect GetOpenerRedirect(String _strClassKey, int _nOpenerMode, 
		XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession);
}
