package com.plumtree.uiinfrastructure.opener.types;

/**
 * Interface for UIClassTypeDesc.  
 * 
 * @author Ricky Wong
 */
public interface IUIClassTypeDesc extends IClassTypeDesc
{
	/**
	 * Returns the class name of the class type. This is a unique string that 
	 * identifies this class.  When the Opener sees "open=XYZ" where "XYZ" is 
	 * not an integer, it will invoke the ClassTypeDesc with the matching class
	 * name.  Note that class name should not be an integer representation, i.e.
	 * "512", because it will collide with PT_CLASSIDS.
	 *
	 * @return The class name of the class type.
	 */
	public String GetClassName();
}

