package com.plumtree.uiinfrastructure.pagecontrols.framework;


/**
 * This abstract class defines some basic elements that all Validators share.
 * A Validator is an object used by Page Controls to validate their input against 
 * its internal criteria that standardizes Page Control Validation. Each Validator
 * has a Validate method for server side validation and has a GetJSValidationCode
 * & GetJSFunction method for client side validation.
 * 
 * @author caiusv
 */
public abstract class AValidator {
	
	/** error message associated with this validator */
	public String m_sErrorMessage;
	
	/**
	 * Returns the error message
	 * 
	 * @return the m_sErrorMessage
	 */
	public String GetErrorMessage() {
		return m_sErrorMessage;
	}
	
	/**
	 * Sets the error message
	 * 
	 * @param errorMessage the error message
	 */
	public void SetErrorMessage(String errorMessage) {
		m_sErrorMessage = errorMessage;
	}
}
