package com.plumtree.uiinfrastructure.pagecontrols.framework;

/**
 * Differnt products may want to manage version numbers for their JS components
 * in different ways. This interface allows them to manager JS component
 * versioning themselves, without making the page-controls framework dependent
 * on any particular system of JS component version management. Note: if you
 * are confused about JS Components and versioning of these, please consult
 * the documentation for the JSRegistry project.
 *
 * @author JohnO
 */
public interface IJSComponentVersionMgr
{
	/**
	 * Given a JS Component name like "jsdatepicker", this method will return a
	 * version number (like 74565). If no version number can be found, it
	 * should return -1.
	 *
	 * @param _strJSComponentName The name of the component for which one wants
	 * 		  the version number.
	 *
	 * @return
	 */

	// TODO: Make sure that clients are returning -1 if not found...
	public int GetJSComponentVersionNumber(String _strJSComponentName);
}

