package com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols;

import com.plumtree.openlog.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.pagecontrols.framework.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CaiusV
 */
public class HTMLHidden extends AHTMLComponent implements IPageControl
{

	private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
															 "com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols.HTMLHidden");

	private static final String STR_HTML_INPUT_BASE_NAME = "in_hi_pc";
	
	public static final String STR_MVC_CLASS_NAME = "HTMLHidden";

	/**
	 * Creates a new HTMLHidden object
	 *
	 */
	public HTMLHidden()
	{	
	}
	
    /**
     * JF- Initializes a new AHTMLComponent object.
     *
     * @param _ptComponentMgr The component manager for this component.
     * @param _strUniqueInstanceID The unique ID for this component.
     */
    public void Init(PageMgr _ptPageMgr, String _strUniqueInstanceID)
    {
        super.Init(_ptPageMgr, _strUniqueInstanceID);
        
    }
	
	/**
	 * Returns the base name of this HTML Component.
	 *
	 * @return String
	 */
	protected String GetHTMLComponentBaseName()
	{
		return STR_HTML_INPUT_BASE_NAME;
	}

	/**
	 * Returns the HTML for this component.
	 *
	 * @return
	 */
	public HTMLElementCollection GetComponentHTML()
	{
		HTMLElementCollection retValue = new HTMLElementCollection();
		HTMLInput htmlHidden = new HTMLInput(HTMLInputTypes.HIDDEN_TYPE, GetHTMLComponentName(), "");
		htmlHidden.SetValue(GetHTMLComponentValue());
		retValue.AddInnerHTMLElement(htmlHidden);		
		return retValue;
	}
	
	/**
	 * This method is used by the ASManager to return new instances of managed
	 * objects.
	 *
	 * @return A new instance of the managed class (i.e. return new Foo();)
	 */
	public Object Create(){
		return new HTMLHidden();
	}
	
	/**
	 * Return the name of the MVC object.
	 *
	 * @return the name of the object.
	 */
	public String GetName(){
		return STR_MVC_CLASS_NAME;
	}
}
