package com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols;

import com.plumtree.openlog.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.pagecontrols.framework.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * HTMLPasswordBox page control handles display and values of a password box.
 * 
 * @author CaiusV
 */
public class HTMLPasswordBox extends AHTMLComponent implements IPageControl
{
	/** for logging */
	private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent("UI_Infrastructure"),
				"com.plumtree.uiinfrastructure.pagecontrols.htmlpagecontrols.HTMLPasswordBox");

	/** base name constant */
	private static final String STR_HTML_INPUT_BASE_NAME = "in_pw_pc";
	
	/** class name constant */
	public static final String STR_MVC_CLASS_NAME = "HTMLPasswordBox";
	
	/** the HTMLInput object this wraps */
	public HTMLInput m_ptHTMLInput;

    /**
     * JF- Initializes a new AHTMLComponent object.
     *
     * @param _ptComponentMgr The component manager for this component.
     * @param _strUniqueInstanceID The unique ID for this component.
     */
    public void Init(PageMgr _ptPageMgr, String _strUniqueInstanceID)
    {
    	super.Init(_ptPageMgr, _strUniqueInstanceID);
		m_ptHTMLInput = new HTMLInput(HTMLInputTypes.PASSWORD_TYPE, GetHTMLComponentName(), "");
    }
	/**
	 * Default constructor. Creates a new HTMLPasswordBox object.
	 */
	public HTMLPasswordBox()
	{	
	}
	
	/**
	 * Returns the base name of this HTML Component.
	 *
	 * @return String
	 */
	protected String GetHTMLComponentBaseName()
	{
		return STR_HTML_INPUT_BASE_NAME;
	}

	/**
	 * Returns the HTML for this component.
	 *
	 * @return
	 */
	public HTMLElementCollection GetComponentHTML()
	{
		HTMLElementCollection retValue = new HTMLElementCollection();
		retValue.AddInnerHTMLElement(m_ptHTMLInput);
		return retValue;
	}
	
	/**
	 * This method is used by the ASManager to return new instances of managed
	 * objects.
	 *
	 * @return A new instance of the managed class (i.e. return new Foo();)
	 */
	public Object Create()
	{
		return new HTMLPasswordBox();
	}
	
	/**
	 * Return the name of the MVC object.
	 *
	 * @return the name of the object.
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
