package com.plumtree.uiinfrastructure.pagination;


/**
 * @author CraigS
 *
 *  General interface for pagination.
 */
public interface IPagination
{
	/**
	 *  Go to another page.
	 *  @param sortOrder        Sort order in which firstItemOnPage should be interpreted
	 *  @param firstItemOnPage  First item to appear on page (1-based)
	 *  @param pageSize         Desired number of items on page
	 *  @param additionalInfo   Additional application-specific info, if needed
	 */
	public void GoToPage(String sortOrder, int firstItemOnPage, int pageSize,
		Object additionalInfo);
}

