package com.plumtree.uiinfrastructure.tips;

import com.plumtree.uiinfrastructure.editor.*;

// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.openfoundation.util.*;

/**
 *
 * This control provides control functionality for views and models
 *     responsible for displaying error messages.
 *
 * @author BenG
 */
public class TipsControl extends EditorHelperRepostControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent("UI_Infrastructure"),
		"com.plumtree.uiinfrastructure.tips.TipsControl");


	public static final String STR_MVC_CLASS_NAME = "TipsControl";


	public static final String PARAM_CLOSE = "in_hi_close";

	//	todo: remove HACK: silly number to avoid conflict


	public final static int POSTTOSELF_ACTION_TOGGLE_TIP = 7555;
	protected TipsModel m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TipsControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Calls the method associated to the repost action.
	 * Editors using this framework need to call that method from
	 * the PerformRepostAction method of the main RepostControl.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		
			log.Debug("PerformRepostAction()");
		

		if (_nAction == POSTTOSELF_ACTION_TOGGLE_TIP)
		{
			this.PerformToggleTipAction();
		}
	}



	/**
	 * Performs repost actions in Read-Only mode.
	 *
	 * @param _nAction
	 */
	protected void PerformReadOnlyAction(int _nAction)
	{
		// JF- Implement this method if you need to execute some
		// code on repost when the Editor is Read-Only.


		if (_nAction == POSTTOSELF_ACTION_TOGGLE_TIP)
		{
			this.PerformToggleTipAction();
		}
	}


	/**
	 */
	public void PerformToggleTipAction()
	{
		TipsModel tm = (TipsModel) super.m_asOwner.GetModel(TipsModel.STR_MVC_CLASS_NAME);

		boolean bOld = tm.GetDoDisplayTipsBox();

		tm.SetDoDisplayTipsBox(!bOld);
	}
}

