package com.plumtree.uiinfrastructure.tree;

import com.plumtree.xpshared.htmlelements.*;

/**
 * @author Don Hayler
 */
public interface ITreeIterator
{
	/**
	 *
	 *
	 * @return
	 */
	public int GetCurrentClassID();

	/**
	 *
	 *
	 * @return
	 */
	public boolean GetCurrentForceSelectable();

	/**
	 * This method returns an image for the current node.  This will
	 * automatically handle open and closed images.  The alt tag
	 * should already be set on this image.
	 *
	 * @return HTMLImg the current image element
	 */
	public HTMLImg GetCurrentImage();

	/**
	 * Returns the encoded and truncated name.
	 *
	 * @return
	 */
	public String GetCurrentEncodedName();

	/**
	 *
	 *
	 * @return
	 */
	public int GetCurrentObjectID();

	/**
	 *
	 *
	 * @return
	 */
	public boolean GetCurrentSelected();

	/**
	 *
	 *
	 * @return
	 */
	public int GetCurrentTreeNodeID();
}

