package com.plumtree.uiinfrastructure.tree;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This page displays the main section of the tree, including the
 * sub-title bar.
 * 
 * @author Don Hayler
 */
public class TreeDP extends AFormDP
{
	/** name of the tree DP */
	public static final String STR_MVC_CLASS_NAME = "Tree";

	/** Strings that don't need localization */
	/** storage name for tree bar view */
	public static final String TREE_BAR_STORAGE_NAME = "TreeBar";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		// This page is displayed in a frame, so doesn't need a title.
		return "";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Add the tree bar named anchor so we can link back to here.
		HTMLAnchor myAnchor= new HTMLAnchor("");
		myAnchor.SetName(ATreeAS.TREE_BAR_ANCHOR);
		result.AddInnerHTMLElement(myAnchor);

		result.AddInnerHTMLElement(m_asOwner.GetView(TREE_BAR_STORAGE_NAME)
			.Display());
		result.AddInnerHTMLElement(m_asOwner.GetView(
				TreeView.STR_MVC_CLASS_NAME).Display());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 *
	 * This is a helper method that all classes that inherit from AFormDP can override
	 * if they like.  The method provides a hook into the head so that DP's can add javascript.
	 * Simply override and return and HTMLScript.  Also, it is best to return the results of the
	 * DisplayJavaScript functions from the appropriate views.
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();
		scripts.AddInnerHTMLElement(m_asOwner.GetView(
				TreeView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return scripts;
	}
}

