package com.plumtree.uiinfrastructure.tree;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * The main frameset for the tree.  Contains the top frame with buttons,
 * bottom frame with selected items, and scrolling body frame for the tree.
 * 
 * @author Don Hayler
 */
public class TreeFrameDP extends FrameSetDP
{
	/** Frameset object name */
	public static final String STR_MVC_CLASS_NAME = "TreeFrame";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBody()
	 */
	public boolean GetFrameScrollBody()
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()
	 */
	public String GetFrameSetAttributes()
	{
		return "35px,50%";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()
	 */
	public String GetFrameSetTitle()
	{
		ITreeModelRO myModel = (ITreeModelRO) m_asOwner.GetModel(ATreeAS.TREEMODEL);

		return myModel.GetTitle();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{
		// Display the tree itself
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(TreeDP.STR_MVC_CLASS_NAME);

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		// Display the form header
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(TreeHeaderDP.STR_MVC_CLASS_NAME);

		return result;
	}
}

