package com.plumtree.uiinfrastructure.tree;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.openfoundation.util.*;

/**
 * The tree repost control handles the common actions in the tree,
 * such as expanding nodes.
 *
 * @author Don Hayler
 */
public class TreeRepostControl extends RepostControl
{
	public static final String STR_MVC_CLASS_NAME = "TreeRepost";

	public static final String m_strEXPAND = "in_hi_Expand";

	public static final String m_strFOLDERID = "in_hi_FolderID";

	public final static int POSTTOSELF_EXPAND = 10;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = super.CheckActionSecurityAndExecute(arguments);

		if (m_nAction == POSTTOSELF_ACTION_CANCEL)
		{
			// If canceling, we want to use the normal close pop up, not the
			// special treeDP close popup with extra javascript
			result = new Redirect();
			result.SetLinkGetCachedSpace(m_asOwner);
			result.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
		}

		if (result == null)
		{
			result = new Redirect();
			result.SetLinkGetCachedSpace(m_asOwner);
			result.SetDisplayPage(TreeDP.STR_MVC_CLASS_NAME);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TreeRepostControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call  the associated method for each
	 * action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		//***CHANGE_HERE*** if you don't have any repost action, delete the switch statement.
		switch (_nAction)
		{
		//***CHANGE_HERE*** Create a new case for each of your action.
		case POSTTOSELF_EXPAND:

			// Expand or contract a node in the tree
			boolean bExpand = XPConvert.ToBoolean(((String[]) m_htFormData.GetElement(
						m_strEXPAND))[0]);
			int nID		 = XPConvert.ToInteger(((String[]) m_htFormData.GetElement(
						m_strFOLDERID))[0]);
			((ITreeModel) m_model).ExpandNode(bExpand, nID);

			break;
		}
	}
}

