package com.plumtree.xpshared.htmlconstructs;

/**
 *
 * @author beng  This class is used to provide an identifier for a specific
 *         html element  within a factory produced construct. <br>
 *         <br>
 *         For example, all banner constructs have an internal html element
 *         that contains the title of the banner.  This html element might be
 *         of type HTMLSpan, HTMLTableCell, etc, but it will always have the
 *         same ElementName. <br><br>
 */
public class ElementName
{
    String sName;

    //   package-private

    /**
     * Creates a new ElementName object.
     *
     * @param s String name of this ElementName.
     */
    public ElementName(String s)
    {
        sName = s;
    }

    /**
     * Get the String name of this ElementName
     *
     * @return String name
     */
    public String GetName()
    {
        return sName;
    }
}
