/*
 * Created on May 25, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.plumtree.xpshared.htmlelements;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;

/**
 * @author sudhas
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class HTMLBlockQuote extends HTMLElement {

	static int iNextID = 0;

	private static final byte[] BEGIN_TAG = HTMLElement.ToByteArray("<blockquote");
	private static final byte[] CITE_ATTR = HTMLElement.ToByteArray(" cite=\"");
	private static final byte[] END_TAG = HTMLElement.ToByteArray("</blockquote>");
	
	private String sCite;
	/* (non-Javadoc)
	 * @see com.plumtree.xpshared.htmlelements.HTMLElement#GetNextID()
	 */
	 
	 
	public HTMLBlockQuote()
	{
		sCite = null;
	}
	
	
	String GetNextID() 
	{
		String s = "blockquote" + iNextID;
		iNextID++;

		return s;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.xpshared.htmlelements.HTMLElement#AppendBeginningOfOpeningTag(boolean, com.plumtree.openfoundation.util.XPStringBuilder, com.plumtree.openfoundation.web.IXPResponse)
	 */
	protected void AppendBeginningOfOpeningTag(boolean bFormat, XPStringBuilder sb, IXPResponse response) 
	{
		WriteNugget(BEGIN_TAG, sb, response);
		
		if (sCite != null)
		{
			WriteNugget(CITE_ATTR, sb, response);
			WriteNugget(sCite, sb, response);
			WriteNugget(QUOTE, sb, response);
		}
	}

	/* (non-Javadoc)
	 * @see com.plumtree.xpshared.htmlelements.HTMLElement#AppendClosingTag(boolean, com.plumtree.openfoundation.util.XPStringBuilder, com.plumtree.openfoundation.web.IXPResponse)
	 */
	protected void AppendClosingTag(boolean bFormat, XPStringBuilder sb, IXPResponse response) 
	{	
		WriteNugget(END_TAG, sb, response);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.xpshared.htmlelements.HTMLElement#ProvidesClosingTag()
	 */
	protected boolean ProvidesClosingTag() 
	{
		return true;
	}
	
	/**
	 *	Call this method to get the Cite attribute string.
	 * 	@return
	 */
   	public String GetCite()
   	{
	   return sCite;
   	}
   	
   	public void SetCite(String sInputCite)
   	{
   		sCite = sInputCite;
   	}
	   
	   

}

