package com.plumtree.xpshared.htmlelements;

/**
 * Title:        HTMLListTypes Description: Copyright:    Copyright (c) 2002
 * Company:      Plumtree Software
 *
 * @version 1.0
 * @author Chris Bucchere
 */
public class HTMLListTypes
{
    public static final int GLOSSARY_LIST = 0;
    public static final int ORDERED_LIST = 1;
    public static final int UNORDERED_LIST = 2;
    public static final int LINEBREAKS_ONLY = 3;

    /**
     *
     * @param listType
     *
     * @return
     */
    public static String GetListClosingTag(int listType)
    {
        switch (listType)
        {
        case HTMLListTypes.GLOSSARY_LIST:
            return "</dl>";

        case HTMLListTypes.ORDERED_LIST:
            return "</ol>";

        case HTMLListTypes.UNORDERED_LIST:
            return "</ul>";

        case HTMLListTypes.LINEBREAKS_ONLY:
            return "";

        default:
            return "";
        }
    }

    /**
     *
     *
     * @param listType
     * @param isDefinition
     *
     * @return
     */
    public static String GetListItemClosingTag(int listType, boolean isDefinition)
    {
        switch (listType)
        {
        case HTMLListTypes.GLOSSARY_LIST:

            if (isDefinition)
            {
                return "</dd>";
            }
            else
            {
                return "</dt>";
            }

        case HTMLListTypes.ORDERED_LIST:
            return "</li>";

        case HTMLListTypes.UNORDERED_LIST:
            return "</li>";

        case HTMLListTypes.LINEBREAKS_ONLY:
            return "<br />";

        default:
            return "";
        }
    }

    /**
     *
     *
     * @param listType
     * @param isDefinition
     *
     * @return
     */
    public static String GetListItemOpeningTag(int listType, boolean isDefinition)
    {
        switch (listType)
        {
        case HTMLListTypes.GLOSSARY_LIST:

            if (isDefinition)
            {
                return "<dd ";
            }
            else
            {
                return "<dt ";
            }

        case HTMLListTypes.ORDERED_LIST:
            return "<li ";

        case HTMLListTypes.UNORDERED_LIST:
            return "<li ";

        case HTMLListTypes.LINEBREAKS_ONLY:
            return "";

        default:
            return "";
        }
    }

    /**
     *
     *
     * @param listType
     *
     * @return
     */
    public static String GetListOpeningTag(int listType)
    {
        switch (listType)
        {
        case HTMLListTypes.GLOSSARY_LIST:
            return "<dl ";

        case HTMLListTypes.ORDERED_LIST:
            return "<ol ";

        case HTMLListTypes.UNORDERED_LIST:
            return "<ul ";

        case HTMLListTypes.LINEBREAKS_ONLY:
            return "";

        default:
            return "";
        }
    }
}
